#include "..\include\internls\evrythng.h"
#pragma hdrstop

#include  "..\include\swintrac\swintrac.h"
#include  "..\include\datavisa\datavisa.h"

#include  "..\include\detecuse\detecuse.h"

#include  "..\include\detecuse\am9513a.h"
#include  "..\include\detecuse\m_devhw.h"



//JP
// dfkisl.h wird hier nicht mehr benoetigt
//#include "dfkisl.h"

//JP
// Dieser Abschnitt wird demnaechst eliminiert.
extern "C" WINAPI __0040h( void );
#ifndef _WIN32
extern "C" LPSTR pTime = ( LPSTR ) MK_FP( FP_OFF( __0040h ),0x006c );
#else
extern "C" LPSTR pTime = "";
#endif

HINSTANCE hModuleInstance;
static char dlVersion[ ]  = "V 1.52 ("__DATE__")";

const int nMaxDeviceAllowed = 3;
static int bModulLoaded = FALSE;
extern LPDList lpDList;
static HINSTANCE hMotorDll;

//static int retval;
int Failure;
extern LPDList lpDList;

//JP
// Abschnitt wird nicht mehr benoetigt.
//******** SCS *****************************************************************
//int FakeDevice = 0;
//int FakeData;
//static int rdd,rcc;
//static HWND hControlWnd;
//static float Intensity_SCS;
//static DWORD expcounts;
//static UINT nEvent;
//static int Cycle;

//********* Code ***************************************************************

//#pragma argused
#ifndef _WIN32
int WINAPI LibMain( HINSTANCE inst,WORD,WORD,LPSTR )
{
  bModulLoaded = FALSE;
  hModuleInstance = inst;
  lpDList = ( LPDList ) new TDList( nMaxDeviceAllowed,inst );
  hMotorDll = GetModuleHandle( "motors.dll" );
  return -1;
};

int CALLBACK WEP( int )
{
  bModulLoaded = FALSE;
  return 1;
};
#else
    BOOL WINAPI DllMain(HINSTANCE hModule, DWORD dwFunction, LPVOID  )
    {
	    switch (dwFunction)
	    {
		case DLL_PROCESS_ATTACH:
    	        bModulLoaded = FALSE;
	        hModuleInstance = hModule;
	        lpDList = ( LPDList ) new TDList( nMaxDeviceAllowed, hModule );
	        hMotorDll = GetModuleHandle( "motors.dll" );
		break;
	    };
	    return TRUE;
    }
#endif

LPCSTR __declspec(dllexport) WINAPI dlGetVersion( void )
{
  return ( LPCSTR ) dlVersion;
};

HINSTANCE __declspec(dllexport) WINAPI dlGetInstance( void )
{
  return hModuleInstance;
};

BOOL __declspec(dllexport) WINAPI InitializeCountersDLL( void )
{
  bModulLoaded = TRUE;
  return lpDList->InitializeModule( );
};

LPDList __declspec(dllexport) WINAPI GetCounterListPtr( void )
{
  if( !bModulLoaded )  return NULL;
  return ( LPDList ) lpDList;
};

BOOL __declspec(dllexport) WINAPI dlSetDevice( int device )
{
  if( lpDList->SetDevice( device ) )
	 return TRUE;
  lpDList->SetDevice( 0 );
  return FALSE;
};

int __declspec(dllexport) WINAPI dMeasureStart( void )
{
  return lpDList->DP( ) ->MeasureStart( );
};

int __declspec(dllexport) WINAPI dMeasureStop( void )
{
  return lpDList->DP( ) ->MeasureStop( );
};

BOOL __declspec(dllexport) WINAPI dSetExposureValues( float time,DWORD counts,float fl )
{
  return lpDList->DP( ) ->SetExposureValues( time,counts,fl );
};

BOOL __declspec(dllexport) WINAPI dGetExposureValues( float& time,DWORD& counts,float& fl )
{
  lpDList->DP( ) ->GetExposureValues( time,counts,fl );
  return TRUE;
};

int __declspec(dllexport) WINAPI dlGetDevice( void )
{
  return lpDList->GetDevice( );
};


int TDList::GetIdByName( TDeviceType at )
{
  int id = -1;

  switch( at )
  {
	 case CounterDevice: id = lpDList->MD_Counter; break;
	 case MonitorDevice: id = lpDList->MD_Monitor; break;
	 case PsdDevice: id = lpDList->MD_Psd; break;
	 case GenericDevice: id = lpDList->MD_Generic; break;
	 case EncoderDevice: id = lpDList->MD_Encoder; break;
  }
  return id;
};

int __declspec(dllexport) WINAPI dlGetIdByName( TDeviceType at )
{
  return lpDList->GetIdByName( at );
};

TDeviceType __declspec(dllexport) WINAPI dlParsingDevice( LPSTR devicename )
{
  return lpDList->ParsingAxis( devicename );
};

BOOL TDList::IsDeviceValid( TDeviceType type )
{
  switch( type )
  {
	 case CounterDevice: return ( lpDList->MD_Counter > -1 );
	 case PsdDevice: return ( lpDList->MD_Psd > -1 );
	 case MonitorDevice: return ( lpDList->MD_Monitor > -1 );
	 case EncoderDevice: return ( lpDList->MD_Encoder > -1 );
	 default: return FALSE;
  }
};

BOOL __declspec(dllexport) WINAPI dlIsDeviceValid( TDeviceType type )
{
  return lpDList->IsDeviceValid( type );
};
//******************************************************************************
TDeviceType TDList::ParsingAxis( LPSTR devicename )
{
  if(  !strcmp( devicename,"Counter" )  || !strcmp( devicename,"Zhler" ) )
	 return CounterDevice;
  if(  !strcmp( devicename,"Monitor" ) )
	 return MonitorDevice;
  if(  !strcmp( devicename,"Psd" )  || !strcmp( devicename,"PSD" ) )
	 return PsdDevice;
  if(  !strcmp( devicename,"Encoder" ) )
	 return EncoderDevice;
  return ( TDeviceType ) GenericDevice;
};

void TDList::SetParametersDlg( void )
{
  TModalDlg* dlg;

  dlg = ( TCommonDevParam * ) new TCommonDevParam( lpDList->GetDevice( ) );
  dlg->ExecuteDialog( GetFrameHandle( ) );
  delete dlg;
};

//JP
// Abschnitt wird nicht mehr benoetigt.
/*
void __declspec(dllexport) CALLBACK  InquireIntensity_SCS( UINT nEvent,UINT,DWORD,DWORD,DWORD )
{
  double time = 1;
  DWORD counts = 1000;

  timeKillEvent( nEvent );
//retval = getinf( 11,rdd,rcc,&time,&counts );
  retval = TRadicon::radiconHW->GetValues( TRadiconHW::interim, time, counts );

  if( ( retval != -4 )  && ( retval != 0 ) )
	 return;
//retval = begwrk( 5,rdd,rcc );
  retval = TRadicon::radiconHW->SetOperationMode( TRadiconHW::stopDevice );
  if( time != 0.0 )
	 lpDList->DP( ) ->fIntensity = ( expcounts-counts )  / time;
  else
	 lpDList->DP( ) ->fIntensity = 0.0;
  if( hControlWnd != NULL )
	 // Daten-Empfnger benachrichtigen
	 PostMessage( hControlWnd,WM_COMMAND,cm_CounterSet,77 );
};


float __declspec(dllexport) WINAPI  GetIntensity_SCS( void )
{
  return Intensity_SCS;
};
*/
//******** TDC *****************************************************************
/*
static float Intensity_TDC;

void __declspec(dllexport) CALLBACK InquireIntensity_TDC( UINT nEvent,UINT,DWORD,DWORD,DWORD )
{
  double angx,angy=0,angz=0;

  if( !Cycle-- )
  {
	 timeKillEvent( nEvent );
	 PostMessage( hControlWnd,WM_COMMAND,cm_SteeringReady,77 );
	 return;
  }
  Intensity_TDC = 0.0;

  if( mGetDistance( angx ) )
  {
	 angx = angx * angx / 11.3;
	 Intensity_TDC = 1/( 1 + 1.8 * pow( angx,2 )  + 0.001 * pow( angy,2 )  + \
								0.001 * pow( angz,2 ) );
	 Intensity_TDC *= 32000;
	 Intensity_TDC += ( rand( )  % 80 )  + 270;
  }
  // Daten-Empfnger benachrichtigen
  PostMessage( hControlWnd,WM_COMMAND,cm_CounterSet,77 );
};

BOOL __declspec(dllexport) WINAPI InitializeTDC_Event( float time,HWND contolwnd )
{
  UINT tic = ( UINT ) ( time*1000 );

  hControlWnd = contolwnd;
  Cycle = 100;
  timeBeginPeriod( 1 );
  if( tic < 1 )  tic = 1;
  nEvent = timeSetEvent( tic,1,( LPTIMECALLBACK ) InquireIntensity_TDC,0,TIME_PERIODIC );
  return TRUE;
};

float __declspec(dllexport) WINAPI GetIntensity_TDC( void )
{
  return Intensity_TDC;
};
*/
//******** A913 ****************************************************************
/*
static float Intensity_A913;

void __declspec(dllexport) CALLBACK InquireIntensity_A913( UINT nEvent,UINT,DWORD,DWORD,DWORD )
{
  //! double time = 1;
  //! DWORD counts = 1000;

  timeKillEvent( nEvent );
  Intensity_A913 = 1.0;
  if( hControlWnd != NULL )
	 // Daten-Empfnger benachrichtigen
	 PostMessage( hControlWnd,WM_COMMAND,cm_CounterSet,77 );
};

float __declspec(dllexport) WINAPI GetIntensity_A913( void )
{
  return Intensity_A913;
};
*/
//******************************************************************************
// __LastLine__

