#include "..\include\winresrc\rc_def.h"
#include "..\include\internls\evrythng.h"
#pragma hdrstop

// m_arscan.cpp
// (C) 1993,95 by Heiko Damerow MPG AG "Roentgenbeugung"
// (C) 1996 by Heiko Damerow DLR
// modul for execution of area scan's with psd and sld

//! kommentiert von Diffr.gruppe (S. Berndt, J. Ullrich)

//! Kommentierung und Aenderungen B. Buss, 2000/2001, HUB IfI
//! speziell cm_dataaquisition, getthetaoffset(), setranges() ...

#include <direct.h>
#include  "..\include\swintrac\swintrac.h"
#include  "..\include\datavisa\datavisa.h"
#include  "..\include\detecuse\detecuse.h"
#include  "..\include\workflow\workflow.h"
#include  "..\include\motrstrg\motrstrg.h"

#include "..\include\difrkmty\difrkmty.h"

#include "..\include\difrkmty\m_arscan.h"
#include "..\include\difrkmty\m_dlgdif.h"


extern TMain Main;
extern LPDList lpDList;
extern LPDataBase lpDBase;
extern TSteering Steering;
extern TModelessDlg* TheModeless;

//! Fehlermeldungen
//! FIX Fehler 73
#ifdef GermanVersion
char szMsgFailure[] = "Fehler";
char szMessage[] = "Meldung";
char szMsgLine001[] = "Messung! Omega: %s 2Theta: %s Intensitt: %%.3f";
char szMsgLine002[] = "Der Detektor %s ist als Monitor gekennzeichnet!";
char szMsgLine003[] =
	 "Starte Omega/2Theta-Scan(PSD)\n mit Omega von %s bis %s ?";
char szMsgLine004[] =
	 "Starte Omega/2Theta-Scan(SLD)\n mit Omega von %s bis %s ?";
char szMsgLine005[] = "Starte OmegaScan(PSD)\n mit Omega von %s bis %s ?";
char szMsgLine006[] = "Theta ist relativ!\n Relativen Winkel auslassen?";
char szMsgLine007[] = "Omega ist relativ!\n Relativen Winkel auslassen ?";
char szMsgLine008[] = "Scan-Nummer bersteigt %d !";
char szMsgLine009[] = "Messung! Omega:%s";
char szMsgLine010[] = "%s P(%s<>%%.1f) Integral Intensitt: %%.1f > %%d";
char szMsgLine011[] = "%d Scan's wurden gemessen";
char szMsgLine012[] = "Die Messung wurde abgeschlossen\r\n und gespeichert";
char szMsgLine013[] = "Messung wurde unterbrochen !";
char szMsgLine014[] = "Inkorrekter Header.";
char szMsgLine016[] = "Kein Detektor als Monitor spezifiziert!";
//! neu eingefuehrt
char szMsgLine017[] = "Bitte erst Daueranzeige deaktivieren!";
char szMsgLine018[] = "Die Messung wurde abgeschlossen";
char szMsgLine019[] = "Die Messung wurde abgeschlossen.\r\nFehler beim Speichern!";
char szMsgLine020[] = "Es ist ein Fehler aufgetreten. %d";
char szMsgLine021[] = "Hardware ist nicht vollstndig verfgbar !";
char szMsgLine023[] = "Kein gueltiger Darstellungstyp !";
char szMsgLine024[] = "Kein Psd verfgbar .";
char szMsgLine025[] = "Standard-Scan nur mit PSD";
char szMsgLine026[] = "Anzeige Psd-Spektrum ...";
char szMsgLine027[] = "Bitte die Darstellung >Curve< waehlen. ";
char szMsgLine028[] = "Scan %d von %d schreiben.";
char szMsgLine029[] = "Scan %d schreiben.";
char szMsgLine030[] = "Reportdatei defekt";
char szMsgLine031[] = "keine Datenbasis vorhanden";
#else
char szMsgFailure[] = "Failure";
char szMessage[] = "Message";
char szMsgLine001[] = "Measurement! Omega: %s 2Theta: %s Intensity: %%.3f";
char szMsgLine002[] = "The Device %s is tagged as Monitor !";
char szMsgLine003[] =
	 "Starting Omega/2Theta-Scan(PSD)\nwith Omega from %s to %s ?";
char szMsgLine004[] =
	 "Starting Omega/2Theta-Scan(SLD)\nwith Omega from %s to %s ?";
char szMsgLine005[] = "Starting OmegaScan(PSD)\nwith Omega from %s to %s ?";
char szMsgLine006[] = "Theta is relative!\nSkip relative Angle ?";
char szMsgLine007[] = "Omega is relative !\nSkip relative Angle ?";
char szMsgLine008[] = "Scan-Number exceeds %d !";
char szMsgLine009[] = "Measurement! Omega:%s";
char szMsgLine010[] = "%s P(%s<>%%.1f) Integral Intensity: %%.1f > %%d";
char szMsgLine011[] = "%d Scan's has been measured";
char szMsgLine012[] = "The Measurement is completed\r\nand the data were saved.";
char szMsgLine013[] = "Measurement has been interrupted !";
char szMsgLine014[] = "Incorrect Header.";
char szMsgLine016[] = "No Device as Monitor specified!";
//! neu eingefuehrt
char szMsgLine017[] = "Please deactivate Continuousdisplay first";
char szMsgLine018[] = "The Measurement is completed.";
char szMsgLine019[] = "The Measurement is completed.\r\nFailure on saving data.";
char szMsgLine020[] = "There is a Failure appeared. %d";
char szMsgLine021[] = "Hardware is not complete available !";
char szMsgLine023[] = "No valid Display Type !";
char szMsgLine024[] = "No psd available .";
char szMsgLine025[] = "Standard-Scan with PSD only";
char szMsgLine026[] = "Display psd-spectrum ...";
char szMsgLine027[] = "Please choose the Display-type >Curve< .";
char szMsgLine028[] = "Save Scan %d of %d .";
char szMsgLine029[] = "Save Scan %d .";
char szMsgLine030[] = "damaged Reportfile";
char szMsgLine031[] = "no DataBase existing";

#endif

// variables for data aquisition
typedef struct
{
	 double dX, dY, dOmega, dTheta;
	 float fDelta, fIntensity;
}
TData;

static int nLinePoints = 100;
static int nEnvironment = 0;
static char DataFile[ 40 ];
float PointX[ 2 ], PointY[ 2 ];
int nMouseAction = 0;
static TData* lpData;
static BOOL bAquisitionActive = FALSE;
static int nSetMarker = 0;
static BOOL bSetDXZero = FALSE;
static BOOL bSetDYZero = FALSE;
static BOOL bSetRLSave = FALSE;

static int nFirstReadColumn = 0;
static int nLastReadColumn = 0;

static float fPsdRange;
static char szODF[ 7 ], szOWF[ 7 ], szTDF[ 7 ], szTWF[ 7 ];
static TUnitType eThetaUnitType = Grad;

//! Hilfsvariable zum Zerlegen bzw. Zusammenfassen einer Datenbasis
//! enthaelt Dateinamen
char DismantleFile[ 40 ];

// #define DEBUG
// #define OldVersion
// #ifdef Peak_and_Cross


//*****************************************************************************
//********** Klasse TAreaScan **************************************
//*****************************************************************************

//! einlesen der Ini-daten zu [AreaScan] und
//! setzen von default-werten fuer AreaScan
//! wird nur durch TAreaScan-konstruktor aufgerufen
TAreaScanParameters::TAreaScanParameters()
{
	 char Ident[] = "AreaScan";
	 char buf[ MaxString ];
	 double dDistance;
	 int nOldId = mlGetAxis();

	 //! setzen von Defaultwerten
	 strcpy( ::DataFile, "*.dtn" );
	 eScanType = Omega2ThetaScan;
	 SetDevice( dlGetIdByName( PsdDevice ) );

	 //! test ob Monitordetektor angeschlossen ist wenn ja dann monitor setzen
	 //! ansonsten monitor auf akt. Detektor setzen
	  if ( dlIsDeviceValid( MonitorDevice ) )
		  Monitor = lpDList->DP( dlGetIdByName( MonitorDevice ) );
	 else
		  Monitor = lpDList->DP();
	 bMonitorUsed=FALSE;	 //! neu info
	 nAddedChannels = Device->GetAddedChannels();
	 bThetaAddsPsd = TRUE;
	 fMaxTime = 6.0;
	 dwMaxCounts = 30000l;
	 fFailure = 0.02;
	 eSaveFormat = StandardFile;
	 bSaveOnReady = FALSE;
	 dMoveRelation = 2.0;
	 dThetaOffset = 0.0;
	 nOmega = mlGetIdByName( Omega );
	 nTheta = mlGetIdByName( Theta );
	 bAbsorberUsed = FALSE;
	 //! Werte fuer Datenbasis-Zusammensetzung
	 MaxFiles=0;
	 strcpy( FirstFile, "Kurve whlen!" );
	 strcpy( LastFile, "testxxxx.crv" );
	 //! Omegamotor und zugehoerige Werte setzen
	 mlSetAxis( nOmega );
	 dOmegaWidth = mGetValue( Width );
	 if ( !mGetDistance( dDistance ) )
	 {
		  dOmegaMin = 40.0;
		  dOmegaMax = 46.0;
	 }
	 else
	 {
		  dOmegaMin = dDistance;
		  dOmegaMax = dDistance + 4.0;
	 }
	 //! Thetamotor und zughoerige Werte setzen
	 mlSetAxis( nTheta );
	 dThetaWidth = dMoveRelation * dOmegaWidth;
	  dThetaMin = dMoveRelation * dOmegaMin;
	 dThetaMax = dMoveRelation * dOmegaMax;
	 dThetaWindow = dThetaMax - dThetaMin;
   d2ThetaStart = dThetaMin;

    //! einlesen der Daten aus dem [AreaScan]-Abschnitt des Ini-Files
	 GetPrivateProfileString( Ident, "ExposureTime", "1.0", buf, MaxString,
                             GetCFile() );
    if ( CreateDefaults() )
		  WritePrivateProfileString( Ident, "ExposureTime", buf, GetCFile() );
    fMaxTime = atof( buf );
    //! FIX Fehler 37
    bSaveOnReady = GetPrivateProfileInt(Ident, "SaveOnReady", 1, GetCFile() );
    //! FIX Fehler 56
    eNotifyValue = IntegralIntensity;
	 //! auskommentiert von s.berndt j.ullrich
	 //! mit physikern noch zu klaeren, ob ganz entfernen oder aenderungswunsch
    /* GetPrivateProfileString( Ident, "Report", "Integral", buf, MaxString,
                             GetCFile() );
    strupr( buf );
    //! festlegen, welche Informationen neben dem Omegawinkel und dem Thetawinkel
    //! als 3. wert im Scanreport gespeichert werden soll
    while ( 1 )
	 {
        eNotifyValue = PeakPosition;
        if ( !strcmp( buf, "MONITOR" ) )
		  {
				eNotifyValue = MonitorIntensity;
            if ( !dlIsDeviceValid( MonitorDevice ) )
            {
					 MessageBox( GetFocus(), szMsgLine016, szMessage, MBINFO );
                break;
            }
            Monitor = lpDList->DP( dlGetIdByName( MonitorDevice ) );
				break;
        }
        if ( !strcmp( buf, "ABSORBER" ) )
		  {
            eNotifyValue = AbsorberPosition;
            break;
        }
        if ( !strcmp( buf, "INTEGRAL" ) )
        {
				eNotifyValue = IntegralIntensity;
				break;
        }
        if ( !strcmp( buf, "TIME" ) )
        {
            eNotifyValue = MeasurementTime;
				break;
        }
		  if ( !strcmp( buf, "PEAK" ) )
        {
            eNotifyValue = PeakPosition;
				break;
		  }
        break;
    }  */
    //! ermittelt Einheit des Thetamotors und Winkelwert eines Kanals + setzt den
    //! Motor , der zu Begin der Funktion gesetzt war
    mlSetAxis( nTheta );
	 eThetaUnitType = mGetUnitType();
	 ::fPsdRange = Device->GetAngleRange( eThetaUnitType );
	 mlSetAxis( nOldId );

	 //! o-t-offset init.
	 dOffsetOmega = dOffsetTheta = 0.0;

   //! psd-offset + Messkanalnr. ini.
   dPsdOffset = 0.0;
   nMeasurementChannel =0;

 	 //! neu akk
   //! standardmaessig nicht akkumuliert darstellen
	 bAccumulatedDisplay = FALSE;


};


//! setzt den Detektor, dessen id-nummer dem Param. id entspricht
//! dabei wird bPsdDevice gesetzt, wenn der Detektor ein Psd ist
void TAreaScanParameters::SetDevice( int id )
{
	 Device = lpDList->DP( id );
	 bPsdDevice = ( Device->GetId() == dlGetIdByName( PsdDevice ) );
};
//#############################################################################

//! registr. des ScanFensters und das ScanFensterMenue erstellen
//! setzen von weiteren Defaultwerten
TAreaScan::TAreaScan( void )
{
	 HMENU hMAdd;

	 bInterrupted = FALSE;
	 bMacroRunning = FALSE;
	 bCalibrationActive = FALSE;
	 bShowPsdContinuous = FALSE;
	 bSaveContinuous = FALSE;
	 bThetaScanCompleted = FALSE;
   //! keine DB-Zusammensetzung
	 bComposeDB = FALSE;
	 LowerBound = 0.5;
	 UpperBound = 800.0;
	 // Registrieren der Kindfenster-Klasse
	 TMDIWindow::RegisterWnd();
	 WindowType = W_PSDWindow;
	 bMeasurementActive = FALSE;
	 //! erstellen der menueeintraege des Areascanfensters
	 TheMenu = CreatePopupMenu();
#ifdef GermanVersion
	 AppendMenu( TheMenu, MF_STRING, cm_SetupAreaScan, "Setup zu&m AreaScan..." );
	 AppendMenu( TheMenu, MF_STRING, cm_ShowCurveParam, "Darstellungs-&Optionen..."
				  );
	 AppendMenu( TheMenu, MF_STRING, cm_InitializeAreaScan, "&AreaScan starten" );
	 AppendMenu( TheMenu, MF_SEPARATOR, 0, NULL );
	 AppendMenu( TheMenu, MF_STRING, cm_ShowPsdP_Data, "&Impuls-Spektrum anzeigen" );
//! fuer Demo entfernt
/*    AppendMenu( TheMenu, MF_STRING, cm_PSDRemoteSyncCtl,
					 "Messung extern synchronisieren.." );*/
	 AppendMenu( TheMenu, MF_STRING, cm_ChooseScan, "Scan ausw&hlen..." );
	 AppendMenu( TheMenu, MF_STRING, cm_DismantleDB, "Datenbasis zerlegen..." );
	 AppendMenu( TheMenu, MF_STRING, cm_ComposeDB, "Datenbasis zusammensetzen..." );
	 hMAdd = CreatePopupMenu();
	 AppendMenu( hMAdd, MF_STRING, cm_FreezeCurve, "&Fixieren" );
	 AppendMenu( hMAdd, MF_STRING, cm_KillSecondCurve, "Ls&chen" );
	 AppendMenu( hMAdd, MF_STRING, cm_SaveSecondCurve, "&Speichern" );
	 AppendMenu( TheMenu, MF_POPUP, ( WORD ) hMAdd, "&Scan" );
	 hMAdd = CreatePopupMenu();
	 AppendMenu( hMAdd, MF_STRING, cm_ShowPsdE_Data, "&Energie-Spektrum anzeigen" );
	 AppendMenu( hMAdd, MF_STRING, cm_SetupPsd, "Ein&stellungen..." );
	 AppendMenu( hMAdd, MF_STRING, cm_CalibratePsd, "&Calibrierung..." );
	 AppendMenu( TheMenu, MF_POPUP, ( WORD ) hMAdd, "&Psd" );
	 AppendMenu( TheMenu, MF_STRING, cm_DataAquisition, "&Datenerhebung..." );
#else
	 AppendMenu( TheMenu, MF_STRING, cm_SetupAreaScan, "Setup &Measurement..." );
	 AppendMenu( TheMenu, MF_STRING, cm_ShowCurveParam, "Visualising &Options..."
				  );
	 AppendMenu( TheMenu, MF_STRING, cm_InitializeAreaScan, "Start &AreaScan" );
	 AppendMenu( TheMenu, MF_SEPARATOR, 0, NULL );
	 AppendMenu( TheMenu, MF_STRING, cm_ShowPsdP_Data, "Show &Impulse-Spectrum" );
//! fuer Demo entfernt
/*
	 AppendMenu( TheMenu, MF_STRING, cm_PSDRemoteSyncCtl,
					 "Measure external synchronized.." );*/
	 AppendMenu( TheMenu, MF_STRING, cm_ChooseScan, "C&hoose Scan..." );
	 AppendMenu( TheMenu, MF_STRING, cm_DismantleDB, "Dismantle Database..." );
	 AppendMenu( TheMenu, MF_STRING, cm_ComposeDB, "Compose Database..." );
	 hMAdd = CreatePopupMenu();
	 AppendMenu( hMAdd, MF_STRING, cm_FreezeCurve, "&Fixing" );
	 AppendMenu( hMAdd, MF_STRING, cm_KillSecondCurve, "&Clear" );
	 AppendMenu( hMAdd, MF_STRING, cm_SaveSecondCurve, "&Save" );
	 AppendMenu( TheMenu, MF_POPUP, ( WORD ) hMAdd, "&Scan" );
	 hMAdd = CreatePopupMenu();
	 AppendMenu( hMAdd, MF_STRING, cm_ShowPsdE_Data, "Show &Energy-Spectrum" );
	 AppendMenu( hMAdd, MF_STRING, cm_SetupPsd, "&Settings..." );
	 AppendMenu( hMAdd, MF_STRING, cm_CalibratePsd, "&Calibrate..." );
	 AppendMenu( TheMenu, MF_POPUP, ( WORD ) hMAdd, "&Psd" );
	 AppendMenu( TheMenu, MF_STRING, cm_DataAquisition, "Inquire &Data..." );
#endif
	 //! alt // Reportstruktur fuer Absorber-Position, Omega und ???
	 //! initial. der Datenbasis + zusatzinfos
	 ScanReport = lpDBase->GetScanReport();
	 ScanReport2 = new TCurve(ScanReport->GetPNumber());
	 ReportUse.bMonitor=ReportUse.bAbsorber=ReportUse.bTime=ReportUse.bIntegral=FALSE;
	 lpDBase->New();
	 nActiveScan = 0;
	 MainCurve = lpDBase->GetCurve( nActiveScan );
	 // Fuer TPlotData
	 LowerBound = 0.1;
	 UpperBound = 10000.0;
	 bXY_Scaling = TRUE;
	 // pointer to output formats
	 mlSetAxis( nOmega );
	 strcpy( szODF, mGetDF() );
	 strcpy( szOWF, mGetSF() );
	 mlSetAxis( nTheta );
	 eThetaUnitType = mGetUnitType();
	 strcpy( szTDF, mGetDF() );
	 strcpy( szTWF, mGetSF() );
	 //! sperren von Psd-spezifischen Menuepunkten wenn kein Psd angeschlossen ist
	 if ( !dlIsDeviceValid( PsdDevice ) )
	 {
		  EnableMenuItem( TheMenu, cm_ShowPsdE_Data, MF_GRAYED );
		  EnableMenuItem( TheMenu, cm_SetupPsd, MF_GRAYED );
		  EnableMenuItem( TheMenu, cm_CalibratePsd, MF_GRAYED );
		  EnableMenuItem( TheMenu, cm_ShowPsdP_Data, MF_GRAYED );
	 }


	 //! FIX Fehler 39
	 VisualDB.bPsd = bPsdDevice;
	 VisualDB.dThetaWindow =dThetaWindow;
	 VisualDB.dMoveRelation =dMoveRelation;
	 VisualDB.dOmegaMin =dOmegaMin;
	 VisualDB.dOmegaMax = dOmegaMax;
		 if(VisualDB.bPsd)
	{
	 VisualDB.fAngleRange =Device->GetAngleRange();
	 VisualDB.fAngleStep = Device->GetAngleStep();
	}
	else
	{
	VisualDB.fAngleRange =dThetaWindow;
	 VisualDB.fAngleStep = dThetaWindow/dThetaWidth;
	}
	 VisualDB.dThetaMinFirst = dThetaMin;
	 VisualDB.dThetaMinLast = dThetaMin + VisualDB.fAngleRange;
	 VisualDB.dThetaMaxFirst = dThetaMin + (dOmegaMax-dOmegaMin)/dOmegaWidth*dOmegaWidth*dMoveRelation;
	 VisualDB.dThetaMaxLast =  VisualDB.dThetaMaxFirst+ VisualDB.fAngleRange;

	 //! Scanstart ist erlaubt (param. ungueltig)
	 //! FIX Fehler 77
	 bScanSetupOk = FALSE;

   bOldDataLoaded = FALSE;
};


//! loeschen der Datenbasis ,des Menues und speichern von Werten in der
//! Ini-Datei
TAreaScan::~TAreaScan()
{
	 char buf[ MaxString ];
	 RECT rc, rcm;

	 //! Hauptfensterverweis auf areascanfenster loeschen + datenbasis loeschen
	 Main.hAreaScanWindow = NULL;
	 lpDBase->New();
	 //! loeschen des Fenstermenue + senden von Detektorsignalen an das
	 //! AreaScanfenster beenden
	 DestroyMenu( TheMenu );
	 Device->MeasureStop();
	 Device->SetHost( NULL );
	 if ( bPsdDevice )
		  Device->SetDisplay( NULL );
	 Device->MeasureStart();
	 //! AreaScanfenster-eigenschaften sowie Datenpfad,Messzeit und SaveOnReady in
	 //! Ini-File ablegen
	 GetWindowRect( GetFrameHandle(), &rcm );
	 GetWindowRect( hWndChild, &rc );
	 sprintf( buf, "%d", rc.left - rcm.left - 4 );
	 WritePrivateProfileString( "AreaScan", "xo", buf, GetCFile() );
	 sprintf( buf, "%d", rc.top - rcm.top - 42 );
	 WritePrivateProfileString( "AreaScan", "yo", buf, GetCFile() );
	 sprintf( buf, "%d", rc.right - rc.left );
	 WritePrivateProfileString( "AreaScan", "dx", buf, GetCFile() );
	 sprintf( buf, "%d", rc.bottom - rc.top );
	 WritePrivateProfileString( "AreaScan", "dy", buf, GetCFile() );
	 WritePrivateProfileString( "AreaScan", "DataPath", szDataPath, GetCFile() );
	 sprintf( buf, "%.2f", fMaxTime );
	 WritePrivateProfileString( "AreaScan", "ExposureTime", buf, GetCFile() );
	 sprintf( buf, "%d", bSaveOnReady );
	 WritePrivateProfileString( "AreaScan", "SaveOnReady", buf, GetCFile() );
};

//#pragma argsused

//! Funktion behandelt Fenstermenuepunkte
LRESULT TAreaScan::CallLocalAction( WPARAM wParam, LPARAM lParam )
{
	 switch ( GET_WM_COMMAND_ID( wParam, lParam ) )
	 {
		  //! 'Choose Scan'
		  //! aufruf der Dialogbox zur Auswahl der scans
	 case cm_ChooseScan:
		  //! FIX Fehler 46
		  if(bShowPsdContinuous)
			{
			MessageBox(GetFocus(),szMsgLine017,szMessage,
			MBINFO);
			break;
			}
			//! keine Datenbasis im speicher
		  if(2>lpDBase->GetCNumber())
			{
			MessageBox(GetFocus(),szMsgLine031,szMessage,
			MBINFO);
			break;
			}
		  TheModeless = ( TChooseScan* ) new TChooseScan( this );
		  if ( TheModeless )
				TheModeless->Initialize();
		  return 0l;

	 //! Aufruf Dialog DB-Zusammensetzung
	 case cm_ComposeDB:
		  ComposeDB();
		  return 0l;

	 //! Aufruf Dialog DB-Zerlegung
	 case cm_DismantleDB:
		  DismantleDB();
		  return 0l;

	 //! 'Show Energy-Spectrum'
	 //! kont. Anzeige des Energiespektrums aktivieren
	 case cm_ShowPsdE_Data:
		  ShowSensorContinuous( PsdEnergyData );
		  return 0l;

		  //! 'Show Impulse-Spectrum'
		  //! kont. Anzeige des Impulsspektrums aktivieren
	 case cm_ShowPsdP_Data:
		  ShowSensorContinuous( PsdPositionData );
		  return 0l;

		  //! 'Settings...'
		  //! aufruf der Psd-Einstellungsbox
	 case cm_SetupPsd:
		  TheModeless = ( TPsdParameters* ) new TPsdParameters();
		  if ( TheModeless )
				TheModeless->Initialize();
		  break;

	 }
	 return 0l;
};

//***************** Mausbedienung *********************************************

//! aufruf wenn rechte Maustaste gedrueckt
//! Fenstermenue an aktueller Mausposition ausgeben
//! eingabeparam. aktuelle Mauspos.low(8) x-pos
//! high(8) y-pos.
void TAreaScan::rButtonDown( LONG lParam )
{
	 POINT pp;

	 //! DB-Zerlegung nur zugelassen, wenn DB im Speicher
	 if ( lpDBase->GetCNumber()<2 )
		  EnableMenuItem( TheMenu, cm_DismantleDB, MF_GRAYED );
	 else
		  EnableMenuItem( TheMenu, cm_DismantleDB, MF_ENABLED );
	 //! sperren von 'Start AreaScan' wenn bereits ein Scan laeuft der nicht
	 //! unterbrochen wurde
	 //! FIX Fehler
	 if ( ( bMeasurementActive && !bInterrupted ) || !bScanSetupOk )
		  EnableMenuItem( TheMenu, cm_InitializeAreaScan, MF_GRAYED );
	 else
		  EnableMenuItem( TheMenu, cm_InitializeAreaScan, MF_ENABLED );
	 //! sperren von 'Choose Scan' wenn irgendeine nichtmodale Dialogbox aktiv ist
	 if ( TheModeless )
		  EnableMenuItem( TheMenu, cm_ChooseScan, MF_GRAYED );
	 else
		  EnableMenuItem( TheMenu, cm_ChooseScan, MF_ENABLED );
	 //! sperren von 'Settings...' wenn kein Psd verfuegbar ist
	 if ( !bPsdDevice )
		  EnableMenuItem( TheMenu, cm_SetupPsd, MF_GRAYED );
	 else
		  EnableMenuItem( TheMenu, cm_SetupPsd, MF_ENABLED );
	 //! sperren von 'Fixing' wenn Darstellungsart ungleich Kurve + sperren von
	 //! 'Inquire Data' wenn Darstellungsart gleich Kurve
	 if ( eOutputType <= MatrixBitmap )
	 {
		  EnableMenuItem( TheMenu, cm_FreezeCurve, MF_GRAYED );
		  EnableMenuItem( TheMenu, cm_DataAquisition, MF_ENABLED );
	 }
	 else
	 {
		  EnableMenuItem( TheMenu, cm_DataAquisition, MF_GRAYED );
    	 //! neu fixscan
	    if (1>SecondCurve->GetPNumber())
      {
		   EnableMenuItem( TheMenu, cm_FreezeCurve, MF_ENABLED );
     	 EnableMenuItem( TheMenu, cm_SaveSecondCurve, MF_GRAYED );
    	 EnableMenuItem( TheMenu, cm_KillSecondCurve, MF_GRAYED );
       //! dieser Befehl macht bei Win31 probleme
       //! ModifyMenu( TheMenu, 8, MF_STRING|MF_BYPOSITION,8,"Scan" );
      }
      else
      {
       //! ModifyMenu( TheMenu, 8, MF_STRING|MF_BYPOSITION,8,"fixierten Scan" );
		   EnableMenuItem( TheMenu, cm_FreezeCurve, MF_GRAYED );
     	 EnableMenuItem( TheMenu, cm_SaveSecondCurve, MF_ENABLED );
    	 EnableMenuItem( TheMenu, cm_KillSecondCurve, MF_ENABLED );
      }

	 }
	 //! darstellen des Menues an der Mausposition
	 pp.x = LOWORD( lParam );
	 pp.y = HIWORD( lParam );
	 ClientToScreen( hWndChild, &pp );
	 TrackPopupMenu( TheMenu, 0, pp.x, pp.y, 0, hWndChild, NULL );
};


//! aufruf wenn linke Maustaste losgelassen wurde(d.h. Endpunkt erreicht)
//! wird in 2 Faellen aktiv
//! - messen von entfernung zwischen zwei Punkten ueber TPlotData
//! - bei Dataaquisition(nMouseAction==100) zusaetzlich Kommando senden
void TAreaScan::lButtonUp( WPARAM wParam, LPARAM lParam )
{
	 TPlotData::lButtonUp( wParam, lParam );
	 if ( nMouseAction == 100 )
	 {
		  nMouseAction = 0;
		  PostMessage( hWndChild, WM_COMMAND, cm_DataAquisition, 0l );
	 }
};


//! aufruf wenn linke Maustaste gedrueckt wurde(d.h Startpunkt wurde gewaehlt)
//! wird in 2 Faellen aktiv
//! - messen von entfernung zwischen zwei Punkten (nMouseAction=0)
//! - bei Dataaquisition (nMouseAction=100)
void TAreaScan::lButtonDown( WPARAM wParam, LPARAM lParam )
{
	 if ( bAquisitionActive )
		  nMouseAction = 100;
	 else
		  nMouseAction = 0;
	 TPlotData::lButtonDown( wParam, lParam );
};


//! behandelt die Kommandos 'Setup Measurement...' und 'Inquire Data'
//! des Kindfenster-menue ; aufruf aus m_main.cpp DoCommandsChild()
void TAreaScan::InitializeDlg( WPARAM task, LPARAM )
{
	 TModalDlg * dlg;

	 switch ( task )
	 {
		  //! aufruf der Dialogbox 'Einstellungen AreaScan'
	 case cm_SetupAreaScan:
		  //! FIX Fehler 74
			if (!mlIsAxisValid( Omega )||
			 ((!mlIsAxisValid(Theta)&&!dlIsDeviceValid(PsdDevice))))
			 {
			 MessageBox(GetFocus(),szMsgLine021,szMsgFailure,MBINFO);
			 break;
			 }
		  dlg = ( TSetupAreaScan* ) new TSetupAreaScan( this );
		  //! zeichnet DialogBox (in dlg_tpl.cpp)
		  dlg->ExecuteDialog( hWndChild );
		  delete dlg;
		  //! Scanstart ist erlaubt (param. gueltig)
		  //! FIX Fehler 77
		  bScanSetupOk = TRUE;
		  break;

	 case cm_DataAquisition:
		  //! Aufruf durch Menue "Data Aquisition"/"Daten Erhebung"
		  //! Benutzer zieht Gerade ueber ein Bitmap und es werden alle
		  //! Punkte (Anzahl der Punkte vom Nutzer einstellbar) der Gerade berechnet
		  //! Es werden berechnet Theta,Omega,RLX,RLY,Intensitaet,Delta
		  //! Delta gibt die gemittelte Abweichung des berechneten Koordinatenpaars
		  //! von einem tatsaechlich vorhandenen Messkoordinatenpaar an
		  if ( bAquisitionActive )
		  {
//!				FILE * hFile;
				int hFile;
				char buf[ MaxString ];
				int cnt, env, row, column;
				float Odelta, Tdelta, x, y, z, offset, value;
				double yDelta, xDelta, Omega, Theta, rlxDelta, rlyDelta;
				TCurve* Scan;
				bAquisitionActive = FALSE;
				OFSTRUCT of;

				SetRanges();

				//! Punkte ausserhalb des Koordinatensystems nicht zulassen
				if (PointX[0]>AltCoorSys.xMax || PointX[1]>AltCoorSys.xMax ||
						  PointY[0]>AltCoorSys.yMax || PointY[1]>AltCoorSys.yMax ||
						  PointX[0]<AltCoorSys.xMin || PointX[1]<AltCoorSys.xMin ||
						  PointY[0]<AltCoorSys.yMin || PointY[1]<AltCoorSys.yMin)
				{
#ifdef GermanVersion
					 MessageBox(GetFocus(),
									"gewhlte Koordinaten ausserhalb des Megebiets!",szMsgFailure,MBINFO );
#else
MessageBox(GetFocus(),
					 "selected coordinates outside of the measurementarea!",szMsgFailure,MBINFO );
#endif
					 break;
				}
				//! Beruecksichtigen, ob Gerade horizontal oder vertikal und nicht frei Hand...
				if (bSetDYZero)
					 PointY[1]=PointY[0];
				if (bSetDXZero)
					 PointX[1]=PointX[0];

				yDelta=(PointY[1]-PointY[0])/nLinePoints;
				xDelta=(PointX[1]-PointX[0])/nLinePoints;

				//! wenn Abstand der Messpunkte nicht gross genug...
				if ((fabs(yDelta)<1e-7)&&(fabs(xDelta)<1e-7))
				{
#ifdef GermanVersion
					 MessageBox(GetFocus(),"Eingabe wird verworfen !",szMsgFailure,
									MBINFO );
#else
					 MessageBox(GetFocus(),"Input is rejected !",szMsgFailure,
									MBINFO );
#endif
					 break;
				}

				//*** Point0 and Point1 are valid
				//! TData Struktur speichert errechnete Werte...
				lpData=(TData*) new TData[nLinePoints];
				//! Berechnung der Punkte der Gerade je nach Darstellungstyp
				switch (eOutputType)
				{
				case MatrixBitmap:
					 //! nLinePoints gibt an, wieviele Messpunkte auf der Gerade liegen sollen...
					 lpData[0].dTheta=PointX[0];
					 lpData[0].dOmega=PointY[0];
					 lpData[0].fDelta=lpData[0].fIntensity=0.0;
					 for (cnt=1;cnt<nLinePoints;cnt++)
					 {
						  lpData[cnt].fDelta=lpData[cnt].fIntensity=0.0;
						  lpData[cnt].dOmega=lpData[cnt-1].dOmega+yDelta;
						  lpData[cnt].dTheta=lpData[cnt-1].dTheta+xDelta;
					 }
					 break;

				case ReciprokeLatticeBitmap:
					 lpData[0].dX=PointX[0];
					 lpData[0].dY=PointY[0];
					 lpData[nLinePoints-1].dX=PointX[1];
					 lpData[nLinePoints-1].dY=PointY[1];
					 lpData[0].fDelta=lpData[0].fIntensity=0.0;
					 lpData[nLinePoints-1].fDelta=lpData[nLinePoints-1].fIntensity=0.0;

					 //! Zeile und Spalte im Bitmap berechnen
					 row=(PointY[0]-AltCoorSys.yMin)/AltCoorSys.ySF;
					 column=(PointX[0]-AltCoorSys.xMin)/AltCoorSys.xSF;


					 //! Omega und Theta aus dem "Daten"Feld holen - Theta ist ohne Offset gespeichert

					 if (BSource->dateniscreated)
					 {
						  lpData[0].dOmega=BSource->daten[row][column].omega;
						  lpData[0].dTheta=BSource->daten[row][column].theta;
					 }
					 else
					 {
						  lpData[0].dOmega=0;
						  lpData[0].dTheta=0;
					 }

					 lpData[0].dX=PointX[0];
					 lpData[0].dY=PointY[0];

					 //! Zeile und Spalte im Bitmap berechnen
					 row=(PointY[1]-AltCoorSys.yMin)/AltCoorSys.ySF;
					 column=(PointX[1]-AltCoorSys.xMin)/AltCoorSys.xSF;

					 //! Omega und Theta aus dem "Daten"Feld holen - Theta ist ohne Offset gespeichert
					 if (BSource->dateniscreated)
							{
								  lpData[nLinePoints-1].dOmega=BSource->daten[row][column].omega;
								  lpData[nLinePoints-1].dTheta=BSource->daten[row][column].theta;
					 }
							else
							{
								  lpData[nLinePoints-1].dOmega=0;
								  lpData[nLinePoints-1].dTheta=0;
							}

					 lpData[nLinePoints-1].dX=PointX[1];
					 lpData[nLinePoints-1].dY=PointY[1];

					 //! nLinePoints gibt an, wieviele Messpunkte auf der Gerade liegen sollen...
					 yDelta=(lpData[nLinePoints-1].dOmega-lpData[0].dOmega)/nLinePoints;
					 xDelta=(lpData[nLinePoints-1].dTheta-lpData[0].dTheta)/nLinePoints;
					 rlxDelta=(lpData[nLinePoints-1].dX-lpData[0].dX)/nLinePoints;
					 rlyDelta=(lpData[nLinePoints-1].dY-lpData[0].dY)/nLinePoints;


					 for(cnt=0;cnt<nLinePoints-1;cnt++)
					 {
						  lpData[cnt+1].fDelta=lpData[cnt+1].fIntensity=0.0;
						  lpData[cnt+1].dOmega=lpData[cnt].dOmega+yDelta;
						  lpData[cnt+1].dTheta=lpData[cnt].dTheta+xDelta;
						  lpData[cnt+1].dX=lpData[cnt].dX+rlxDelta;
						  lpData[cnt+1].dY=lpData[cnt].dY+rlyDelta;
					 }
					 break;
				}
				//*** search the related intensities
				//! berechnen der fehlenden Einheiten
				switch (eOutputType)
				{
				case MatrixBitmap:
					 for (cnt=0;cnt<nLinePoints;cnt++)
					 {
						  Omega=lpData[cnt].dOmega;
						  row=ScanReport->GetValueByValue(Omega,Odelta,offset);
						  Theta=lpData[cnt].dTheta;

						  if(VisualDB.bPsd)
						  {
							  //! Theta-Offset beruecksichtigen
							  Theta=lpData[cnt].dTheta-(GetThetaOffset(row)-VisualDB.dThetaMinFirst);
							  Theta-=AltCoorSys.xMin;
						  }

						  Scan=lpDBase->GetCurve(row);
						  //! Omega-=Odelta;
						  //** pick out the intensity
						  column=Scan->GetValueByValue(Theta,Tdelta,value);
						  //! Theta-=Tdelta;
						  //! Omega und Theta in RL Koordinaten umrechnen
						  Omega=DegToRad(Omega);
						  Theta=DegToRad(lpData[cnt].dTheta);
						  lpData[cnt].dX=ArToRLx(Omega,Theta)*(M_PI/(0.5*Main.WaveLength));
						  lpData[cnt].dY=ArToRLy(Omega,Theta)*(M_PI/(0.5*Main.WaveLength));
						  //! lpData[cnt].fIntensity=value;
						  value=0;
						  //! nEnvironment liegt immer zwischen 0-3
						  env=nEnvironment;
						  //! beruecksichtigen der gewuenschten Umgebungsmesspunkte,
						  //! damit eventuelle krasse Intensitaetsunterschiede wegfallen
						  //! berechne Intensitaet
						  if (xDelta>yDelta)
								while (env+1)
								{
									 Scan->SetPP(column+env);
									 Scan->PGet(x,y,z);
									 value += y;
									 Scan->SetPP(column-env);
									 Scan->PGet(x,y,z);
									 value += y;
									 env--;
								}
						  else
								while (env+1)
								{
									 Scan = lpDBase->GetCurve(row+env);
									 Scan->SetPP(column);
									 Scan->PGet(x,y,z);
									 value+=y;
									 Scan=lpDBase->GetCurve(row-env);
									 Scan->SetPP(column);
									 Scan->PGet(x,y,z);
									 value+=y;
									 env--;
								}
						  //! bilde arithmetisches Mittel der Intensitaeten
						  lpData[cnt].fIntensity=value/((nEnvironment+1)*2);
						  //! quadriere Deltas, damit sich pos./neg. Werte nicht gegenseitig aufheben
						  lpData[cnt].fDelta=sqrt(pow(Odelta,2)+pow(Tdelta,2));
					 }
					 break;

				case ReciprokeLatticeBitmap:
					 for (cnt=0;cnt<nLinePoints;cnt++)
					 {
						  Omega=lpData[cnt].dOmega;
						  Theta=lpData[cnt].dTheta;
						  row = ScanReport->GetValueByValue(Omega,Odelta,offset);
						  //** reverse connection between psd and theta-axis
						  //! Omega-=Odelta;
						  Scan=lpDBase->GetCurve(row);

						  //** pick out the intensity
						  column=Scan->GetValueByValue(Theta,Tdelta,value);

						  //! Theta-Offset beruecksichtigen
						  if (VisualDB.bPsd) lpData[cnt].dTheta=Theta + GetThetaOffset(row);
						  else lpData[cnt].dTheta=Theta+GetThetaOffset(row)-VisualDB.dThetaMinFirst;

						  //! Theta-=Tdelta;
						  //! lpData[cnt].fIntensity=value;
						  value=0;
						  //! nEnvironment liegt immer zwischen 0-3
						  env=nEnvironment;
						  //! beruecksichtigen der gewuenschten Umgebungsmesspunkte,
						  //! damit eventuelle krasse Intensitaetsunterschiede wegfallen
						  //! berechne Intensitaet
						  if (Tdelta>Odelta)
								while (env+1)
								{
									 Scan->SetPP(column + env);
									 Scan->PGet(x,y,z);
									 value+=y;
									 Scan->SetPP(column-env);
									 Scan->PGet(x,y,z);
									 value+=y;
									 env--;
								}
						  else
								while (env+1)
								{
									 Scan = lpDBase->GetCurve(row+env);
									 Scan->SetPP(column);
									 Scan->PGet(x,y,z);
									 value+=y;
									 Scan=lpDBase->GetCurve(row-env);
									 Scan->SetPP(column);
									 Scan->PGet(x,y,z);
									 value+=y;
									 env--;
								}
						  //! bilde arithmetisches Mittel der Intensitaeten
						  lpData[cnt].fIntensity=value/((nEnvironment+1)*2);
						  //! quadriere Deltas, damit sich pos./neg. Werte nicht gegenseitig aufheben
						  lpData[cnt].fDelta=sqrt(pow(Odelta,2)+pow(Tdelta,2));
					 }
					 break;
				}
				//! Daten speichern
//!				hFile=fopen(DataFile,"w");
				hFile = OpenFile( DataFile, &of, OF_CREATE );
				if(-1==hFile)
				{
#ifdef GermanVersion
					 strcpy( buf,"Probleme beim Anlegen der Datei !");
					 MessageBox(GetFocus(),buf,szMessage,MBINFO );
#else
					 strcpy( buf,"Problems when creating the file !");
					 MessageBox(GetFocus(),buf,szMessage,MBINFO );
#endif
					 delete[] lpData;
					 return;
				}
				//! ergaenzt um Header und Data Info
#ifdef GermanVersion
				sprintf(buf,"[Header]\nGerade zwischen 2 Punkten \n");
#else
sprintf(buf,"[Header]\nLine between 2 points \n");
#endif
//!				fwrite( buf,strlen(buf),1,hFile);
				_lwrite(hFile,buf,strlen(buf));
				//! FileType mit eingefuehrt - TScan.eSaveFormat=dtnFile (beim Einlesen)
				sprintf( buf,"FileType=Aquisition\n",FileName );
//!				fwrite( buf,strlen( buf ), 1,hFile );
				_lwrite(hFile,buf,strlen(buf));
				sprintf( buf,"Source = %s\n",FileName );
//!				fwrite(buf,strlen(buf),1,hFile );
				_lwrite(hFile,buf,strlen(buf));

				//! Abfrage RL oder normale Koordinaten speichern
				if (!bSetRLSave)
				{
					 sprintf( buf,"Omega Intens. Theta RLY RLX Delta\n",FileName );
//!					 fwrite( buf,strlen(buf),1,hFile );
					 _lwrite(hFile,buf,strlen(buf));
#ifdef GermanVersion
					 sprintf(buf,"Omega aufsteigend geordnet\n",FileName );
#else
					 sprintf(buf,"Omega ascending arranged\n",FileName );
#endif
//!					 fwrite(buf,strlen(buf),1,hFile);
					 _lwrite(hFile,buf,strlen(buf));

					 sprintf(buf,"[Data]\n",FileName);
//!					 fwrite(buf,strlen(buf),1,hFile);
					 _lwrite(hFile,buf,strlen(buf));

					 //! Unterscheidung eingebaut, damit Omega aufsteigend abgespeichert
					 if (lpData[0].dOmega<lpData[nLinePoints-1].dOmega)
					 {
						  for (cnt=0;cnt<nLinePoints;cnt++)
						  {
								sprintf( buf,"%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f",
											lpData[cnt].dOmega,
											lpData[cnt].fIntensity,
											lpData[cnt].dTheta,
											lpData[cnt].dY,
											lpData[cnt].dX,
											lpData[cnt].fDelta);
//!								fwrite(buf,strlen(buf),1,hFile );
									strcat(buf, EOL);
									_lwrite(hFile,buf,strlen(buf));

						  }
					 }
					 else
					 {
						  for (cnt=nLinePoints-1;cnt>=0;cnt--)
						  {
								sprintf( buf,"%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f",
											lpData[cnt].dOmega,
											lpData[cnt].fIntensity,
											lpData[cnt].dTheta,
											lpData[cnt].dY,
											lpData[cnt].dX,
											lpData[cnt].fDelta);
//!								fwrite(buf,strlen(buf),1,hFile);
									strcat(buf, EOL);
									_lwrite(hFile,buf,strlen(buf));

						  }
					 }
				}
				else
				{
					 sprintf(buf,"RLY Intens. RLX Omega Theta Delta\n",FileName);
//!					 fwrite(buf,strlen(buf),1,hFile);
					 _lwrite(hFile,buf,strlen(buf));

#ifdef GermanVersion
					 sprintf(buf,"RLY aufsteigend geordnet\n",FileName );
#else
					 sprintf(buf,"RLY ascending arranged\n",FileName );
#endif
//!					 fwrite(buf,strlen(buf),1,hFile);
					 _lwrite(hFile,buf,strlen(buf));
					 sprintf(buf,"[Data]\n",FileName);
//!					 fwrite(buf,strlen(buf),1,hFile);
					 _lwrite(hFile,buf,strlen(buf));
					 //! Unterscheidung eingebaut, damit RLY aufsteigend abgespeichert
					 if (lpData[0].dY<lpData[nLinePoints-1].dY)
					 {
						  for (cnt=0;cnt<nLinePoints;cnt++)
						  {
								sprintf( buf,"%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f",
											lpData[cnt].dY,
											lpData[cnt].fIntensity,
											lpData[cnt].dX,
											lpData[cnt].dOmega,
											lpData[cnt].dTheta,
											lpData[cnt].fDelta);
//!								fwrite(buf,strlen(buf),1,hFile );
									strcat(buf, EOL);
									_lwrite(hFile,buf,strlen(buf));

						  }
					 }
					 else
					 {
						  for (cnt=nLinePoints-1;cnt>=0;cnt--)
						  {
								sprintf(buf,"%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f",
										  lpData[cnt].dY,
										  lpData[cnt].fIntensity,
										  lpData[cnt].dX,
										  lpData[cnt].dOmega,
										  lpData[cnt].dTheta,
										  lpData[cnt].fDelta);
//!								fwrite(buf,strlen(buf),1,hFile );
                           strcat(buf, EOL);
									_lwrite(hFile,buf,strlen(buf));

						  }
					 }
				}
				_lclose(hFile);
				delete[] lpData;
#ifdef GermanVersion
				sprintf(buf,"Die Daten wurden in der Datei %s gespeichert !", DataFile );
				MessageBox( GetFocus(), buf, "Daten-Erhebung", MBINFO );
#else
sprintf(buf,"The data were stored in the file %s !", DataFile );
				MessageBox( GetFocus(), buf, "Data-inquiries", MBINFO );
#endif
				return ;
		  }
		  dlg = ( TAquisition* ) new TAquisition();
		  dlg->ExecuteDialog( hWndChild );
		  delete dlg;
		  break;
	 }
	 UpdateWnd( 0 );
};

//! Funktion wird bei WM_CREATE aus WndProc aufgerufen
//! testet ob weniger als 5 Fenster geoeffnet sind liefert dann ein true als
//! Rueckkehrcode ansonsten ein false
//! wahrscheinlich ueberfluessig (wird geerbt)
BOOL TAreaScan::CanOpen( void )
{
	 if ( !TMDIWindow::CanOpen() ) return FALSE;
	 return TRUE;
};


//! test ob Fenster geschlossen werden kann
//! -test ob Messung aktiv, wenn ja, dann zuerst Messung unterbrechen
//! -test ob geaenderte Daten, wenn ja, dann Speicher-Anfrage
//! Rueckkehrcode False wenn kein Fenster goeffnet war sonst immer True
//! wahrscheinlich ueberfluessig (wird geerbt)
BOOL TAreaScan::CanClose( void )
{
	 if ( !TMDIWindow::CanClose() ) return FALSE;
	 return TRUE;
};


//! loescht aktuelle datenbasis + baut AreaScanfenster neu auf
//! Rueckkehrcode immer True
BOOL TAreaScan::New( void )
{
	 //! FIX Fehler 39
	 VisualDB.bPsd = bPsdDevice;
	 VisualDB.dThetaWindow =dThetaWindow;
	 VisualDB.dMoveRelation =dMoveRelation;
	 VisualDB.dOmegaMin =dOmegaMin;
	 VisualDB.dOmegaMax = dOmegaMax;
	 if(VisualDB.bPsd)
	{
	 VisualDB.fAngleRange =Device->GetAngleRange();
	 VisualDB.fAngleStep = Device->GetAngleStep();
	}
	else
	{
	VisualDB.fAngleRange =dThetaWindow;
	 VisualDB.fAngleStep = dThetaWindow/dThetaWidth;
	}
	 VisualDB.dThetaMinFirst = dThetaMin;
	 VisualDB.dThetaMaxFirst = dThetaMin + VisualDB.fAngleRange;
  if (eScanType==StandardScan)
    VisualDB.dThetaMinLast = dThetaMin;
  else
	 VisualDB.dThetaMinLast = dThetaMin + (dOmegaMax-dOmegaMin)/dOmegaWidth*dOmegaWidth*dMoveRelation;
	 VisualDB.dThetaMaxLast =  VisualDB.dThetaMinLast+ VisualDB.fAngleRange;

	 lpDBase->New();
	 ScanReport2->New();

	 nActiveScan = 0;
	 MainCurve = lpDBase->GetCurve( nActiveScan );
   bOldDataLoaded = FALSE;
	 return TPlotData::New();
};


//! Darstellen des AreaScan-Fenster
void TAreaScan::Create( HWND hwnd )
{
	 RECT rc;

	 hWndChild = hwnd;
	 Main.hAreaScanWindow = hwnd;
	 Main.AreaScanWindow = this;
	 Delay( 2000 );
	 //! einlesen der Fenstereigenschaften, des Datenpfades aus dem
	 //! [AreaScan]-Abschnitt des Ini-Files
	 rc.left = GetPrivateProfileInt( "AreaScan", "xo", 500, GetCFile() );
	 rc.top = GetPrivateProfileInt( "AreaScan", "yo", 400, GetCFile() );
	 rc.right = rc.left + GetPrivateProfileInt( "AreaScan", "dx", 170, GetCFile()
															);
	 rc.bottom = rc.top + GetPrivateProfileInt( "AreaScan", "dy", 50, GetCFile()
															);
	 GetPrivateProfileString( "AreaScan", "DataPath", "c:\\", szDataPath,
									  MaxString, GetCFile() );
	 if ( szDataPath[ strlen( szDataPath ) - 1 ] != '\\' )
		  strcat( szDataPath, "\\" );
	 //! setzen der Filter und der Extension
	 strcpy( szFilter, "HRM Standard (*.psd)|*.psd|" );
	 strcpy( szExtension, "psd" );
	 //! Titelzeile des Fensters bestimmen + aktualisieren des Hauptmenues +
	 //! darstellen des Scanfensters
	 SetTitle();
	 UpdateMenu();
	 SetWindowPos( hWndChild, NULL, rc.left, rc.top, rc.right - rc.left,
						rc.bottom - rc.top, SWP_NOZORDER );
};


//! setzt Titel des AreaScanFensters
//! Rueckkehrcode immer True
BOOL TAreaScan::SetTitle()
{
	 char aTitle[ MaxString ];

#ifdef GermanVersion
	 strcpy( aTitle, "Areascan:" );
#else
	 strcpy( aTitle, "AreaScan:" );
#endif
	 //! haengt "<untitled.psd>" bei neuer Datei , sonst FileName an
	 //! und schreibt ihn ins Fenster
	 if ( bIsNewFile )
		  strcat( aTitle, "<untitled.psd>" );
	 else
		  strcat( aTitle, FileName );
	 SetWindowText( hWndChild, aTitle );
	 return TRUE;
};


//! zeichnet in abhaengigkeit des eingestellten Darstellungstyps das AreaScan-
//! fenster neu
void TAreaScan::UpdateWnd( int act )
{
	 switch ( eOutputType )
	 {
	 case ReciprokeLatticeBitmap:
		  BSource->UpdateBitmapSource();
		  break;
	 case MatrixBitmap:
		  BSource->UpdateBitmapSource();
		  break;
	 }
	 //! behandelt Darstellungstyp Curve
	 TMDIWindow::UpdateWnd( act );
};


//! setzt die Achsen-min. und -max. abhaengig von der Darstellungsart
void TAreaScan::SetRanges( void )
{
	 float xshift;
   float fRangeSec = 1.0;
	 TDisplay DParam;

	 //! FIX Fehler 39
	 if (bShowPsdContinuous||bMeasurementActive)
	 { //! akt. Detektor spez. Darstellung
	 DParam.bPsd = bPsdDevice;
	 DParam.dThetaWindow =dThetaWindow;
	 DParam.dMoveRelation =dMoveRelation;
	 DParam.dOmegaMin =dOmegaMin;
	 DParam.dOmegaMax = dOmegaMax;
	 DParam.fAngleRange =Device->GetAngleRange();
   fRangeSec = Device->GetAngleRange(Sekunden)/DParam.fAngleRange;
	 DParam.fAngleStep = Device->GetAngleStep();
	 }
	 else
	 { //! Datenbasis spez. Darstellung
	 DParam.bPsd = VisualDB.bPsd;
	 DParam.dThetaWindow = VisualDB.dThetaWindow;
	 DParam.dMoveRelation = VisualDB.dMoveRelation;
	 DParam.dOmegaMin = VisualDB.dOmegaMin;
	 DParam.dOmegaMax = VisualDB.dOmegaMax;
	 DParam.fAngleRange = VisualDB.fAngleRange;
	 DParam.fAngleStep = VisualDB.fAngleStep;
	 }

    switch ( eOutputType )
    {
        //! Kurve
	 case Curve:
        CoorSys.yMin = LowerBound;
        CoorSys.yMax = UpperBound;
		  if ( !DParam.bPsd )
		  {
				//! wenn kein Psd dann test ob Punkte in Kurve
				if ( 1 > MainCurve->GetPNumber() )
				{
					 //! wenn nicht x-Achse( -xx/2 -> xx/2)
					 CoorSys.xMin = - DParam.dThetaWindow / 2.0;
					 CoorSys.xMax = DParam.dThetaWindow / 2.0;
					 break;
				}
				//! sonst x-Achse (min: auf min.Winkelwert der Kurve -> max: min + xx)
				CoorSys.xMin = MainCurve->Min[ P_X ];
				CoorSys.xMax = CoorSys.xMin + DParam.dThetaWindow;
				break;
		  }
		  //! Psd angeschlossen
		  if ( 2 > MainCurve->GetPNumber() )
        {
            //! kurve hat keine Punkte
            if ( bSecondaryCoor )
            {
                //! Kanaldarstellung => x-Achse (0 -> (Kurvenbereich/winkel
                //! pro Kanal))
					 CoorSys.xMin = 0.0;
                CoorSys.xMax = DParam.fAngleRange / DParam.fAngleStep * fRangeSec;
                             /*! Device->GetAngleRange( Sekunden ) /
                               Device->GetAngleStep();*/
                break;
				}
				//! Winkeldarstellung x-Achse
            CoorSys.xMin = DParam.dOmegaMin * DParam.dMoveRelation;
            CoorSys.xMax = CoorSys.xMin + DParam.fAngleRange;
                                          /*Device->GetAngleRange();*/
            break;
        }
        //! Kurve hat Punkte
		  if ( bSecondaryCoor )
        {
            CoorSys.xMin = MainCurve->Min[ P_Z ];
            CoorSys.xMax = MainCurve->Max[ P_Z ];
            break;
        }
		  //! liefert 0 wenn kein Psd ansonsten den ThetaOffset und setzt
		  //! entsprechend die x-Achse
		  xshift = GetThetaOffset( 0 );
		  CoorSys.xMin = MainCurve->Min[ P_X ] + xshift;
		  CoorSys.xMax = MainCurve->Max[ P_X ] + xshift;
		  break;

		  //! RL-Bitmap
    case ReciprokeLatticeBitmap:
        CoorSys.zMax = UpperBound;
        CoorSys.zMin = LowerBound;
        // The AltCoorSys is now used and will be setted in
        // TransformDBaseToBitmap()
        break;

		  //! RAW-Matrix
    case MatrixBitmap:
        CoorSys.zMax = UpperBound;
        CoorSys.zMin = LowerBound;
        CoorSys.yMin = DParam.dOmegaMin;
        CoorSys.yMax = DParam.dOmegaMax;
        //! setzen der x-Achse in abhaengigkeit von Kurvenpunktzahl
		  if ( 7 > MainCurve->GetPNumber())
        {
            CoorSys.xMin = DParam.dOmegaMin * DParam.dMoveRelation;
            CoorSys.xMax = CoorSys.xMin + DParam.fAngleRange;
                                         /*Device->GetAngleRange();*/
            break;
        }
        xshift = GetThetaOffset( 0 );
        CoorSys.xMin = MainCurve->Min[ P_X ] + xshift;
        //! dies muss mit rein! B.Buss
        xshift = GetThetaOffset(lpDBase->GetCNumber()-1);
		  CoorSys.xMax = MainCurve->Max[ P_X ] + xshift;
        break;

	 default:
		  MessageBox( GetFocus(), szMsgLine023, szMessage,
						  MBINFO );
		  break;
	 }
};

//! Funktion liefert den absoluten Thetawert als Rueckkehrcode
//! 1.Param. scid gibt Kurvennr. an, deren absoluter Thetawert gesucht ist
//! nur bei RL-Bitmap benutzt
double TAreaScan::GetThetaOffset( int scid )
{
	 float theta, v;

	 // this function returns an absolute Theta Value
	 switch ( eOutputType )
	 {
	 case Curve:
        //! bei kont.Anzeige den akt. Thetawinkel als Offset zurueck
        if ( bShowPsdContinuous )
            return ( mlGetValue( nTheta, Distance ) - mlGetOffset( nTheta ) );
        //! wenn kein Psd angeschl. offset=0
        //! FIX Fehler 39
		  if ( !VisualDB.bPsd )
            theta = 0.0;
        else
        {
            //! neu akk
            //! waehrend des Scans existiert noch keine reportkurve
            //! deshalb akt. motorposition
            if ( bMeasurementActive )
               theta= ( mlGetValue( nTheta, Distance ) - mlGetOffset( nTheta )+ dOffsetTheta );
             else
             {
             //! Offset = thetawert der letzten Kurve holen wenn dieser gueltig ist
             //! sonst 0
             ScanReport->SetPP( nActiveScan );
             ScanReport->PGet( v, theta, v );
             if ( ( theta > 1000.0 ) || ( theta < -1000.0 ) )
                 theta = 0.0;
             }
        }
		  return theta;


	 case ReciprokeLatticeBitmap:
		  //! liefert 0 wenn zuwenig Kurven in Datenbasis sonst den Thetawert der
		  //! scid-ten Kurve der Datenbasis
		  if ( 2 > lpDBase->GetCNumber() ) return 0.0;
		  ScanReport->SetPP( scid );
		  ScanReport->PGet( v, theta, v );
		  return theta - dThetaOffset;

    case MatrixBitmap:
        //! liefert 0 wenn zuwenig Kurven in Datenbasis sonst den Thetawert der
        //! 0-ten Kurve der Datenbasis
        if ( 2 > lpDBase->GetCNumber() ) return 0.0;
		  //! Aenderung B.Buss ScanReport->SetPP( 0 );
        ScanReport->SetPP( scid );
        ScanReport->PGet( v, theta, v );
        return theta - dThetaOffset;

	 default:
		  MessageBox( GetFocus(), szMsgLine023, szMessage,
						  MBINFO );
		  return 0.0;
	 }
};


//! bildn. Darstellung ausschl. in TPlotData verwendet
BOOL TAreaScan::SetMeasurementArea( TKSystem &ks )
{
	 /*
	 ::fPsdRange wird fuer jede Messung mit Device->GetAngleRange()
	 oder nach dem Einlesen in LoadMeasurementInfo() und LoadOldData() gesetzt.
	 */
	 switch ( eOutputType )
	 {
	 case ReciprokeLatticeBitmap:
		  ks[ 0 ].x = DegToRad ( VisualDB.dThetaMinFirst );
		  ks[ 0 ].y = DegToRad ( VisualDB.dOmegaMin );//! FIX Fehler 39
		  ks[ 0 ].Ord = 0;
		  ks[ 1 ].x = DegToRad ( VisualDB.dThetaMaxFirst );   //! FIX Fehler 39
		  ks[ 1 ].y = DegToRad ( VisualDB.dOmegaMin );//! FIX Fehler 39
		  ks[ 1 ].Ord = 1;
		  ks[ 2 ].x = DegToRad ( VisualDB.dThetaMaxLast );//! FIX Fehler 39
		  ks[ 2 ].y = DegToRad ( VisualDB.dOmegaMax );//! FIX Fehler 39
		  ks[ 2 ].Ord = 2;
		  ks[ 3 ].x = DegToRad ( VisualDB.dThetaMinLast );
		  ks[ 3 ].y = DegToRad ( VisualDB.dOmegaMax );//! FIX Fehler 39
		  ks[ 3 ].Ord = 3;
		  break;

	 case MatrixBitmap:
		  ks[ 0 ].x = VisualDB.dThetaMinFirst/*0.0*/;
		  ks[ 0 ].y =   VisualDB.dOmegaMin;//! FIX Fehler 39
		  ks[ 0 ].Ord = 0;
		  ks[ 1 ].x =   VisualDB.dThetaMaxFirst/*fAngleRange*/;//! FIX Fehler 39
		  ks[ 1 ].y =   VisualDB.dOmegaMin;//! FIX Fehler 39
		  ks[ 1 ].Ord = 1;
		  //! B.Buss geaendert ks[ 2 ].x = ::fPsdRange;
		  //! FIX Fehler 39
		  ks[ 2 ].x = VisualDB.dThetaMaxLast/*GetThetaOffset(lpDBase->GetCNumber()-1)-GetThetaOffset(0) +   VisualDB.fAngleRange*/;
		  ks[ 2 ].y =   VisualDB.dOmegaMax;//! FIX Fehler 39
		  ks[ 2 ].Ord = 2;
		  ks[ 3 ].x = VisualDB.dThetaMinLast/*0.0*/;
		  ks[ 3 ].y =   VisualDB.dOmegaMax;//! FIX Fehler 39
		  ks[ 3 ].Ord = 3;
		  break;
	 }
	 return TRUE;
};

//! wird aufgerufen aus m_main.cpp bei cm_InitializeScan
//! startet den Scanvorgang
void TAreaScan::InitializeTask( WPARAM, LPARAM )
{
	 char buf[ 101 ];
	 char fmt[ MaxString ];
#ifdef GermanVersion
	 char HeadLine[] = "Start AreaScan";
#else
	 char HeadLine[] = "Starting AreaScan";
#endif
	 char msg[ 101 ];

	 //! Scan nicht bei kont. Anzeige erlaubt
	 if ( bShowPsdContinuous )
	 {
		  LoadString( Main.hInstance, sth_StopContiniousPsd, msg, 100 );
		  MessageBox( hWndChild, msg, HeadLine, MBSTOP );
		  return ;
	 }
	 // Alte Daten sichern bzw. neuen Namen vergeben
	 //! test ob die Anzahl der Erwarteten Scans die max. Kapaz. der Datenbasis
	 //! ueberschreitet
	 if ( ( ( dOmegaMax - dOmegaMin ) / dOmegaWidth ) >
				lpDBase->GetMaxScanNumber() )
	 {
		  sprintf( msg, szMsgLine008, lpDBase->GetMaxScanNumber() );
		  MessageBox( hWndChild, msg, HeadLine, MBSTOP );
		  return ;
	 }
	 //! FIX Fehler 44
	 dThetaOffset = 0.0 ;
	 // Motoren initialisieren
	 mlSetAxis( nOmega );
	 mSetValue( Speed, 10000.0 );

	 //! wenn omega-relativ abfrage ob relative Null zuruecksetzen
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( !mIsDistanceRelative() ) break;
		  strcpy( msg, szMsgLine007 );
		  if ( IDYES == MessageBox( hWndChild, msg, HeadLine, MBASK ) )
				mSetRelativeZero( NO, 0.0 );
	 }
	 mlSetAxis( nTheta );
	 mSetValue( Speed, 10000.0 );
	 //! wenn theta-relativ abfrage ob relative Null zuruecksetzen
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( !mIsDistanceRelative() ) break;
		  strcpy( msg, szMsgLine006 );
		  if ( IDYES == MessageBox( hWndChild, msg, HeadLine, MBASK ) )
		  {
				mSetRelativeZero( NO, 0.0 );
				dThetaOffset = 0.0;
		  }
		  else
				dThetaOffset = mlGetOffset( nTheta );
	 }
	 //! auswahl des Scanstartdialogs
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( bPsdDevice )
				sprintf( fmt, szMsgLine003, szODF, szODF );
		  else
		  {
				sprintf( fmt, szMsgLine004, szODF, szODF );
				dThetaOffset = 0.0;
		  }
		  break;

	 case StandardScan:
		  if ( !bPsdDevice ) break;
		  sprintf( fmt, szMsgLine005, szODF, szODF );
		  break;
	 default:
		  return ;
	 }
	 //! dialog anzeigen
	 sprintf( msg, fmt, dOmegaMin, dOmegaMax );
	 if ( IDNO == MessageBox( GetFocus(), msg, HeadLine, MBASK ) )
		  return ;


	//! FIX Fehler 70
	 lpDBase->New();
	 //! FIX Fehler 32
	 if ( bSaveOnReady || bSaveContinuous)
		SaveFile( SaveWithNewName );
	 // Sensoren initialisieren
	 Device->MeasureStop();
	 Steering.Reset();
	 Steering.StartUp( hWndChild, nOmega, Device->GetId() );
	 //! Werte an Detektor
	 Device->SetExposureValues( fMaxTime, dwMaxCounts, fFailure );
	 Device->SetParameters();
   //! Monitordetektor initialisieren wenn als zusatzinfo gewollt
   if(ReportUse.bMonitor)
     {
		  if ( dlGetIdByName( MonitorDevice ) == Device->GetId() )
		  {
				sprintf( buf, szMsgLine002, Device->Characteristic );
				MessageBox( GetFocus(), buf, szMsgFailure, MBSTOP );
				return ;
		  }
		  Monitor->MeasureStop();
		  Monitor->SetHost( hWndChild );
		  Monitor->SetExposureValues( fMaxTime * 0.8, dwMaxCounts, fFailure );
    }
   /*
	 //! ueberfluessig (wahrscheinlich als erweiterung geplant)
	 switch ( eNotifyValue )
	 {
	 case MonitorIntensity:
		  if ( dlGetIdByName( MonitorDevice ) == Device->GetId() )
		  {
				sprintf( buf, szMsgLine002, Device->Characteristic );
				MessageBox( GetFocus(), buf, szMsgFailure, MBSTOP );
				return ;
		  }
		  Monitor->MeasureStop();
		  Monitor->SetHost( hWndChild );
		  Monitor->SetExposureValues( fMaxTime * 0.8, dwMaxCounts, fFailure );
		  break;

	 case AbsorberPosition:
		  break;
	 } */
	 //! einstellen psd-spez. werte
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( bPsdDevice )
		  {
				//! art der Kurvenaktualisierung einstellen
				Device->SetSignalGrowUp( bAccumulatedDisplay );//! neu akk
				//! einstellen der Anzahl der zusammenzufassenden Kanaele
				Device->SetAddedChannels( nAddedChannels );
				//! winkelbereich eines Spektrums ermitteln bei psd
				::fPsdRange = Device->GetAngleRange( eThetaUnitType );
		  }
		  else
				//! winkelbereich eines Spektrums ermitteln bei 0-dim. Det.
				::fPsdRange = dThetaWindow;
		  break;

	 case StandardScan:
		  if ( !bPsdDevice )
		  {
				SetInfo( szMsgLine025 );
				return ;
		  }
		  //! art der Kurvenaktualisierung einstellen
		  Device->SetSignalGrowUp( bAccumulatedDisplay );//! neu akk
		  //! einstellen der Anzahl der zusammenzufassenden Kanaele
		  Device->SetAddedChannels( nAddedChannels );
		  //! winkelbereich eines Spektrums ermitteln bei Psd
		  ::fPsdRange = Device->GetAngleRange( eThetaUnitType );
		  break;
	 }
	 // ******* Alte Daten verwerfen *********************************************
	 bFirstScan = TRUE;
	 //! Darstellungsoptionen fuer Scan setzen
	 Steering.Visualising( 0, 0, 0, 0, 0, 0 );
	 // Scan starten
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( bPsdDevice )
		  {
				//! Anweisungen sind doppelt
				Device->SetSignalGrowUp( bAccumulatedDisplay );//! neu akk
				Device->SetAddedChannels( nAddedChannels );
				strcpy( buf, "" );
				//! Scan starten
				Steering.StartCmdExecution( Scan, ForAreaScan, Omega2ThetaScan, buf,
													 GetWndHandle() );
		  }
		  else
		  {
				bThetaScanCompleted = FALSE;
				mlSetAxis( nTheta );
//!				mSetRelativeZero( YES, mGetValue( Distance ) );
				mlSetAxis( nOmega );
//!				mSetRelativeZero( YES, mGetValue( Distance ) );
				strcpy( buf, "" );
				//! Scan starten
				Steering.StartCmdExecution( AreaScan, Omega2ThetaScan, 0, buf,
													 GetWndHandle() );
		  }
		  break;

	 case StandardScan:
		  //! Anweisungen sind doppelt
		  if ( !bPsdDevice )
		  {
				SetInfo( szMsgLine025 );
				return ;
		  }
		  Device->SetSignalGrowUp( bAccumulatedDisplay );//! neu akk
		  Device->SetAddedChannels( nAddedChannels );
		  strcpy( buf, "" );
		  //! Scan starten
		  Steering.StartCmdExecution( Scan, ForAreaScan, StandardScan, buf,
												GetWndHandle() );
		  break;
	 }
	 //! akt.Kurve loeschen + AreaScan als aktiv kennzeichnen
	 MainCurve->New();
	 bMeasurementActive = TRUE;
	 UpdateMenu();
};

//********* Schnittstellen fuer Ablaufsteuerung *******************************
//! behandelt eigentlichen Scanablauf sowie die kont. Anzeige ,Calibrate ...
//! aufruf aus m_main.cpp wenn cm_CounterSet
void TAreaScan::CounterSetRequest( LPARAM lParam )
{
	 float absorber, channel, psdtheta, peakpos;
	 //! FIX Fehler 30
	 float x, y, x2, y2, z2, intens, integral, time;
	 //! FIX Fehler 47
	 char buf[ 3 * MaxString ], fmt[ 3 * MaxString ], msg[ MaxString ];
	 double dTheta, dOmega;
	 static float fMonitorSignal;
	 int nNumOffs = 0;

	 //! bei kont. Anzeige
	 if ( bShowPsdContinuous )
	 {
		  strcpy( msg, szMsgLine026 );
		  //! Kurvenspektrum+ integrale Intensitaet von Psd holen
		  Device->GetData( *MainCurve );
		  Device->GetData( integral );
		  //! wenn keine Calibr. dann Messung neu starten
		  //! (sonst wird dies in TCalibr. gemacht)
		  if ( !bCalibrationActive && Device->bDataValid )
				Device->MeasureStart();
		  sprintf( fmt, "%s Peak( %s | %s) Integral Intensity : %s", msg, szTDF,
					  "%.2f", "%.2f" );
		  //! in abhaengigkeit von x-achsen-art(Kanal,Winkel) statuszeilen ausgabe
        if ( bSecondaryCoor )
		  {
            //! Kanaldarst.
            channel = Device->GetMaximumChannel();
            intens = Device->GetMaximumIntensity();
            sprintf( buf, fmt, channel, intens, integral );
        }
		  else
		  {
            //! Winkeldarst.
            MainCurve->GetGravityCenter( psdtheta, intens, channel, 2 );
				psdtheta += GetThetaOffset( 0 );
				sprintf( buf, fmt, psdtheta, intens, integral );
		  }
        SetInfo( buf );
		  UpdateWnd( 0 );
        return ;
	 }
    //! bei unterbrochenem Scan + Scan nicht aktiviert abbruch
	 if ( bInterrupted ) return ;
	 if ( !bMeasurementActive ) return ;
	 //! ab hier ablauf bei laufendem AreaScan
	//! Monitorintensitaet ermitteln und sich merken (in static-var.) bis
	//! Messdetektor auch fertig ist
	 if (ReportUse.bMonitor)
		if ( lParam == Monitor->GetId() )
		  {
				Monitor->GetData( fMonitorSignal );
				return ;
		  }

	 bFileChanged = TRUE;
	 //! position der motoren holen + bei theta offset dazurechnen
	dOmega = mlGetValue( nOmega, Distance );
	 dTheta = mlGetValue( nTheta, Distance );
	 //! o-t-offset in reale Motorpositionen einrechnen
	 x = ( float ) (dOmega + dOffsetOmega);
	 // Theta will be stored in absolute Koordinates
	 y = ( float ) (dTheta + dOffsetTheta - dThetaOffset);

	 //***************************************************************************
	 //**** Datenbasis aktualisieren *********************************************
	 //***************************************************************************
	 //! erste Messung(erstes Spektrum wird nicht benutzt) weil Datenbasis schon
	 //! mit einer Kurve init. wurde
	 if ( bFirstScan )
		  nNumOffs = ( Device->bDataValid ) ? 0 : 0;
	 else
		  nNumOffs = ( Device->bDataValid ) ? 0 : 1;
	 switch ( eScanType )
	 {
		  //! Omega2Thetascan
	 case Omega2ThetaScan:
		  //###########################################################
		  //! Scan mit Psd
		  if ( bPsdDevice )
		  {
				//! wenn Detektordaten gueltig
				//! wenn nicht 1.Spektrum in Datenbasis neues Spektrum hinzufuegen
		 //! Spektrum + integr. vom detektor holen
			 MainCurve = lpDBase->GetCurve( 10000 );
		 Device->GetData( *MainCurve );
			 Device->GetData( integral );
				if ( Device->bDataValid )
					  {
					  bFileChanged = TRUE;
					  //! neues Spektrum in datei speichern bei kont. Speichern
					  if ( bSaveContinuous )
						  UpdateFile();
					  //! nur wenn Messzeit abgelaufen kurve in Datenbasis
					  //! speichern und Datenbasis vergroessern
					  lpDBase->AddCurve( MainCurve->GetPNumber() );
					  nActiveScan = lpDBase->GetCNumber() - 1;
					  }
		  //! Kurve + integrale Int. vom Detektor holen + Kurve in Datenbasis
		//! Thetawinkel der Peakpos. holen*/
		  //! absorberposition ermitteln
				if (ReportUse.bAbsorber )
					 absorber = mlGetValue( mlGetIdByName( Absorber ), Distance );
				else
					 absorber = Device->GetMaximumChannel();

				MainCurve->GetGravityCenter( psdtheta, intens, peakpos, 2 );
				psdtheta += y;
				//! in abhaengigkeit von der eingestellten Reportart zum Spektrum die
					 //! omega- , Thetapos. sowie den jeweiligen Reportwert im Scanreport
				//! speichern ueberfluessig (wahrscheinlich als Erweiterung geplant)
				if ( Device->bDataValid )
				{
				  time = Device->dRealTime;
				  //! monitordet. reset
				  if (ReportUse.bMonitor)
						 Monitor->MeasureStop();
				  else
						 fMonitorSignal=0.0;
				  //! Zusatzinfos anlegen
				  ScanReport->PAdd( x,y,integral);
				  ScanReport2->PAdd( time, fMonitorSignal,absorber);
				  //! naechste pos. anfahren
				  Steering.DeviceRequest();
				}
		  }
		  //###########################################################
		  //! Scan mit 0-dim. Detektor
		  else
		  {
				//! im ersten schritt keine neue Kurve in Datenbasis
				if ( bFirstScan )
					 bFirstScan = FALSE;
				else
					 //! wenn 0-dim. detektor ueber gesamten Thetabereich gelaufen dann
					 //! eine neue Kurve in Datenbasis
					 if ( bThetaScanCompleted )
					 {
						  bThetaScanCompleted = FALSE;
						  //! bei kont. speichern akt. maincurve an datei anhaengen
						  //! FIX Fehler 34
						  if ( bSaveContinuous )
							  UpdateFile();
						  // save data about last scan
						  //! FIX Fehler 30,40
							MainCurve->SetPP(0);
							MainCurve->PGet(x2,y2,z2);
				  //! neu info
							//!MainCurve->GetGravityCenter(intens,intens,peakpos,2);
							ScanReport->PAdd(z2,x2,intens=0);
						  lpDBase->AddCurve( MainCurve->GetPNumber() );
						  MainCurve = lpDBase->GetCurve( 10000 );
						  nActiveScan = lpDBase->GetCNumber() - 1;
					 }
				//! intens.wert vom Detektor holen + an Kurve anhaengen
				Device->GetData( intens );
				//! FIX Fehler 30,40
				MainCurve->PAdd( y, intens, x );
				bFileChanged = TRUE;

				//! naechste pos. anfahren
				Steering.DeviceRequest();
		  }
		  break;

		  //#######################################################################
	 case StandardScan:
		  //! standardscan nur mit Psd erlaubt
		  if ( !bPsdDevice ) return ;
		  //! wenn Detektordaten gueltig
		  //! wenn nicht 1.Spektrum in Datenbasis neues Spektrum hinzufuegen
		//! Spektrum + integr. vom detektor holen
		  MainCurve = lpDBase->GetCurve( 10000 );
		Device->GetData( *MainCurve );
		  Device->GetData( integral );
		  if ( Device->bDataValid )
		  {
			bFileChanged = TRUE;
			//! neues Spektrum in datei speichern bei kont. Speichern
			if ( bSaveContinuous )
				 UpdateFile();
		//! nur wenn Messzeit abgelaufen kurve in Datenbasis
		//! speichern und Datenbasis vergroessern
					 lpDBase->AddCurve( MainCurve->GetPNumber() );
					 nActiveScan = lpDBase->GetCNumber() - 1;
		  }
		  //! Kurve + integrale Int. vom Detektor holen + Kurve in Datenbasis
	 //! absorberposition ermitteln
		if ( ReportUse.bAbsorber )
				absorber = mlGetValue( mlGetIdByName( Absorber ), Distance );
		  else
				absorber = Device->GetMaximumChannel();


		  //! Thetawinkel der Peakpos. holen
		  MainCurve->GetGravityCenter( psdtheta, intens, peakpos, 2 );
		  psdtheta += y;
		  //! in abhaengigkeit von der eingestellten Reportart zum Spektrum die
		  //! omega- , Thetapos. sowie den jeweiligen Reportwert im Scanreport
		  //! speichern ueberfluessig (wahrscheinlich als Erweiterung geplant)
		  if ( Device->bDataValid )
		  {
		  //! neu info
		//! monitordet. reset
		  if (ReportUse.bMonitor)
			Monitor->MeasureStop();
		  else
			fMonitorSignal=0.0;
		  time = Device->dRealTime;
		//! zusatzinfos anlegen
		  ScanReport->PAdd(x,y,integral);
		  ScanReport2->PAdd(time, fMonitorSignal,absorber);

				//! naechste pos. anfahren
				Steering.DeviceRequest();
		  }
		  break;
	 }
	 //***************************************************************************
	 //**** Anzeige fuer Signalaufbau aktualisieren ******************************
	 //***************************************************************************
	 //! UpdateWindow:
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  //! Anzeige bei 0-dim.Det.
		  if ( !bPsdDevice )
		  {
				//! string fuer Statusleiste erstellen
				sprintf( fmt, szMsgLine001, szODF, szTDF );

				sprintf( buf, fmt, x, y, intens );

				//! wenn akt. Kurve keine Punkte dann Fenster neuzeichnen sonst den
				//! neuen Punkt der Kurve einzeichnen
				if ( 1 == MainCurve->GetPNumber() )
					 UpdateWnd( 0 );
				else
					 UpdateWnd( O_PaintPoint );
		  }
		  //! Anzeige bei Psd
		  else
		  {
				//! string fuer Statusleiste erstellen
#ifdef GermanVersion
				sprintf( fmt, "Messung laeuft! O:%s T:%s", szODF, szTDF );
				sprintf( buf, "%s P(%s<>%%.1f) Gesamt-Intensitaet:%%.1f > %%d", fmt,
							szTDF );
#else
				sprintf( fmt, "Measurement ! O:%s T:%s", szODF, szTDF );
				sprintf( buf, "%s P(%s<>%%.1f) Integral Intensity:%%.lf > %%d", fmt,
							szTDF );
#endif
				strcpy( fmt, buf );
        nNumOffs += lpDBase->GetCNumber() - 1;
				if ( bSecondaryCoor )
					 sprintf( buf, fmt, x, y, peakpos, intens, integral,
								 nNumOffs );
				else
					 sprintf( buf, fmt, x, y, psdtheta, intens, integral,
								 nNumOffs );
				//! neue Kurve zeichnen
				UpdateWnd( 0 );
				//! wenn integr. Int. zu hoch dann Overflow ausgeben
				if ( Device->IsSoftOverflow() )
					 strcat( buf, " Overflow !" );
		  }
		  break;

	 case StandardScan:
		  //! nur fuer Psd erlaubt
		  if ( !bPsdDevice ) return ;
		  //! string fuer Statusleiste erstellen
		  sprintf( fmt, szMsgLine009, szODF );
		  sprintf( buf, szMsgLine010, fmt, szTDF );
		  strcpy( fmt, buf );
				nNumOffs += lpDBase->GetCNumber() - 1;
		  if ( bSecondaryCoor )
				sprintf( buf, fmt, x, peakpos, intens, integral, nNumOffs );
		  else
				sprintf( buf, fmt, x, psdtheta, intens, integral, nNumOffs );
		  //! neue Kurve zeichnen
		  UpdateWnd( 0 );
		  //! wenn integr. Int. zu hoch dann Overflow ausgeben
		  if ( Device->IsSoftOverflow() )
				strcat( buf, " Overflow !" );
	 }
	 //! String in Statusleiste schreiben
	 SetInfo( buf );
};

//! wird augerufen nachdem AreaScan abgeschlossen wurde
//! aus m_main.cpp bei cm_SteeringReady
void TAreaScan::SteeringReady( LPARAM lParam )
{
	 char buf[ MaxString ];

	 // Funktion behandelt Meldung cm_CmdExecuted
	 bMeasurementActive = FALSE;
	 //! FIX Fehler 78
	 UpdateMenu();
	 Device->MeasureStop();
	 // Scan wurde ausgefuehrt
	 switch ( HIWORD( lParam ) )
	 {
	 case R_Failure:
		  sprintf( buf, szMsgLine020, LOWORD( lParam ) );
		  MessageBox( hWndChild, buf, szMsgFailure, MB_OK );
		  break;

		  //! keine Fehler aufgetreten
	 default:
      //! neu akk
      //! letztes Spektrum bei Scan mit Psd wieder loeschen
      //! es wird immer eins zuviel angelegt
      if( bPsdDevice)
       lpDBase->DelCurve();
		  //! Info in Statusleiste
			sprintf( buf, szMsgLine011, lpDBase->GetCNumber() );
		  SetInfo( buf );
		  //! FIX Fehler 30,40
		  switch (eScanType){
		  case Omega2ThetaScan:if (!bPsdDevice)
										  {
										  //! die Werte zu der letzten Scankurve in Report-
										  //! kurve ablegen
										  //! FIX Fehler 30,40
											float x2,y2,z2,intens/*,peakpos*/;
											MainCurve->SetPP(0);
											MainCurve->PGet(x2,y2,z2);
											ScanReport->PAdd(z2,x2,intens=0);
											bFileChanged = TRUE;
											//! letztes Spektrum in datei speichern bei kont. Speichern
											if ( bSaveContinuous )
												 UpdateFile();
											}
										break;

		  default: ;
		  }
		  //! wenn savecont. ausgewaehlt dann Headerinfo aktualisieren + Scanreport
		  if ( bSaveContinuous )
				// Header aktualisieren
		  {
				SaveMeasurementInfo( 1 );
				SaveReport();
		  }
				//! FIX Fehler 76
				if ( bSaveOnReady )
					 if ( SaveFile( NoAskForSave ) )
						  sprintf( buf, szMsgLine012 );
					 else
						  sprintf( buf, szMsgLine019 );
				//! FIX Fehler 76
				else if( bSaveContinuous )
						  sprintf( buf, szMsgLine012 );
					  else
						  sprintf( buf, szMsgLine018 );
				MessageBox( hWndChild, buf, szMessage, MBINFO );
		  }
	 //! Detektor stoppen
	 Device->MeasureStop();
	 Device->PopSettings();
	 Device->SetHost( NULL );


};

//! diese Fkt. schaltet die kont. Spektrumsanzeige fuer Psd an oder aus
//! 1.Param. type== PsdEnergyData(3000) => kont. EnergieSpektrum an/aus
//! PsdPositionData(3001) => kont. ImpulsSpekrum an/aus
//! (99) => schaltet kont. Spektrum aus
//! (0) => schaltet kont.Spektrum aus und dieses spaeter
//! wieder ein
//! nicht implementiert aber benutzt
void TAreaScan::ShowSensorContinuous( int type )
{
	 //! Variable merkt sich Art des eingest. kont. Spektrum
	 static int datatype;
#ifdef GermanVersion
	 char HeadLine[] = "Psd-Spektrum anzeigen";
#else
	 char HeadLine[] = "Show Psd-Spectrum";
#endif
	 TCurve* dummy = new TCurve(100);
	 char msg[ MaxString ];

	 //! kont. Anzeige nur bei Kurvendarst. erlaubt
	 if ( eOutputType != Curve )
	 {
		  strcpy( msg, szMsgLine027 );
		  MessageBox( hWndChild, msg, HeadLine, MBSTOP );
		  return ;
	 }
	 if ( type == 99 )
		  type = datatype;
	 //! kont. Anzeige nur fuer Psd erlaubt
	 if ( !dlIsDeviceValid( PsdDevice ) )
	 {
		  MessageBox( GetFocus(), szMsgLine024, szMessage, MBINFO );
		  return ;
	 }
	 bShowPsdContinuous = !bShowPsdContinuous;
	 lpDList->SetDevice( dlGetIdByName( PsdDevice ) );
	 SetDevice( dlGetDevice() );
	 Device->MeasureStop();
	 //! kont. Anzeige soll aktiviert werden
	 if ( bShowPsdContinuous )
	 {
		  //! FIX Fehler 46
		  MainCurve = dummy;
		  // Eingeschraenkte Aufloesung einstellen
		  Device->SetSignalGrowUp( FALSE );
		  Device->SetHost( hWndChild );
		  bSecondaryCoor = TRUE;
		  //! speichern der aktivierten Spektrumsart
		  datatype = type;
		  //! Anzeigeart an Psd uebergeben und im Menue kennzeichnen
		  switch ( type )
		  {
		  case PsdEnergyData:
				Device->SetDataType( PsdEnergyData );
				CheckMenuItem( TheMenu, cm_ShowPsdE_Data, MF_CHECKED );
				break;

		  case PsdPositionData:
				Device->SetDataType( PsdPositionData );
				CheckMenuItem( TheMenu, cm_ShowPsdP_Data, MF_CHECKED );
		  }
		  Device->MeasureStart();
	 }
	 //! kont. Anzeige soll ausgeschaltet werden
	 else
	 {
		  //*** switch off visialising
		  //! anwaehlen einer kont. Darstellungsart wenn eine andere bereits aktiv
		  //! ist verhindern
		  //! FIX Fehler 46
		  MainCurve = lpDBase->GetCurve(nActiveScan);
      delete dummy;
		  if ( datatype != type )
		  {
				bShowPsdContinuous = !bShowPsdContinuous;
				Device->MeasureStart();
				strcpy( msg, szMsgLine017 );
				MessageBox( hWndChild, msg, HeadLine, MBINFO );
				return ;
		  }
		  //! alte Werte in Psd zuruecksetzen und im Menue Kennzeichnung entfernen
		  Device->PopSettings();
		  Device->SetHost( NULL );
		  Device->MeasureStart();
		  bSecondaryCoor = FALSE;
		  UpdateWnd( 0 );
		  if ( type == PsdEnergyData )
		  {
				CheckMenuItem( TheMenu, cm_ShowPsdE_Data, MF_UNCHECKED );
				Device->SetDataType( PsdPositionData );
		  }
		  else
				CheckMenuItem( TheMenu, cm_ShowPsdP_Data, MF_UNCHECKED );
	 }
};

//! aufruf aus CallLocalAction zur PsdCalibrierung
//! FIX Fehler 35
void TAreaScan::CalibratePsd( void )
{
	 char buf[ MaxString ];
	 HWND holddp;
	 TModalDlg* dlg;
	 BOOL bsCoor;
	 TCurve* dummy = new TCurve(100);//!

	 //! nur wenn Thetamotor und Psd verfuegbar
	 if ( !mlIsAxisValid( Theta ) || !dlIsDeviceValid( PsdDevice ) )
	 {
		  strcpy( buf, szMsgLine021 );
		  MessageBox( hWndChild, ( LPSTR ) buf, szMsgFailure, MB_OK );
		  return ;
	 }
	 if ( bShowPsdContinuous )
	 {
		  ShowSensorContinuous( 0 );
		  return ;
	 }
   //! FIX Fehler 46
	 MainCurve = dummy;
	 bCalibrationActive = TRUE;
	 lpDList->SetDevice( dlGetIdByName( PsdDevice ) );
	 SetDevice( dlGetDevice() );
	 //! kont.Anzeige wieder aktivieren + Kanaldarstellung waehlen
	 bShowPsdContinuous = TRUE;
	 holddp = Device->GetDisplay();
	 Device->SetDisplay( hWndChild );
	 Device->SetSignalGrowUp( FALSE );
	 bsCoor = bSecondaryCoor;
	 bSecondaryCoor = TRUE;
	 //! Calibrierungsdialogbox
	 dlg = ( TCalibratePsd* ) new TCalibratePsd( *MainCurve );
	 dlg->ExecuteDialog( hWndChild );
	 delete dlg;
	 //! alt // lpDList->CalibrateDlg(*MainCurve);
	 //! kont.Anzeige aus +alte Achsenbeschriftung
	 bShowPsdContinuous = FALSE;
   //! FIX Fehler 46
	 MainCurve = lpDBase->GetCurve(nActiveScan);
   delete dummy;
	 bSecondaryCoor = bsCoor;
	 bCalibrationActive = FALSE;
	 Device->SetDisplay( holddp );
	 Device->MeasureStart();
   UpdateWnd(0);
};

//! ??
//! Aufruf aus CallLocalAction bei ExternalSync
//! Dialogbox unvollstaendig + gesamte Funktionalitaet ExternalSync nur in
//! Ansaetzen implementiert
void TAreaScan::ExternSychronized( void )
{
	 char buf[ MaxString ];
	 HWND holddp;
	 TModalDlg* dlg;
	 BOOL bsCoor, bshowpsd;

	 //! nur wenn Thetamotor und Psd verfuegbar
	 if ( !mlIsAxisValid( Theta ) || !dlIsDeviceValid( PsdDevice ) )
	 {
		  strcpy( buf, szMsgLine021 );
		  MessageBox( hWndChild, ( LPSTR ) buf, szMsgFailure, MB_OK );
		  return ;
	 }
	 //! ??
	 lpDList->SetDevice( dlGetIdByName( PsdDevice ) );
	 SetDevice( dlGetDevice() );
	 holddp = Device->GetDisplay();
	 Device->SetDisplay( hWndChild );
	 Device->SetSignalGrowUp( TRUE );
	 bshowpsd = bShowPsdContinuous;
	 bsCoor = bSecondaryCoor;
	 bSecondaryCoor = TRUE;
	 //! aufruf der Dialogbox
	 dlg = ( TPsdRemoteSync* ) new TPsdRemoteSync( *MainCurve );
    dlg->ExecuteDialog( hWndChild );
    delete dlg;
    bSecondaryCoor = bsCoor;
    Device->SetDisplay( NULL );
	 if ( bshowpsd )
        ShowSensorContinuous( 0 );
    else
    {
        Device->SetDisplay( holddp );
        Device->MeasureStart();
    }
};

//! Fkt. wird bei unterbrechen/fortsetzen eines AreaScans aufgerufen oder zum
//! ausschalten einer kont. Anzeige
void TAreaScan::Interrupt()
{
    //! kont. Anzeige ausschalten wenn aktiv
	 if ( bShowPsdContinuous )
	 {
        ShowSensorContinuous( 99 );
        return ;
    }
    //! nur wenn AreaScan laeuft oder unterbrochener AreaScan existiert
    if ( !bMeasurementActive )
		  return ;
    //! Hauptmenueeintrag aendern
	 TMDIWindow::Interrupt();
    if ( !bInterrupted )
    {
        // Messung weiterfueren
        Steering.ToggleInterrupt();
		  bNewCurveNeeded = FALSE;
    }
    else
    {
        //! Messung unterbrechen + in Statusleiste anzeigen
        Steering.ToggleInterrupt();
        SetInfo( szMsgLine013 );
    }
};

//******************* Read/Write **********************************************

//! Zusammensetzen einer Datenbasis
BOOL TAreaScan::ComposeDB( void )
{
	TModalDlg * dlg;
	const int LLength = 2500;
	LPSTR lpBuf;
	char buf[ MaxString ];
	float x, x2, x3, y, z, z2, z3;
	int hFile, cnt, idx, idx2;
	OFSTRUCT of;
	char name[ MaxString ], oldname[ MaxString ];
	BOOL bReady = FALSE;
	TCurve * TheCurve;
	float dummy;
  HCURSOR hCursor;

  //! Aufruf des Dialoges DB zusammensetzen
	MaxFiles = 0;
	dlg = ( TComposeDB * ) new TComposeDB( this );
	dlg->ExecuteDialog( hWndChild );
	delete dlg;
  //! wenn Zahl der Kurven groesser 0
	if( MaxFiles>0 )
	{
   hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 bComposeDB = TRUE;
	 bFileChanged = TRUE;
   //! neue DB
	 lpDBase->New();
	 nActiveScan = 0;
	 TheCurve = lpDBase->GetCurve( nActiveScan );
	 strcpy( name, FirstFile );
	 name[ strlen( name )-8 ]='\0';
	 strcpy( oldname, name );
	 idx=idx2=atoi( &FirstFile[ strlen( FirstFile ) - 8 ] );
   //! neuer Scan-Report
	 ScanReport->New();
   //! fuer jede Kurve Datei oeffnen + Header einlesen + Datenaufnahme
	 for( idx; idx<(idx2+MaxFiles); idx++ )
	 {
		strcpy( name, oldname );
		sprintf( buf, "%.4d.crv", idx );
		strcat( name, buf );
	 SetInfo(name);
		hFile = OpenFile( name, &of, OF_READ );
		LoadMeasurementInfo( hFile );
		nActiveScan = lpDBase->GetCNumber() - 1;
		TheCurve = lpDBase->GetCurve( 10000 );
		lpBuf = new char [ LLength ];
		if ( !SetFPOnData( hFile ) )
     {
      SetCursor(hCursor);
      return FALSE;
     }
		bReady = FALSE;
		for ( cnt = 0; !bReady ; cnt++ )
		  switch ( GetFileLine( hFile, lpBuf, LLength ) )
		  {
			case R_Overflow:
				cnt++;
				bReady = TRUE;
				continue;
			case R_EndOfFile:
				cnt++;
				bReady = TRUE;
			default:
				if( 3 != sscanf( lpBuf, "%f %f %f", &x, &y, &z ) ) continue;
				if( cnt==0 ) x2 = x;
				if( VisualDB.bPsd ) x-=x2;
				TheCurve->PAdd( x, y, z );
		  }
		if( idx<(idx2+MaxFiles)-1 )
			lpDBase->AddCurve( TheCurve->GetPNumber() );
		_lclose( hFile );
		TheCurve->GetGravityCenter(dummy, y, dummy,2);
		ScanReport->PAdd( z, x2 , y );
		delete[] lpBuf;
	 }
   //! erste Datei wiederholt lesen
   //! Bestimmung der Report-Informationen fuer Omega, Theta, Relation, Schritt,..
	 hFile = OpenFile( FirstFile, &of, OF_READ );
	 LoadMeasurementInfo( hFile );
	 _lclose( hFile );
	 ScanReport->SetPP( 0 );
	 ScanReport->PGet(x, z, y);
	 ScanReport->SetPP( 1 );
	 ScanReport->PGet(x2, z2, y);
	 ScanReport->SetPP( ScanReport->GetPNumber() );
	 ScanReport->PGet(x3, z3, y);
	 if( VisualDB.bPsd )
	 {
		if( nLastReadColumn > 0 )
			nAddedChannels = 4096/(nLastReadColumn+1);
		else
			nAddedChannels = 1;
		VisualDB.dOmegaMin = dOmegaMin = x;
		VisualDB.dOmegaMax = dOmegaMax = x3;
		dThetaMin = d2ThetaStart = z;
		dThetaMax = z3;
		dOmegaWidth = ( x3 - x ) / ( lpDBase->GetCNumber()-1 );
		dThetaWidth = ( z3 - z ) / ( lpDBase->GetCNumber()-1 );
		dMoveRelation = VisualDB.dMoveRelation = dThetaWidth / dOmegaWidth;
		TheCurve = lpDBase->GetCurve( 0 );
		TheCurve->SetPP( 0 );
		TheCurve->PGet(x, y, z);
		TheCurve->SetPP( 1 );
		TheCurve->PGet(x2, y, z);
		VisualDB.fAngleStep = x2 - x;
		VisualDB.fAngleRange = VisualDB.fAngleStep * TheCurve->GetPNumber();
	 }
	 else
	 {
		VisualDB.dOmegaMin = dOmegaMin = x;
		VisualDB.dOmegaMax = dOmegaMax = x3;
		dThetaMin = d2ThetaStart = z;
		dThetaMax = z3;
		dOmegaWidth = ( x3 - x ) / ( lpDBase->GetCNumber()-1 );
		dThetaWidth = ( z3 - z ) / ( lpDBase->GetCNumber()-1 );
		dMoveRelation = VisualDB.dMoveRelation = dThetaWidth / dOmegaWidth;
		TheCurve = lpDBase->GetCurve( 0 );
		TheCurve->SetPP( 0 );
		TheCurve->PGet(x, y, z);
		TheCurve->SetPP( TheCurve->GetPNumber() );
		TheCurve->PGet(x2, y, z);
		VisualDB.dThetaWindow = x2 - x;
    VisualDB.fAngleStep = VisualDB.dThetaWindow / (TheCurve->GetPNumber()-1);
		VisualDB.fAngleRange = VisualDB.dThetaWindow;
	 }
	 VisualDB.dThetaMinFirst = dThetaMin;
   if (dThetaWidth!=0)
	  VisualDB.dThetaMinLast = dThetaMin + (dOmegaMax-dOmegaMin)*dMoveRelation;
   else
    VisualDB.dThetaMinLast = dThetaMin;
	 VisualDB.dThetaMaxFirst = dThetaMin + VisualDB.fAngleRange;
	 VisualDB.dThetaMaxLast =  VisualDB.dThetaMinLast+ VisualDB.fAngleRange;
   //! Fenster-Aktualisierung + DB-Zusammenfassung deaktiviert
	 UpdateWnd( 0 );
	 bComposeDB = FALSE;
   SetCursor(hCursor);
	}
	return TRUE;
};

//! Sichern einer aktuellen Kurve der DB in crv-Datei
BOOL TAreaScan::SaveDismantleCurve( int counter )
{
	int hFile;
	OFSTRUCT of;
	UINT nSize;
	char format[ MaxString ];
	char buf[ 2 * MaxString ], buf2[ 20 ], buf3[ 20 ], fmt[ 30 ];
	char *data;
	const int dataoffset = 1000;
//	struct date d;
//	struct time t;
    SYSTEMTIME st;
	float v, x, y, z, fOmega, fTheta;


	//! Dateinamen anlegen
	sprintf( buf, "%.4d.crv", counter );
	strcpy( FileName, szDataPath );
	strcat( FileName, DismantleFile );
	strcat( FileName, buf );
  SetInfo(FileName);
	//! Kurve auslesen
	MainCurve = lpDBase->GetCurve( counter );
	ScanReport->SetPP( counter );
	ScanReport->PGet( fOmega, fTheta, z );
	MainCurve->SetPP( 0 );
  //! Datei anlegen + Header
	hFile=OpenFile(FileName,&of,OF_CREATE);
	if(-1==hFile) return FALSE;
  _llseek (hFile, 0, 2 );
	sprintf( fmt, "%s %s %s\r\n", mGetSF(), "%.4f", "%.4f" );
	MainCurve->FastOpen();
    GetLocalTime( &st );
	data = new char[ dataoffset + 1 ];
	strcpy( format, "Comment=%s" );
	sprintf( buf, format, Main.Comment );
	strcpy( data, buf );
	strcat( data, EOL );
	strcat( data, "[Header]" );
	strcat( data, EOL );
  //! Neu im Header: Zerlegungs-Information
	if( VisualDB.bPsd )
		strcat( data, "Zerlegung=PSD" );
	else
		strcat( data, "Zerlegung=SLD" );
	strcat( data, EOL );
	strcpy( format, "User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d DataOffset=%d" );
	sprintf( buf, format, Main.User, (int)st.wDay, (int)st.wMonth, (int)st.wYear, (int)st.wHour, \
			 (int)st.wMinute, (int)st.wSecond, dataoffset );
	strcat( data, buf );
	strcat( data, EOL );
	strcpy( format, "Point_Number=%d FileType=Standard" );
	sprintf( buf, format, MainCurve->GetPNumber());
	strcat( data, buf );
	strcat( data, EOL );
	strcpy( format, "Target=%s Reflection=%s Orientation=%s" );
	GetHKL( Main.Reflection, buf2 );
	GetHKL( Main.Orientation, buf3 );
	sprintf( buf, format, Main.Target, buf2, buf3 );
	strcat( data, buf );
	strcat( data, EOL );
	sprintf( format, "ArgumentMin=%s ArgumentWidth=%s ArgumentMax=%s Scanaxis=Theta", mGetDF(),
			 mGetSF(), mGetDF() );
	if( VisualDB.bPsd )
		sprintf( buf, format, fTheta+MainCurve->Min[0]*VisualDB.fAngleStep,
			(MainCurve->Max[0]-MainCurve->Min[0])/MainCurve->GetPNumber()
			, MainCurve->Max[0]+fTheta);
	else
		sprintf( buf, format, MainCurve->Min[0], dThetaWidth, MainCurve->Max[0]);
	strcat( data, buf );
	strcat( data, EOL );
	strcpy( format, "WaveLength=%.3f Current=%d HV=%d" );
	sprintf( buf, format, Main.WaveLength, Main.Current, Main.Voltage );
	strcat( data, buf );
	strcat( data, EOL );
	strcpy( format, "TimePerScan=%.2f" );
	sprintf( buf, format, fMaxTime );
	strcat( data, buf );
	nSize = strlen( data );
	for ( ; nSize < dataoffset - 10; nSize++ )
	  data[ nSize ] = ' ';
	data[ nSize ] = 0x0;
	strcat( data, EOL );
	strcat( data, "[Data]" );
	strcat( data, EOL );
	_lwrite(hFile,data,strlen(data));
	while ( MainCurve->FastPGet( x, y, z ) )
	{
	 if( VisualDB.bPsd )
	 {
		x+=fTheta;
	 }
	 ScanReport->SetPP( counter );
	 ScanReport->PGet( z, v, v );
	 sprintf( buf, fmt, x, y, z );
	 _lwrite( hFile, buf, strlen( buf ) );
	}
	_lclose(hFile);
	MainCurve->FastClose();
	delete[] data;
  bFileChanged=FALSE;
	return TRUE;
};

//! Zerlegen der DB
BOOL TAreaScan::DismantleDB( void )
{
	TModalDlg * dlg;
  HCURSOR hCursor;

  //! Dialogboxaufruf
	dlg = ( TDismantleDB * ) new TDismantleDB( this );
	dlg->ExecuteDialog( hWndChild );
	delete dlg;

	//! alle Kurven durchlaufen und einzeln speichern
  hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	if( strcmp( DismantleFile, "" ) )
		for( int counter=0; counter<lpDBase->GetCNumber(); counter++ )
			if (!SaveDismantleCurve( counter )) break;
  SetCursor(hCursor);
	return TRUE;
};

//! ?
//! Rueckkehrcode bei ShiftedStandard ist die Anzahl der Psd-kanaele die
//! benoetigt werden um den Thetabereich zu ueberdecken
//! sonst immer 0
int TAreaScan::GetAdditionalColumns( void )
{
    if ( eSaveFormat != ShiftedStandard )
        return 0;
    if ( dOmegaWidth == 0.0 )
        return 0;
    return GetShift( ( ( dOmegaMax - dOmegaMin ) / dOmegaWidth ) + 1 );
};

//! Funktion liefert zu Anzahl der Scans (1.Parameter) Anzahl der Psd-kanaele
//! die benoetigt werden um den Thetabereich zu ueberdecken
//! (nur bei ShiftedStan.) sonst 0 als Rueckkehrcode
int TAreaScan::GetShift( int ScanNumber )
{
	 if ( Device->GetWidth() == 0.0 )
        return 0;
    if ( eScanType == StandardScan )
        return 0;
    return ScanNumber * ( dOmegaWidth * dMoveRelation ) / Device->GetWidth();
};


//! Funktion speichert Headerinformationen zu einem Areascan in einer Datei
//! 1.Parameter gibt an, ob die Datei neu erstellt(=0) werden soll oder nur
//! aktualisiert (ungl. 0) werden soll
//! Rueckkehrcode false wenn probleme beim erstellen bzw. oeffnen der Datei
//! sonst immer true
BOOL TAreaScan::SaveMeasurementInfo( BOOL UpdateHeader )
{
	 int hFile;
	 UINT nSize;
	 char *data;
	 TCurve* Report = lpDBase->GetScanReport();
	 char buf[ MaxString + 1 ], buf2[ MaxString / 2 ], buf3[ MaxString / 2 ];
	 char format[ 2 * MaxString + 1 ];
	 int dataoffset = 1000, ival;
	 OFSTRUCT of;
//	 struct date d;
//	 struct time t;
     SYSTEMTIME st;

	 //! oeffnet oder erstellt Datei + wenn Fehler dann Meldung + abbruch
	 if ( UpdateHeader )
		  hFile = OpenFile( FileName, &of, OF_WRITE );
	 else
		  hFile = OpenFile( FileName, &of, OF_CREATE );
	 if ( -1 == hFile )
	 {
		  LoadString( Main.hInstance, sth_CannotOpenFile, buf, MaxString );
		  MessageBox( GetFocus(), buf, szMsgFailure, MB_OK | MB_ICONSTOP );
		  return FALSE;
	 }
	 //! Systemzeit + datum holen
	 GetLocalTime( &st );
	 //! Headerinformationen in String kopieren
	 data = new char[ 1001 ];
	 strcpy( format, "Comment=%s" );
	 sprintf( buf, format, Main.Comment );
	 strcpy( data, buf );
	 strcat( data, EOL );

	 strcat( data, "[Header]" );
	 strcat( data, EOL );
	 strcpy( format, "User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d" );
	 sprintf( buf, format, Main.User, (int)st.wDay, (int)st.wMonth, (int)st.wYear, (int)st.wHour, \
				 (int)st.wMinute, (int)st.wSecond );
	 strcat( data, buf );
	 strcat( data, EOL );

	 switch ( eSaveFormat )
	 {
		  //! Fehler tripel nicht moeglich
	 case Tripel:
		  strcpy( format, "Scan_Number=%d Point_Number_per_Scan=%d FileType=%d" );
		  break;

	 default:
		  strcpy( format, "DataRows=%d DataColumns=%d FileType=%d" );
		  // HD 960106
		  strcat( format, EOL );
		  strcat( format, "FirstColumn=0 LastColumns=%d" );
	 }
	 ival = lpDBase->GetCurve( 0 ) ->GetPNumber() + GetAdditionalColumns();
	 sprintf( buf, format, lpDBase->GetCNumber(), ival, ( BOOL )
				 ( eSaveFormat == StandardFile ), ival - 1 );
	 strcat( data, buf );
	 strcat( data, EOL );

	 // aktuelle Bereiche abspeichern
	 sprintf( format, "OmegaMin=%s OmegaStep=%s OmegaMax=%s", szODF, szOWF,
				 szODF );
	 sprintf( buf, format, Report->Min[ P_X ], dOmegaWidth, Report->Max[ P_X ] );
	 strcat( data, buf );
	 strcat( data, EOL );
	 sprintf( format, "ThetaMin=%s ThetaStep=%s ThetaMax=%s MoveRelation=%%.2f",
				 szTDF, szTWF, szTDF );
   //! in abhaengigkeit von art des Scans haben die Thetaeintraege verschiedene
   //! bedeutungen
	 if(VisualDB.bPsd)//! speichern einer Psd-Datenbasis
	  sprintf( buf, format, Report->Min[ P_Y ]-dPsdOffset,
				  dOmegaWidth * VisualDB.dMoveRelation,
				  Report->Max[ P_Y ]-dPsdOffset,
				  VisualDB.dMoveRelation );
	 else//! speichern einer SLD-DatenBasis mit zentren der Thetawindows als Thetawerte
	  sprintf( buf, format, VisualDB.dThetaMinFirst+0.5* VisualDB.dThetaWindow,
				  dOmegaWidth * VisualDB.dMoveRelation, VisualDB.dThetaMinFirst+0.5*
          VisualDB.dThetaWindow +(Report->GetPNumber()-1)* dOmegaWidth *
          VisualDB.dMoveRelation, VisualDB.dMoveRelation );

	 strcat( data, buf );
	 strcat( data, EOL );

	 strcpy( format, "Target=%s Reflection=%s Orientation=%s" );
	 GetHKL( Main.Reflection, buf2 );
	 GetHKL( Main.Orientation, buf3 );
	 sprintf( buf, format, Main.Target, buf2, buf3 );
	 strcat( data, buf );
	 strcat( data, EOL );
	 strcpy( format, "WaveLength=%.3f Current=%d HV=%d" );
	 sprintf( buf, format, Main.WaveLength, Main.Current, Main.Voltage );
	 strcat( data, buf );
	 strcat( data, EOL );

	 //! in abhaengigkeit vom Detektor (0-dim. oder psd ) Fehler
	 if ( VisualDB.bPsd )
	 {
		  strcpy( format, "TimePerScan=%.2f PsdStep=%.9f PsdAddedChannels=%d MeasurementChannel=%d" );
		  sprintf( buf, format, fMaxTime, (bOldDataLoaded)?VisualDB.fAngleStep:VisualDB.fAngleStep/3600.0
      /* Device->GetWidth()*/, nAddedChannels,
		           nMeasurementChannel );
		  strcat( data, buf );
	 }
	 else
	 {
		  //! FIX Fehler 39
		  strcpy( format, "TimePerScan=%.2f ThetaWindow=%.2f" );
		  sprintf( buf, format, fMaxTime, VisualDB.dThetaWindow );
		  strcat( data, buf );
	 }
	 nSize = strlen( data );
	 //! auffuellen de Strings mit Leerzeichen + ablegen des Strings in der Datei
	 //! + schliessen der Datei
	 for ( ; nSize < dataoffset - 10; nSize++ )
		  data[ nSize ] = ' ';
    data[ nSize ] = 0x0;
    strcat( data, EOL );
    strcat( data, "[Data]" );
    strcat( data, EOL );
    _lwrite( hFile, data, strlen( data ) );
    _lclose( hFile );
    delete[] data;
    return TRUE;
};


//! Funktion speichert einen Messdatensatz
//! 1.Parameter gibt an ob neuer Dateiname zu waehlen ist (SaveWithNewName)
//! oder ob automatisch unter altem Namen (NoAskForSave) gespeichert werden
//! soll
//! Rueckkehrcode False wenn Fehler bei anlegen der Datei oder bei speichern
//! der headerinfos sonst immer true
BOOL TAreaScan::SaveFile( int ask )
{
    HCURSOR hCursor;
    TCurve* TheCurve;
    float fOmega, fIntensity, fPsdTheta, fTheta;
    float d0, d2;
    char *buf, fmt[ MaxString ], msg[ MaxString ];
    int hFile, idx, numbercolumn, nCIdx;
    OFSTRUCT of;

    //! anlegen der Datei (event. mit eingabe des Dateinamen)
    if ( !TMDIWindow::SaveFile( ask ) )
		  return FALSE;
    //*** explicite repaint of window, since it's normally not possible.
    PAINTSTRUCT ps;
    HDC hdc = BeginPaint( hWndChild, &ps );
    Paint( hdc, &ps );
    EndPaint( hWndChild, &ps );
    //****************************
	 //! ueberschreiben der Datei mit Headerinfo.
    if ( !SaveMeasurementInfo( 0 ) )
	 {
        MessageBox( GetFocus(), szMsgLine014, szMsgFailure, MBINFO );
        return FALSE;
	 }
    //! speichern der reportkurve
    SaveReport();
    hFile = OpenFile( FileName, &of, OF_WRITE );
    hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
    // Daten an den Header anhaengen
    _llseek( hFile, 0, SEEK_END );
    // Hier zwischen den einzelnen Formaten waehlen
    switch ( eSaveFormat )
    {
        //! fehler (nur Standard moeglich)
    case ShiftedStandard:
        // 1. Scan ist noch nicht mit gueltigen Daten belegt
        if ( bSaveContinuous && ( 1 == lpDBase->GetCNumber() ) )
            break;
		  buf = new char [ 8 * 3000 ];
		  for ( nCIdx = 0; nCIdx < lpDBase->GetCNumber(); nCIdx++ )
		  {
				sprintf( buf, szMsgLine028, nCIdx + 1,
							lpDBase->GetCNumber() );
				SetInfo( buf );
				TheCurve = lpDBase->GetCurve( nCIdx );
				TheCurve->SetPP( 0 );
				TheCurve->FastOpen();
				numbercolumn = GetAdditionalColumns() + MainCurve->GetPNumber();
				for ( idx = 0; idx < numbercolumn; idx++ )
				{
					 if ( GetShift( nCIdx ) <= idx )
						  if ( TheCurve->FastPGet( d0, fIntensity, d2 ) )
								if ( 0.0 != fIntensity )
								{
									 short pp = 3 - log10( fIntensity );
									 strcpy( fmt, "%.3f " );
									 if ( pp < 0 ) pp = 0;
									 fmt[ 2 ] = ( char ) ( '0' + pp );
									 sprintf( buf, fmt, fIntensity );
									 goto Ready2;
								}
					 sprintf( buf, "0 " );
Ready2:
					 _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
				}
				TheCurve->FastClose();
				strcpy( buf, EOL );
				_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  }
		  delete[] buf;
		  break;

	 case StandardFile:
		  // 1. Scan ist noch nicht mit gueltigen Daten belegt
		  if ( bSaveContinuous && ( 1 == lpDBase->GetCNumber() ) )
				break;
		  buf = new char [ 8 * 3000 ];
		  numbercolumn = lpDBase->GetCurve( 0 ) ->GetPNumber();
		  //! alle Kurven der Datenbasis durchlaufen und jeweils alle Intens.werte
		  //! der Kurve in Datei ablegen
		  for ( nCIdx = 0; nCIdx < lpDBase->GetCNumber(); nCIdx++ )
		  {
				sprintf( buf, szMsgLine028, nCIdx + 1,
							lpDBase->GetCNumber() );
				SetInfo( buf );
				TheCurve = lpDBase->GetCurve( nCIdx );
				TheCurve->SetPP( 0 );
				TheCurve->FastOpen();
				for ( idx = 0; idx < numbercolumn; idx++ )
				{
					 if ( TheCurve->FastPGet( d0, fIntensity, d2 ) )
						  //! formatieren der Intensitaetswerte mit untersch. Genauigkeit
						  while ( 1 )
						  {
								if ( 0.00001 > fIntensity )
								{
									 sprintf( msg, "0 " );
									 break;
								}
								if ( 10.0 > fIntensity )
								{
									 sprintf( msg, "%.4f ", fIntensity );
									 break;
								}
								if ( 100.0 > fIntensity )
								{
									 sprintf( msg, "%.3f ", fIntensity );
									 break;
								}
								if ( 1000.0 > fIntensity )
								{
									 sprintf( msg, "%.2f ", fIntensity );
									 break;
								}
								sprintf( msg, "%.1f ", fIntensity );
								break;
						  }
					 else
						  strcpy( msg, "0 " );
					 if ( 0 == idx )
						  strcpy( buf, msg );
					 else
						  strcat( buf, msg );
				}
				//! ablegen einer Kurve als zeile in Datei
				strcat( buf, EOL );
				TheCurve->FastClose();
				_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  }
		  delete[] buf;
		  break;

		  //! fehler (nur Standard moeglich)
	 case Tripel:
		  // 1. Scan ist noch nicht mit gueltigen Daten belegt
		  if ( bSaveContinuous && ( 1 == lpDBase->GetCNumber() ) )
				break;
		  nCIdx = 0;
		  buf = new char [ MaxString ];
		  ScanReport->SetPP( 0 );
		  ScanReport->FastOpen();
		  sprintf( fmt, "%s %s %s %s", szODF, szTDF, "%.3f", EOL );
		  while ( nCIdx < lpDBase->GetCNumber() )
		  {
				TheCurve = lpDBase->GetCurve( nCIdx );
				TheCurve->SetPP( 0 );
				TheCurve->FastOpen();
				ScanReport->FastPGet( fOmega, fTheta, d2 );
				while ( TheCurve->FastPGet( fPsdTheta, fIntensity, d0 ) )
				{
					 if ( bThetaAddsPsd )
						  fPsdTheta += fTheta;
					 sprintf( buf, fmt, fOmega, fPsdTheta, fIntensity );
					 _lwrite( hFile, buf, strlen( buf ) );
				}
				TheCurve->FastClose();
				nCIdx++;
		  }
		  ScanReport->FastClose();
		  delete[] buf;
		  break;

		  //! fehler (nur Standard moeglich)
	 case Bitmap:
		  ;
	 }
	 //! schliessen der Datei
	 _lclose( hFile );
	 SetCursor( hCursor );
	 bFileChanged = FALSE;
	 return TRUE;
};


//! haengt aktuelles Kurve an Datei mit FileName an
//! aufruf nur bei kontinuierlichem Speichern
//! Rueckkehrcode immer true
BOOL TAreaScan::UpdateFile( void )
{
	 HCURSOR hCursor;
	 TCurve* TheCurve;
	 float fOmega, fIntensity, fPsdTheta, fTheta;
	 float d0, d2;
	 char buf[ MaxString ], fmt[ MaxString ];
	 int hFile, idx, numbercolumn;
	 OFSTRUCT of;
	 //! nicht von Diffr.gruppe auskommentiert
	 //! int nOldId = mlGetAxis();

	 //! Datei oeffnen + Statusinfo ausgeben
	 hFile = OpenFile( FileName, &of, OF_WRITE );
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 _llseek( hFile, 0, SEEK_END );
	 lpDBase->GetCurve( 10000 ) ->SetPP( 0 ); // first point of last curve
	 sprintf( buf, szMsgLine029, lpDBase->GetCNumber() - 1 );
	 SetInfo( buf );
	 switch ( eSaveFormat )
	 {
	 case StandardFile:
		  //! letzte Kurve der Datenbasis auswaehlen + alle Intens.werte der Kurve
		  //! auslesen und als zeile an Datei anhaengen
		  numbercolumn = lpDBase->GetCurve( 0 ) ->GetPNumber();
		  TheCurve = lpDBase->GetCurve( 10000 );
		  TheCurve->FastOpen();
		  TheCurve->SetPP( 0 );
		  for ( idx = 0; idx < numbercolumn; idx++ )
		  {
				if ( TheCurve->FastPGet( d0, fIntensity, d2 ) )
					 //! bestimmt anzahl dez.-stellen und legt Intensitaetswert demenstpr.
					 //! formatiert ab
					 if ( 0.0 != fIntensity )
					 {
						  short pp = 3 - log10( fIntensity );
						  if ( pp < 0 ) pp = 0;
						  strcpy( fmt, "%.3f " );
						  fmt[ 2 ] = ( char ) ( '0' + pp );
						  sprintf( buf, fmt, fIntensity );
						  goto Ready;
					 }
				sprintf( buf, "0 " );
Ready:
				_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  }
		  TheCurve->FastClose();
		  strcpy( buf, EOL );
		  _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  break;

		  //! fehler (nur Standard moeglich)
	 case Tripel:
		  ScanReport->BackStep();
		  ScanReport->PGet( fOmega, fTheta, d2 );
		  TheCurve = lpDBase->GetCurve( 10000 );
		  TheCurve->SetPP( 0 );
		  TheCurve->FastOpen();
		  sprintf( fmt, "%s %s %s %s", szODF, szTDF, "%.3f", EOL );
		  while ( TheCurve->FastPGet( fPsdTheta, fIntensity, d0 ) )
		  {
				if ( bThetaAddsPsd )
					 fPsdTheta += fTheta;
				sprintf( buf, fmt, fOmega, fPsdTheta, fIntensity );
				_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  }
		  TheCurve->FastClose();
	 }
	 //! Datei schliessen
	 _lclose( hFile );
	 SetCursor( hCursor );
	 bFileChanged = FALSE;
	 return TRUE;
};

//! speichert die zur Datenbasis gehoerigen zusatzinfos in einer Datei unter
//! dem aktuellen Dateinamen mit der Extension .rep ab
//! Rueckkehrcode immer true
BOOL TAreaScan::SaveReport( void )
{
	 HCURSOR hCursor;
	 float fOmega, fIntegral, fTheta;
	 char buf[ MaxString *3];
	 char fmt[ MaxString *3];
	 int hFile, cnt;
	 OFSTRUCT of;
	 char fn[ _MAX_PATH ];
	 char drive[ _MAX_DRIVE ], path[ _MAX_DIR ], name[ _MAX_FNAME ], ext[ _MAX_EXT ];


	 //! ermitteln des Dateinamen + anhaengen der Extension .rep + erstellen der
	 //! Datei
	 _splitpath( FileName, drive, path, name, ext );
	 _makepath( fn, drive, path, name, "rep" );
	 hFile = OpenFile( fn, &of, OF_CREATE );
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 //! abhaengig von eingestellter Zusatzinformation Tabellenkopf speichern
   //! neu info
   /*
	 switch ( eNotifyValue )
	 {
	 case MonitorIntensity:
		  sprintf( buf, "# Report: ScanId Omega : Theta : Monitor Signal" );
		  break;
	 case MeasurementTime:
		  sprintf( buf, "# Report: ScanId Omega : Theta : MeasurementTime" );
		  break;
	 case AbsorberPosition:
		  sprintf( buf, "# Report: ScanId Omega : Theta : AbsorberPosition" );
		  break;
	 case PeakPosition:
		  sprintf( buf, "# Report: ScanId Omega : Theta : PeakPosition" );
		  break;
	 default:
	 case IntegralIntensity:
		  sprintf( buf, "# Report: ScanId Omega : Theta : Integral Intensity" );
		  break;
	 } */
   //! Headerteil anlegen in abhaengigkeit von den vorhandenen zusatzinfos
   sprintf(buf,"# Report: ");
   _lwrite( hFile,(LPSTR) buf, strlen( buf ) );
   strcpy( buf, EOL );
  _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
   sprintf(buf,"ScanId : Omega : Theta : MaxIntensity : PeakPosition ");
   if(ReportUse.bIntegral)
     	 strcat( buf,": IntegralIntensity " );
	if(ReportUse.bTime)
     	 strcat( buf,": MeasurementTime " );
   if(ReportUse.bMonitor)
     	 strcat( buf,": MonitorSignal " );
	if(ReportUse.bAbsorber)
     	 strcat( buf,": AbsorberPosition " );
		  _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
       strcpy( buf, EOL );
		  _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
	 ScanReport->SetPP( 0 );

	ScanReport2->SetPP( 0 );
	 cnt = 0;
	 //! alle zusatzinfos in Tabelle speichern +datei schliessen
	 while ( ScanReport->PGet( fOmega, fTheta, fIntegral ) )
	 {
         char buf2[MaxString];
         float fdummy,fPeakPos,fTime,fMonitor,fAbsorber;
         TCurve* DummyCurve = lpDBase->GetCurve( cnt);

         sprintf(fmt, "%d %s %s %.0f %s",cnt,szODF,szTDF,DummyCurve->Max[1],
                 szTDF );
         DummyCurve->GetGravityCenter(fPeakPos,fdummy,fdummy,2);
			ScanReport2->PGet(fTime,fMonitor,fAbsorber);
			  if (VisualDB.bPsd)
			      fPeakPos=fTheta+ fPeakPos;
         if(ReportUse.bIntegral)
        	 {
           sprintf(buf2," %.0f",fIntegral);
			  strcat( fmt,buf2 );}
         if(ReportUse.bTime){
           sprintf(buf2," %.3f",fTime);
     	     strcat( fmt,buf2 );}
         if(ReportUse.bMonitor){
           sprintf(buf2," %.0f",fMonitor);
     	     strcat( fmt,buf2 );}
         if(ReportUse.bAbsorber){
           sprintf(buf2," %.3f",fAbsorber);
     	     strcat( fmt,buf2 );   }

		  sprintf( buf, fmt, fOmega, fTheta, fPeakPos );
		  _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
      strcpy( buf, EOL );
		  _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
      cnt++;
	 }
	 _lclose( hFile );
	 SetCursor( hCursor );
	 return TRUE;
};

//! Funktion laedt die zu einer .psd datei gehoerigen zusatzinfos
//! Rueckkehrcode False wenn Fehler bei oeffnen der Datei, wenn weniger als 15
//! Punkte in der Datei waren oder das vorgefundene Format(Titelzeile) nicht
//! stimmt
//! true sonst
BOOL TAreaScan::LoadReport( void )
{
	 HCURSOR hCursor;
	 float fOmega, fTheta;
	 float fValue[8];
	 HPSTR data;
   HGLOBAL hMem;
	 HFILE hFile;
	 char line[ MaxString*3 ];
	 char wort[MaxString*3];
	 char buf[MaxString*3];
	 int cnt=0,headlength=0;
	int i2,cnt2,cnt3,cnt4;
   float fIntegral=0,fTime=0,fAbsorber=0,fMonitor=0;
	 DWORD wSize;
	 OFSTRUCT of;
   BOOL bEndOfFile=FALSE;
	 char fn[ _MAX_PATH ];
	 char drive[ _MAX_DRIVE ], path[ _MAX_DIR ], name[ _MAX_FNAME ], ext[ _MAX_EXT ];

   //! zusatzinfos reset
   ReportUse.bIntegral=ReportUse.bTime=ReportUse.bMonitor=ReportUse.bAbsorber=FALSE;
	 _splitpath( FileName, drive, path, name, ext );
	 _makepath( fn, drive, path, name, "rep" );
	 hFile = OpenFile( fn, &of, OF_READ );
	 if ( HFILE_ERROR == hFile )
		{
    return FALSE;
    }
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
   _llseek( hFile, 0, 0 );
	 wSize = _llseek( hFile, 0, 2 );
   _llseek( hFile, 0, 0 );
   //! datei-inhalt in speicher
   hMem = GlobalAlloc( GMEM_MOVEABLE, wSize + 100 );
	 data = ( HPSTR ) GlobalLock( hMem );
	 wSize = _hread( hFile, ( HPSTR ) data, wSize );
   data[ wSize - 2 ] = '\0';
	 data[ wSize - 1 ] = '\0';
	 data[ wSize ] = '\0';
	 _lclose( hFile );
   if (wSize<15)
    return FALSE;

   //! einlesen des Headerteils
    cnt = 0 ;
    	 cnt2=0;
   			while ( 1 )
				{
					 if ( *( data + cnt2 ) == '\n' ) break;
					 if ( *( data + cnt2 ) == '\0' ){
               bEndOfFile=TRUE;
               break;}
					 cnt2++;
				}
    data += cnt2+1;
    cnt2 = 0;
				while ( 1 )
				{
					 if ( *( data + cnt2 ) == '\n' ) break;
					 if ( *( data + cnt2 ) == '\0' ){
               bEndOfFile=TRUE;
               break;}
					 cnt2++;
				}
    #ifdef _WIN32
				//! Kopieren DEST , SRC , n Bytes
				memcpy( ( HPSTR ) line, ( HPSTR ) data, ( long ) cnt2 );
#else
				memcpy( ( HPSTR ) line, ( HPSTR ) data, cnt2 );
#endif
	 data += cnt2;
    cnt4=0;
    //! bestimmen welche zusatzinfos vorhanden und die reihenfolge
    while(cnt4<cnt2)
    {
    while((line[cnt4]==' ')||(line[cnt4]==':')) cnt4++;
      strcpy(wort,"");
      cnt3=0;
      while((line[cnt4]!=' ')&&(line[cnt4]!='\n'))
      {
		wort[cnt3++]=line[cnt4++];
      }
      wort[cnt3]='\0';
    if(!strcmp(wort,"Omega"))
		 ;
	  else
	  if(!strcmp(wort,"Theta"))
		 ;
	  else
	  if(!strcmp(wort,"MaxIntensity"))
		 ;
	  else
	  if(!strcmp(wort,"PeakPosition"))
		 ;
	  else
	  if(!strcmp(wort,"IntegralIntensity"))
		 ReportUse.bIntegral=TRUE;
	  else
	  if(!strcmp(wort,"MeasurementTime"))
		ReportUse.bTime=TRUE;
	  else
	  if(!strcmp(wort,"MonitorSignal"))
		ReportUse.bMonitor=TRUE;
	  else
	  if(!strcmp(wort,"AbsorberPosition"))
		ReportUse.bAbsorber=TRUE;
    else
     continue;
	 cnt++;
    }
    bEndOfFile=FALSE;
	 if(cnt<4)
	  return FALSE;
   strcpy(buf,"");
	 strcat(buf,"%d");
   //! erstellen von formatstring abhaengig von anzahl der zusatzinfos
	 for(int i=1;i<=cnt;i++)
	  {
	  strcat(buf," %f");
	  }
	 ScanReport->New();
	 ScanReport2->New();
   //! einlesen der zusatzinfos
   cnt2=0;
   while ( 1 )
				{
					 if ( *( data + cnt2 ) == '\n' ) break;
					 if ( *( data + cnt2 ) == '\0' ){
               bEndOfFile=TRUE;
               break;}
					 cnt2++;
				}
    #ifdef _WIN32
				//! Kopieren DEST , SRC , n Bytes
				memcpy( ( HPSTR ) line, ( HPSTR ) data, ( long ) cnt2 );
#else
				memcpy( ( HPSTR ) line, ( HPSTR ) data, cnt2 );
#endif
    data+= cnt2+1;

	 do
	 {
    cnt2=0;
				while ( 1 )
				{
					 if ( *( data + cnt2 ) == '\n' ) break;
					 if ( *( data + cnt2 ) == '\0' ){
               bEndOfFile=TRUE;
               break;}
					 cnt2++;
				}
    #ifdef _WIN32
				//! Kopieren DEST , SRC , n Bytes
				memcpy( ( HPSTR ) line, ( HPSTR ) data, ( long ) cnt2 );
#else
				memcpy( ( HPSTR ) line, ( HPSTR ) data, cnt2 );
#endif
    data+= cnt2+1;
	 line[cnt2]='\0';
	  fIntegral=fTime=fAbsorber=fMonitor=0;
    i2=5;
    sscanf( line,buf, &cnt, &fOmega, &fTheta, &fValue[3], &fValue[4],
					&fValue[5],&fValue[6],&fValue[7],&fValue[8] );
		if(ReportUse.bIntegral)
		{
     fIntegral=fValue[i2++];
    }
		if(ReportUse.bTime)
			fTime=fValue[i2++];
		if(ReportUse.bMonitor)
			fMonitor=fValue[i2++];
		if(ReportUse.bAbsorber)
		 fAbsorber=fValue[i2++];
		ScanReport->PAdd( fOmega, fTheta, fIntegral );
		ScanReport2->PAdd( fTime, fMonitor, fAbsorber);
	 }while (!bEndOfFile);

   //! speicher freigeben
   GlobalUnlock( hMem );
	 GlobalFree( hMem );
	 SetCursor( hCursor );
	 if ( 3 > ScanReport->GetPNumber() )
		  return FALSE;

	 return TRUE;
};


//! laden der Messungsinfos aus einer .psd datei
//! hFile ist Filehandle der Messdatei
//! Rueckkehrcode False wenn Datei zu kurz ,[HEADER] nicht vorhanden,
//! Filetyp ungl. 1 oder OmegaStep = 0
//! true sonst
BOOL TAreaScan::LoadMeasurementInfo( HFILE hFile )
{
	 char header[ 2048 ];
	 UINT wReadCnt;
	 int columns;
	 char *token, *info, *keyword;
	 BOOL retval = FALSE, bCheckHeader = FALSE;

	 nFirstReadColumn = nLastReadColumn = 0;
	 // Header-Marke suchen
	 //! test ob Datei zu kurz
	 _llseek( hFile, 0, 0 );
	 wReadCnt = _lread( hFile, ( LPSTR ) header, 2048 );
	 if ( wReadCnt < 50 )
		  goto Exit; // File korrupt
	 //! test ob [Header]-eintrag existiert
	 token = strtok( header, " \r\n" );
	 do
	 {
		  if ( strstr( token, "[Header]" ) )
				break;
		  token = strtok( NULL, " \r\n" );
		  if ( !token )
				goto Exit; // Kein Header enthalten
	 }


	 while ( 1 );
	 dThetaOffset = 0.0;
   //! FIX Fehler 39
   VisualDB.bPsd = FALSE;
   //! Messkanal auf default-wert
   nMeasurementChannel = 0;
	 // Header-Informationen auswerten
	 while ( 1 )
	 {
		  keyword = strtok( NULL, " =\n\r" );
		  info = strtok( NULL, " =\n\r" );
		  if ( !strcmp( "Date", keyword ) ||
					 !strcmp( "DataRows", keyword ) ||
					 !strcmp( "Time", keyword ) ||
					 !strcmp( "HV", keyword )
			  )
				continue;
		  if ( !strcmp( "User", keyword ) )
		  {
				strcpy( Main.User, info );
				continue;
		  }
		  if ( !strcmp( "Target", keyword ) )
		  {
				strcpy( Main.Target, info );
				continue;
		  }
		  if ( !strcmp( "Substrat", keyword ) )
		  {
				strcpy( Main.TargetBulk, info );
				continue;
		  }
		  if ( !strcmp( "Reflection", keyword ) )
		  {
				SetHKL( Main.Reflection, info );
				continue;
		  }
		  if ( !strcmp( "Orientation", keyword ) )
		  {
				SetHKL( Main.Orientation, info );
				continue;
		  }
		  if ( !strcmp( "DataColumns", keyword ) )
		  {
				columns = atof( info );
				continue;
		  }
		  if ( !strcmp( "FirstColumn", keyword ) )
		  {
				nFirstReadColumn = atof( info );
				continue;
		  }
		  if ( !strcmp( "LastColumn", keyword ) )
		  {
				nLastReadColumn = atof( info );
				continue;
		  }
		  if ( !strcmp( "WaveLength", keyword ) )
		  {
				Main.WaveLength = atof( info );
				continue;
		  }
		  if ( !strcmp( "PsdStep", keyword ) )
		  {
				::fPsdRange = atof( info );
        //! Gradwert in Sekunden umrechnen
//        ::fPsdRange *= 3600.0;
        //! FIX Fehler 39
        VisualDB.bPsd = TRUE;
				continue;
		  }
		  if ( !strcmp( "ThetaMin", keyword ) )
		  {
				dThetaMin = atof( info );
				continue;
		  }
      if ( !strcmp( "ThetaMax", keyword ) )
		  {
				dThetaMax = atof( info );
				continue;
		  }

		  if ( !strcmp( "MoveRelation", keyword ) )
		  {
				dMoveRelation = atof( info );
        //! FIX Fehler 39
        VisualDB.dMoveRelation = dMoveRelation;
				continue;
		  }
		  if ( !strcmp( "OmegaMin", keyword ) )
		  {
				dOmegaMin = atof( info );
				//! FIX Fehler 39
        VisualDB.dOmegaMin = dOmegaMin;
        continue;
		  }
      //! FIX Fehler 39
 		  if ( !strcmp( "OmegaMax", keyword ) )
		  {
				dOmegaMax = atof( info );
        VisualDB.dOmegaMax = dOmegaMax;
				continue;
		  }
		  if ( !strcmp( "OmegaStep", keyword ) )
		  {
				dOmegaWidth = atof( info );
				continue;
		  }
      //! FIX Fehler 39
      if ( !strcmp( "ThetaWindow", keyword ) )
		  {
				dThetaWindow = atof( info );
        VisualDB.dThetaWindow=dThetaWindow;
        dThetaWidth = dThetaWindow / (columns-1);
				continue;
		  }
		  if ( !strcmp( "TimePerScan", keyword ) )
		  {
				fMaxTime = atof( info );
				continue;
		  }
		  if ( !strcmp( "PsdAddedChannels", keyword ) )
		  {
				nAddedChannels = atoi( info );
				continue;
		  }
		  if ( !strcmp( keyword, "FileType" ) )
		  {
				if (( *info == '1' )|| !strcmp("Standard",info))
					 eSaveFormat = StandardFile;
				else
					 goto Exit; // Falsches File-Format
				continue;
		  }

			if ( !strcmp( "MeasurementChannel", keyword ) )
			{
				nMeasurementChannel = atoi( info );
				continue;
			}

		  //! Test auf folgende Eintraege bei DB-Zusammensetzung
		  if ( bComposeDB )
		  {
			if ( !strcmp( "Point_Number", keyword ) )
			{
				columns = atoi( info );
				continue;
			}
			if ( !strcmp( "Zerlegung", keyword ) )
			{
				if( !strcmp( info, "PSD" ) )
				{
					VisualDB.bPsd = TRUE;
					continue;
				}
			}
			nFirstReadColumn = 0;
			nLastReadColumn = columns;
		  }

		  if ( strstr( keyword, "[Data]" ) )
				break;
		  if ( strstr( info, "[Data]" ) )
				break;
	 }
	 //! alt // check infos
	 //! einige Headerwerte ueberpruefen und evtl. auf gueltige Werte setzen
	 if ( !nLastReadColumn )
		  nLastReadColumn = columns;
	 else
		  if ( nLastReadColumn > columns )
				nLastReadColumn = columns;
	 if ( !nFirstReadColumn )
		  nFirstReadColumn = 0;
	 if ( !dOmegaWidth )
		  bCheckHeader = TRUE;
	 dThetaOffset = 0.0;

	 if ( bCheckHeader )
	 {
		  MessageBox( GetFocus(), szMsgLine014, szMsgFailure, MBINFO );
		  goto Exit;
	 }
	 //! FIX Fehler 39
	if( VisualDB.bPsd)
	 {
	 VisualDB.fAngleStep = ::fPsdRange ;
	 VisualDB.fAngleRange = ::fPsdRange * (columns+1) * nAddedChannels;
   //! psd-offset in kurve einrechnen
	 VisualDB.dThetaMinFirst = dThetaMin-nMeasurementChannel*VisualDB.fAngleStep;
	 VisualDB.dThetaMaxFirst = VisualDB.dThetaMinFirst+VisualDB.fAngleRange;
   //! psd-offset in kurve einrechnen
	 VisualDB.dThetaMinLast = dThetaMax-nMeasurementChannel*VisualDB.fAngleStep;
	 VisualDB.dThetaMaxLast = VisualDB.dThetaMinLast+VisualDB.fAngleRange;
	 }
	 else
	 {
	 VisualDB.fAngleStep = VisualDB.dThetaWindow / (columns-1);
	 VisualDB.fAngleRange = VisualDB.dThetaWindow;
	 VisualDB.dThetaMinFirst = dThetaMin-0.5 * VisualDB.dThetaWindow;
	 VisualDB.dThetaMaxFirst = dThetaMin+0.5 * VisualDB.dThetaWindow;
	 VisualDB.dThetaMinLast = dThetaMax-0.5 * VisualDB.dThetaWindow;;
	 VisualDB.dThetaMaxLast = dThetaMax+0.5 * VisualDB.dThetaWindow;
	 }
	 retval = TRUE;
Exit:
	 return retval;
};


//! liest gespeicherte Kurve (.psd)
//! ?? inputparam nicht implem.
//! Rueckkehrcode false wenn Fehler beim oeffnen der Datei, Extension ungl.
//! .psd, fehlerhaften Headerinfo. oder keine Eintraege nach[DATA]
//! sonst auch false (fehler)
BOOL TAreaScan::LoadOldData( int )
{
	 char buf[ _MAX_PATH ];
	 HFILE hFile;
	 TCurve* TheCurve;
	 HPSTR daten;
	 HCURSOR hCursor;
	 float omega, theta, intens, channel;
   //! FIX Fehler 39
	 int cnt, column, rows;
	 HGLOBAL hMem;
	 DWORD dwReadCnt;
	 OFSTRUCT of;
	 BOOL retval = FALSE;

	 //! ins Arbeitverzeichnis wechseln + Nachladebox oeffnen
	 _chdir( szDataPath );
	 sprintf( buf, "*.%s", szExtension );
#ifdef GermanVersion
	 FileOpen( "File nachladen", szFilter, buf, szDataPath );
#else
	 FileOpen( "reload File", szFilter, buf, szDataPath );
#endif
	 if ( buf[ 0 ] == '*' )
		  return FALSE;
	 if ( strcmp( strupr( &( buf[ strlen( buf ) - 3 ] ) ), "PSD" ) )
		  return FALSE;
	 //*** clear data base
	 lpDBase->New();
	 strcpy( FileName, buf );
	 nActiveScan = 0;
	 MainCurve = lpDBase->GetCurve( nActiveScan );
	 UpdateWnd( 0 );
	 //*** explicite repaint of window, since it's normally not possible.
	 PAINTSTRUCT ps;
	 HDC hdc = BeginPaint( hWndChild, &ps );
	 Paint( hdc, &ps );
	 EndPaint( hWndChild, &ps );
	 //*** open file and allocate of memory for read buffer
	 hFile = OpenFile( FileName, &of, OF_READ );
	 dwReadCnt = _llseek( hFile, 0, 2 );
	 //*** load header information
	 if ( !LoadMeasurementInfo( hFile ) )
	 {
		  MessageBox( GetFocus(), szMsgLine014, szMsgFailure, MBINFO );
		  return FALSE;
	 }
	 //! test ob Werte hinter [DATA] folgen
	 if ( !SetFPOnData( hFile ) ) return FALSE;
	 //! Speicherblock der Laenge der Datei+100 anlegen + Datei in Speicherblock
	 //! kopieren letzte 3 Zeichen '/0' + Schliessen der Datei
	 hMem = GlobalAlloc( GMEM_MOVEABLE, dwReadCnt + 100 );
	 daten = ( HPSTR ) GlobalLock( hMem );
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 dwReadCnt = _hread( hFile, ( HPSTR ) daten, dwReadCnt );
	 daten[ dwReadCnt - 2 ] = '\0';
	 daten[ dwReadCnt - 1 ] = '\0';
	 daten[ dwReadCnt ] = '\0';
	 _lclose( hFile );
	 // read of old data
	//! FIX Fehler 39
	rows= 1;
	 while ( 1 )
	 {
		  //! alle 5 gelesenen Scans Info ausgeben
		  if ( !( lpDBase->GetCNumber() % 5 ) )
		  {
#ifdef GermanVersion
				sprintf( buf, "%d Scan's gelesen", lpDBase->GetCNumber() );
#else
				sprintf( buf, "%d scan's read", lpDBase->GetCNumber() );
#endif
				SetInfo( buf );
		  }
		  TheCurve = lpDBase->GetCurve( 10000 );
		  TheCurve->FastOpen();
		  //! FIX Fehler 39
		//! in abhaengigkeit von Detektor der Datenbasis (Psd oder 0-dim.)
		//! den Thetastartwert je Kurve berechnen
		theta = (VisualDB.bPsd)? 0.0 : dThetaMin+
		(rows-1)*dOmegaWidth*VisualDB.dMoveRelation-0.5*VisualDB.dThetaWindow;
		  channel = 0.0;
		  column = 0;
		  cnt=0;
		  //! zeilenweises Einlesen der Messwerte
		  while ( 1 )
		  {
				cnt = 0;
				//! einlesen eines Messwertes
				while ( 1 )
				{
					 if ( *( daten + cnt ) == ' ' ) break;
					 if ( *( daten + cnt ) == '\t' ) break;
					 if ( *( daten + cnt ) == '\r' ) break;
					 if ( *( daten + cnt ) == '\n' ) break;
					 if ( *( daten + cnt ) == '\0' ) goto Exit;
					 cnt++;
				}
#ifdef _WIN32
				//! Kopieren DEST , SRC , n Bytes
				memcpy( ( HPSTR ) buf, ( HPSTR ) daten, ( long ) cnt );
#else
				memcpy( ( HPSTR ) buf, ( HPSTR ) daten, cnt );
#endif
				daten += cnt;
				buf[ cnt ] = 0;
				intens = atof( buf );
				if ( column <= nLastReadColumn )
				{
					 if ( column >= nFirstReadColumn )
						  TheCurve->FastPAdd( theta, intens, channel );
					 column++;
           channel += nAddedChannels;
				 //! FIX Fehler 39
			  //! in abhaengigkeit von Detektor der Datenbasis (Psd oder 0-dim.)
			  //! de Scanreportwerte der Datenbasis
			  theta += (VisualDB.bPsd)?(::fPsdRange)*nAddedChannels:dThetaWidth; // contains here the PsdStep
				}


				while ( *daten == ' ' ) daten++;
				while ( *daten == '\t' ) daten++;
				if ( *daten == '\r' ) break;
				if ( *daten == '\n' ) break;
				if ( *daten == '\0' ) goto Exit;
		  }
		  daten++;
		  if ( ( *daten == '\r' ) || ( *daten == '\n' ) )
				daten++;
		  TheCurve->FastClose();
		  lpDBase->AddCurve( nLastReadColumn - nFirstReadColumn + 10 );
		//! FIX Fehler 39
		rows++;
	 }
Exit:
   GlobalUnlock( hMem );
   GlobalFree( hMem );
   //! Bereich des PSD aus Min und Max der letzten Kurve ermitteln
	 ::fPsdRange = TheCurve->Max[ 0 ] - TheCurve->Min[ 0 ];
	 //*** Generation of ScanRep from ranges witch corrections of measurement area
	 {
		//! FIX Fehler 39
		  omega = VisualDB.dOmegaMin;
		  theta = VisualDB.dThetaMinFirst;
      //! unterscheiden O2T und Standard-Scan
      if(dThetaMin == dThetaMax)
        dThetaWidth = 0.0;
      else
		    dThetaWidth = dOmegaWidth * dMoveRelation;
		  //! dOmegaMax = dOmegaMin + dOmegaWidth * ( lpDBase->GetCNumber() - 1 );
      //! test ob zugehoerige reportdatei exist. bzw. defekt ist
		  if(!LoadReport())
		  {
      MessageBox(GetFocus(),szMsgLine030,szMsgFailure,MBINFO);
		  ScanReport->New();
		  ScanReport->FastOpen();
		  ScanReport2->New();
		  ScanReport2->FastOpen();
		  //! ScanReport erstellen

		  float dummy;


		  for ( cnt = 0; cnt < lpDBase->GetCNumber(); cnt++ )
		  {
				//! NEU! Fehler 33
				TheCurve=lpDBase->GetCurve(cnt);
				TheCurve->GetGravityCenter(dummy,intens,dummy,2);
				ScanReport->FastPAdd( omega, theta, intens );
        dummy = 0.0;
        ScanReport2->FastPAdd(dummy,dummy,dummy);
				omega += dOmegaWidth;
				theta += dThetaWidth;
		  }
		  ScanReport2->FastClose();
		  ScanReport->FastClose();

		  }
	 }
	 //*** format data for output
	 SetCursor( hCursor );
	 bFileChanged = FALSE;
	 bIsNewFile = FALSE;

	 //! automatisch Bitmap errechnen wenn entspr. Ausgabetyp gewaehlt
	 if ( eOutputType <= MatrixBitmap )
		  BSource->FormatDBaseToBitmapSource();
	 //! Fenster erneuern + Info setzen + Speicher freigeben
	 UpdateWnd( 0 );
#ifdef GermanVersion
	 SetInfo( "archivierte Datendatei wurde gelesen" );
#else
	 SetInfo( "archived data-file was read" );
#endif
	 //! ? nicht eingeschaltet ?
#ifdef Peak_and_Cross
	 //**** Daten aquirieren Peak- und Cross-Scan speichern **********************
	 {
		  float psdtheta, intens, channel, maxintens = 0.0;
		  int maxcu, maxch;

		  XShift = 0.0;
		  for ( Idx = 0; Idx < lpDBase->GetCNumber(); Idx++ )
		  {
				TheCurve = lpDBase->GetCurve( Idx );
				TheCurve->GetGravityCenter( psdtheta, intens, channel, 2 );
				if ( intens > maxintens )
				{
					 maxintens = intens;
					 maxcu = Idx;
					 maxch = channel;
				}
		  }
		  TheCurve = lpDBase->GetCurve( maxcu );
		  *SecondCurve = *TheCurve;
		  SaveSecondCurve();
		  SecondCurve->Delete();
		  for ( Idx = 0; Idx < lpDBase->GetCNumber(); Idx++ )
		  {
				TheCurve = lpDBase->GetCurve( Idx );
				TheCurve->SetPP( maxch );
				TheCurve->PGet( psdtheta, intens, channel );
				psdtheta = OmegaMin + Idx * OmegaWidth;
				SecondCurve->PAdd( psdtheta, intens, channel );
		  }
		  // Speichern der Curven
		  SaveSecondCurve();
	 }
#endif

	 bOldDataLoaded = TRUE;
	 return retval;
};

//*****************************************************************************
//******* Dialog fuer Data Aquisition ****************************************
//*****************************************************************************
//! Konstruktor fuer Dialogeinstellungen 'Aquisition'
//! dabei wird zunaechst der Konstruktor fuer Dialogboxen mit dem String, der
//! die Ressource spezifiziert, aufgerufen
#ifdef GermanVersion
TAquisition::TAquisition( void ) : TModalDlg( "Aquisition" )
#else
TAquisition::TAquisition( void ) : TModalDlg( "AquisitionEng" )
#endif
{
	 bAquisitionActive = FALSE;
};

//#pragma argsused
//! eintragen von Defaultwerten fuer alle Elemente bei Aufruf der Dlg.Box
//! rueckkehrcode immer true
BOOL TAquisition::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
	 //! int i = 0;
	 char buf[ MaxString ];

	 //! Anzahl der Messpunkte
	 sprintf( buf, "%d", nLinePoints );
	 SetDlgItemText( GetHandle(), id_LinePoints, buf );
	 //! Umgebung
	 sprintf( buf, "%d", nEnvironment );
	 SetDlgItemText( GetHandle(), id_AddedPoints, buf );
	 sprintf( buf, "%s", DataFile );
	 SetDlgItemText( GetHandle(), id_FileName, buf );
	 //! ?
	 CheckDlgButton( GetHandle(), id_DX, bSetDXZero );
	 CheckDlgButton( GetHandle(), id_DY, bSetDYZero );
	 CheckDlgButton( GetHandle(), id_RL, bSetRLSave );
	 return TRUE;
};

//! hier werden IDOK und IDCANCEL behandelt
void TAquisition::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
											UINT codeNotify )
{
	 TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
};

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen der
//! Dialogbox (durch OK-Button)
//! Rueckkehrcode false wenn die Dialogbox nicht geschlossen werden kann (werte
//! inkonsistent) sonst true
BOOL TAquisition::CanClose( void )
{
	 int value;
	 OFSTRUCT of;
	 int hFile;
	 char buf[ MaxString ];

	 //! Werte der CheckBoxen uebernehmen wenn nicht beide markiert, sonst 'dX=0'
	 //! auf unmarkiert setzen, CheckButtons neu setzen und Box nicht verlassen
	 bSetDXZero = IsDlgButtonChecked( GetHandle(), id_DX );
	 bSetDYZero = IsDlgButtonChecked( GetHandle(), id_DY );
	 bSetRLSave = IsDlgButtonChecked( GetHandle(), id_RL );
	 if ( bSetDXZero * bSetDYZero )
	 {
		  bSetDXZero = !bSetDYZero;
		  CheckDlgButton( GetHandle(), id_DX, bSetDXZero );
		  CheckDlgButton( GetHandle(), id_DY, bSetDYZero );
		  return FALSE;
	 }
	 //! uebernehmen der 'Umgebung', wenn Wert im Bereich von 0 bis 3 liegt, sonst
	 //! Wert auf entsprechende Grenze setzen + Wert in Box eintragen + Box nicht
	 //! verlassen
	 GetDlgItemText( GetHandle(), id_AddedPoints, buf, MaxString );
	 value = atoi( buf );
	 nEnvironment = max( 0, min( 3, value ) );
	 if ( value != nEnvironment )
	 {
		  sprintf( buf, "%d", nEnvironment );
		  SetDlgItemText( GetHandle(), id_AddedPoints, buf );
		  return FALSE;
	 }
	 //! uebernehmen der 'Messpunkte', wenn Wert im Bereich von 0 bis 1100 liegt,
	 //! sonst Wert auf entsprechende Grenze setzen + Wert in Box eintragen + Box
	 //! nicht verlassen
	 GetDlgItemText( GetHandle(), id_LinePoints, buf, MaxString );
	 value = atoi( buf );
	 nLinePoints = max( 0, min( 1100, value ) );
	 if ( value != nLinePoints )
	 {
		  sprintf( buf, "%d", nLinePoints );
		  SetDlgItemText( GetHandle(), id_LinePoints, buf );
		  return FALSE;
	 }
	 //! Test, ob angeg. Datei bereits existiert + evtl. Fehlermeldung
	 //! anlegen der Datei
	 GetDlgItemText( GetHandle(), id_FileName, DataFile, MaxString );
	 // Testen, ob sich das File auch erzeugen laesst
	 if ( HFILE_ERROR != OpenFile( DataFile, &of, OF_EXIST ) )
	 {
#ifdef GermanVersion
		  strcpy( buf, "File existiert bereits !\r\nberschreiben ?" );
#else
		  strcpy( buf, "File already exists !\r\nOverwrite ?" );
#endif
		  if ( IDYES == MessageBox( GetFocus(), buf, szMessage, MBASK ) )
				goto Exit;
		  else
				return FALSE;
	 }


	 //! Fehlermeldung bei Problemen beim Anlegen der Datei
	 hFile=OpenFile( DataFile, &of, OF_CREATE );
	 if (-1 == hFile)
	 {
		  _lclose(hFile);
#ifdef GermanVersion
		  strcpy( buf, "Probleme beim Anlegen des File !" );
#else
		  strcpy( buf, "Error, creating the file !" );
#endif
		  MessageBox( GetFocus(), buf, szMessage, MBINFO );
		  return FALSE;
	 }
	 else _lclose(hFile);
//!	 remove( DataFile );

	 //! wenn alles erfolgreich Marke setzen + Info + DataAquisiton auf true
	 //!setzen
Exit:
	 bAquisitionActive = TRUE;
	 //! ? evtl ueberfluessig
	 nSetMarker = 0;
#ifdef GermanVersion
	 SetInfo( "Bitte mit der Maus eine Linie festlegen." );
#else
	 SetInfo( "Draw a line with the mouse." );
#endif
	 return TRUE;
};

//! wird bei verlassen der Dlg.box aufgerufen (in dieser Dlg.box keine
//! Bedeutung) da auch geerbt
BOOL TAquisition::LeaveDialog( void )
{
	 return TRUE;
};

// __LastLine__

