#include "..\include\winresrc\rc_def.h"
#include "..\include\internls\evrythng.h"

#include "..\include\swintrac\swintrac.h"
#include "..\include\datavisa\datavisa.h"
#include "..\include\motrstrg\motrstrg.h"
#include "..\include\detecuse\detecuse.h"

#include "..\include\difrkmty\difrkmty.h"
#include "..\include\difrkmty\m_dlgdif.h"


#ifdef GermanVersion
char szDlgFailure[] = "Fehler";
char szDlgMessage[] = "Meldung";
char szInfoType0[] = "         Medetektor";
char szInfoType1[] = "Integrale Intensitt";
char szInfoType2[] = "    Absorberposition";
char szInfoType3[] = "  Monitor-Intensitt";
char szInfoType4[] = "       reale Mezeit";
char szDlgMsgLine001[] = "Kein gltiger Scantyp";
char szDlgMsgLine002[] = "Vorgang bitte wiederholen !";
char szDlgMsgLine003[] = "kein Absorber verfgbar";
char szDlgMsgLine004[] = "gltige Kanalnummern: 0 bis %d";
char szDlgMsgLine005[] = "Bereichsberschreitung(Omega)";
char szDlgMsgLine006[] = "Bereichsberschreitung(Theta)";
#else
char szDlgFailure[] = "Failure";
char szDlgMessage[] = "Message";
char szInfoType0[] = "       Detector-type";
char szInfoType1[] = "  Integral Intensity";
char szInfoType2[] = "    Absorberposition";
char szInfoType3[] = "   Monitor-Intensity";
char szInfoType4[] = "  real Measure-Time ";
char szDlgMsgLine001[] = "No valid Scan Type";
char szDlgMsgLine002[] = "Please repeat the procedure !";
char szDlgMsgLine003[] = "no absorber available";
char szDlgMsgLine004[] = "valid Channelnumber: 0 to %d";
char szDlgMsgLine005[] = "area-overstepping(Omega)";
char szDlgMsgLine006[] = "area-overstepping(Theta)";
#endif

extern LPDList lpDList;
extern LPDataBase lpDBase;
extern TModelessDlg* TheModeless;

char aTempPath[ 120 ] = {0};
char aTempName[ 12 ] = {0};

extern char DismantleFile[ 40 ];

//*****************************************************************************
//******* Dialog zum Messen mit PSD unter externer Sychronisation *************
//*****************************************************************************

//! diese Dialogbox funktioniert nicht(unvollstaendig)
TPsdRemoteSync::TPsdRemoteSync( TCurve& curve ) : TModalDlg( "PSDRemoteSync" )
{
	 Curve = &curve; // MainCurve vom Daten-Fenster
	 hDlgItem = NULL;
	 bCalibrationOk = FALSE;
	 if ( !strlen( aTempPath ) )
		  strcpy( aTempPath, "c:\\Work\\" );
	 strcpy( aPath, aTempPath );
	 if ( !strlen( aTempName ) )
		  strcpy( aTempName, "GESI_474" );
	 strcpy( aName, aTempName );
	 nAskTime = 80;
	 nCurveCount = 0;
	 Device = lpDList->DP( dlGetIdByName( PsdDevice ) );
	 if ( Device )
		  Device->GetExposureValues( fExposureTime, dwExposureCounts, fError );
};

//#pragma argsused
BOOL TPsdRemoteSync::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
	 if ( !Device )
		  return FALSE;
	 Device->MeasureStop();
	 Device->SetHost( GetHandle() );
	 Device->SetSignalGrowUp( TRUE );
	 // External Sync
	 // Die Messzeit wird quasi auf unendlich gestellt
	 // Ein Abbruch der Messung wird durch ein explizites aendern der Exposure-
	 // Time erreicht.
	 FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
	 hDlgItem = NULL;
	 return TRUE;

};

void TPsdRemoteSync::Dlg_OnTimer( HWND hwnd, UINT id )
{
	 switch ( id )
	 {
	 case TimerIdInformation:
		  KillTimer( hwnd, TimerIdInformation );
		  // Messung starten
		  // Messung stoppen
	 }


	 return ;
};

void TPsdRemoteSync::PrintFileName( void )
{
	 char aBuf[ 20 ];

	 SetDlgItemText( GetHandle(), IDC_DirPSDCycle, aPath );
	 SetDlgItemText( GetHandle(), IDC_TargetName, aName );
	 sprintf( aBuf, ".%03d", nCurveCount );
	 SetDlgItemText( GetHandle(), IDC_Extension, aBuf );
};

LPCSTR TPsdRemoteSync::GetFileName( void )
{
	 sprintf( aFileName, "%s\\%s.%03d", aPath, aName, nCurveCount );
	 return aFileName;
};

void TPsdRemoteSync::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
												UINT codeNotify )
{
	 switch ( id )
	 {
	 case cm_ParamSet:
		  PrintFileName();
		  if ( Device )
				SetDlgItemText( hwnd, IDC_Messages, "Initialisation OK" );
		  break;

	 case cm_CounterSet:
		  Device->UpdateDisplay();
		  if ( Curve->Save( GetFileName(), 100, 2 ) )
		  {
				PrintFileName();
				Device->SetExposureValues( fExposureTime, dwExposureCounts, fError );
				SetDlgItemText( hwnd, IDC_Messages, "Scan acquisition was ok" );
				break;
		  }
		  SetDlgItemText( hwnd, IDC_Messages, "Scan acquisition failed" );
		  break;

	 case IDC_StopPSDCycle:
		  KillTimer( hwnd, TimerIdInformation );
		  break;

	 case IDC_InterruptPSDCycle:
		  KillTimer( hwnd, TimerIdInformation );
		  break;

	 case IDC_StartPSDCycle:
		  GetDlgItemText( hwnd, IDC_DirPSDCycle, aPath, 10 );
		  strcpy( aTempPath, aPath );
		  GetDlgItemText( hwnd, IDC_TargetName, aName, 10 );
		  strcpy( aTempName, aName );
		  // check whether exist or not writable

		  SetTimer( hwnd, TimerIdInformation, 100, NULL );
		  break;


	 default:
		  TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }

};

BOOL TPsdRemoteSync::CanClose( void )
{
	 return TRUE;
};

BOOL TPsdRemoteSync::LeaveDialog( void )
{
	 KillTimer( GetHandle(), TimerIdInformation );
	 Device->MeasureStop();
	 Device->SetExposureValues( fExposureTime, dwExposureCounts, fError );
	 Device->SetHost( NULL );
	 return TRUE;
};

//*****************************************************************************
//******* Dialog zum Kalibrieren des Psd **************************************
//*****************************************************************************
#ifdef GermanVersion
TCalibratePsd::TCalibratePsd( TCurve &curve ) : TModalDlg( "CalibratePsd" )
#else
TCalibratePsd::TCalibratePsd( TCurve &curve ) : TModalDlg( "CalibratePsdEng" )
#endif
{
    Curve = &curve; // MainCurve vom Daten-Fenster
    hDlgItem = NULL;
	 //! gibt an ob motor ueber groessere distanz faehrt
    bLongMove = FALSE;
    LeftPeak.Valid = FALSE;
	 RightPeak.Valid = FALSE;
	 //! gibt an ob rechter bzw. linker Peak schon erreicht ist
    bGetRightPeak = FALSE;
	 bGetLeftPeak = FALSE;
    //! gibt an ob motor in bewegung
	 bMoveActive = FALSE;
	 //! wahrscheinlich ueberfluessig
    bCalibrationOk = FALSE;
    //! Zeitintervall zur akt. der Winkel in Dialogbox
	 nAskTime = 80;
    //! Psd ermitteln + thetamotor setzen
    Device = lpDList->DP( dlGetIdByName( PsdDevice ) );
	 nMotor = mlGetIdByName( Theta );
    mlSetAxis( nMotor );
    // Die Schrittweite des Psd dAngleStep wird stets in Winkelsekunden angegeben
    if ( Grad == mGetUnitType() )
        fRelationFactor = 1.0 / 3600.0;
    else
        if ( Minuten == mGetUnitType() )
				fRelationFactor = 1.0 / 60.0;
        else
            fRelationFactor = 1.0;
};

//#pragma argsused

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TCalibratePsd::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
    //! alte Schrittweite merken + neue auf 1800 winkelsekunden setzen
	 dOldMotorWidth = mGetValue( Width );
    mSetValue( Width, 1800.0 * fRelationFactor );
	 //! Psd einstellen
	 Device->MeasureStop();
    Device->SetAddedChannels( 2 );
    Device->SetHost( GetHandle() );
	 Device->SetExposureValues( 2.0, 10000, 0.02 );
    Device->MeasureStart();
    Delay( 5000 );
	 //! FIX Fehler 48
    dStepWidth = Device->GetAngleStep() ;
    hBar = GetDlgItem( GetHandle(), id_Bar );
    //! Timer starten + motor init. + DialogboxParameter setzen
    SetTimer( GetHandle(), TimerIdInformation, nAskTime, NULL );
    FORWARD_WM_COMMAND( hwnd, cm_MotorInit, hwndCtl, 0, SendMessage );
    FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
	 hDlgItem = NULL;
    return TRUE;
};

//! behandelt Timersignale zur aktualisierung der Winkelwerte in Dialogbox
void TCalibratePsd::Dlg_OnTimer( HWND hwnd, UINT id )
{
    char buf[ MaxString ];
	 double dDistance;

	 switch ( id )
    {
	 case TimerIdInformation:
        //! Timer loeschen + Wait-mauszeiger setzen
		  KillTimer( hwnd, TimerIdInformation );
		  SetCursor( LoadCursor( NULL, IDC_WAIT ) );
        //! test ob motor an Ziel angekommen
        if ( mIsMoveFinish() )
		  {
            //! Motorpos.bestimmung + test ob fehler
            if ( !mGetDistance( dDistance ) )
				{
                SetTimer( hwnd, TimerIdInformation, nAskTime, NULL );
                return ;
            }
            //! Winkel 2Thetawerte in Dialogbox schreiben + scrollbar aktualisieren
            sprintf( buf, mGetDF(), dDistance );
            SetDlgItemText( hwnd, id_NewAngle, buf );
				//! ueberfluessig
            sprintf( buf, mGetDF(), dDistance );
            SetDlgItemText( hwnd, id_Angle, buf );
            SetScrollPos( hBar, SB_CTL, GetBarPos(), TRUE );
            bMoveActive = FALSE;
            SetCursor( LoadCursor( NULL, IDC_ARROW ) );
		  }
        //! motor in bewegung
        else
		  {
				//! bei bewegung ueber groessere distanz den akt. Winkel in Dialogbox +
            //! scrollbar aktualisieren
				if ( bLongMove )
            {
					 mGetDistance( dDistance );
					 sprintf( buf, mGetDF(), dDistance );
                SetDlgItemText( hwnd, id_Angle, buf );
                SetScrollPos( hBar, SB_CTL, GetBarPos(), TRUE );
				}
            //! Timer neu setzen
            SetTimer( hwnd, TimerIdInformation, nAskTime, NULL );
		  }
    }
    return ;
};

//! behandelt Kommandos in der Dialogbox
void TCalibratePsd::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
											  UINT codeNotify )
{
    char buf[ MaxString ];
    float val_f, channel, dd;
	 static int MsgCnt = FALSE;

	 switch ( id )
    {
        //! init. einiger Dialogboxelemente
	 case cm_ParamSet:
		  //! winkeleinheit+ akt. Winkel je Kanal setzen
        SetDlgItemText( GetHandle(), id_Unit, mGetAxisUnit() );
		  //! FIX Fehler 48
        sprintf( buf, "%.3f", dStepWidth );
		  SetDlgItemText( GetHandle(), id_StepWidth, buf );
		  // Initialisieren des Motor-Scroll-Bar's
        SetScrollRange( hBar, SB_CTL, GetBarEgde( LEFT ), GetBarEgde( RIGHT ),
                        TRUE );
		  SetFocus( hBar );
        break;

		  //! Motor init.
    case cm_MotorInit:
        mActivateDrive();
        // Initialisieren des Positions-Eingabefenster's
        bMoveActive = TRUE;
        SetTimer( GetHandle(), TimerIdInformation, nAskTime, NULL );
        break;

        //! wenn Psdmessung fertig
	 case cm_CounterSet:
        Device->UpdateDisplay();
        //! test ob rechte Peakpos. schon eingestellt wurde
        if ( bGetRightPeak )
		  {
            //! ermitteln + speichern des Kanals der max. Intensitaet
            Curve->GetGravityCenter( dd, dd, channel, 2 );
				RightPeak.Pt[ 0 ] = channel;
				RightPeak.Valid = TRUE;
            bGetRightPeak = FALSE;
				//! wenn linke Peakpos. schon ermittelt
            if ( LeftPeak.Valid )
				{
					 //! winkeldifferenz zwischen linken und rechten peak ermitteln
                val_f = ( LeftPeak.Pt[ 1 ] - RightPeak.Pt[ 1 ] );
                //! wenn linker peak == rechter peak dann rechte Peakpos. verwerfen
					 if ( val_f == 0.0 )
                {
                    RightPeak.Valid = FALSE;
						  bGetRightPeak = TRUE;
                }
                else
                {
                    //! wenn gleicher kanal fuer linken und rechten peak dann
                    //! Fehlermeldung
                    if ( 0 != ( RightPeak.Pt[ 0 ] - LeftPeak.Pt[ 0 ] ) )
						  {
                        //! Winkel je kanal ausrechnen und an Psd uebergeben
                        val_f = val_f / ( RightPeak.Pt[ 0 ] - LeftPeak.Pt[ 0 ] ) /
                                fRelationFactor;
                        //! FIX Fehler 48
                        dStepWidth = val_f ;
						  }
                    else
                    {
								MessageBox( GetFocus(), szDlgMsgLine002,
												szDlgFailure, MBINFO );
								//! FIX Fehler 58
								//! reset aller wichtigen Werte
								bLongMove = FALSE;
								LeftPeak.Valid = FALSE;
								RightPeak.Valid = FALSE;
								bGetRightPeak = FALSE;
								bGetLeftPeak = FALSE;
								bMoveActive = FALSE;
								EnableWindow( GetDlgItem( GetHandle(), cm_LeftPositionReached ),
								  TRUE);
								EnableWindow( GetDlgItem( GetHandle(), cm_RightPositionReached ),
                          TRUE);
                        break;
                    }
                }
				}
            //! sperren bzw. freigeben des rechte-Position-erreicht-Button
				EnableWindow( GetDlgItem( GetHandle(), cm_RightPositionReached ),
                          bGetRightPeak );
        }
        //! test ob linke Peakpos. schon eingestellt wurde
        if ( bGetLeftPeak )
        {
				//! ermitteln + speichern des Kanals der max. Intensitaet
            Curve->GetGravityCenter( dd, dd, channel, 2 );
            LeftPeak.Pt[ 0 ] = channel;
				LeftPeak.Valid = TRUE;
				bGetLeftPeak = FALSE;
            //! wenn rechte Peakpos. schon ermittelt
            if ( RightPeak.Valid )
            {
					 //! winkeldifferenz zwischen linken und rechten peak ermitteln
					 val_f = ( LeftPeak.Pt[ 1 ] - RightPeak.Pt[ 1 ] );
                //! wenn linker peak == rechter peak dann rechte Peakpos. verwerfen
                if ( val_f == 0.0 )
					 {
                    LeftPeak.Valid = FALSE;
                    bGetLeftPeak = TRUE;
					 }
                else
                {
						  //! wenn gleicher kanal fuer linken und rechten peak dann
                    //! Fehlermeldung
                    if ( 0 != ( RightPeak.Pt[ 0 ] - LeftPeak.Pt[ 0 ] ) )
                    {
								//! Winkel je kanal ausrechnen und an Psd uebergeben
                        val_f = val_f / ( RightPeak.Pt[ 0 ] - LeftPeak.Pt[ 0 ] ) /
                                fRelationFactor;
                        //! FIX Fehler 48
                        dStepWidth = val_f ;
                    }
						  else
                     {
                        MessageBox( GetFocus(), szDlgMsgLine002,
												szDlgFailure, MBINFO );
								//! FIX Fehler 58
                        //! reset aller wichtigen Werte
                        bLongMove = FALSE;
                        LeftPeak.Valid = FALSE;
								RightPeak.Valid = FALSE;
								bGetRightPeak = FALSE;
                        bGetLeftPeak = FALSE;
                        bMoveActive = FALSE;
								EnableWindow( GetDlgItem( GetHandle(), cm_LeftPositionReached ),
                          TRUE );
                        EnableWindow( GetDlgItem( GetHandle(), cm_RightPositionReached ),
								  TRUE );
								break;
                    }
                }
            }
            //! sperren bzw. freigeben des linke-Position-erreicht-Button
            EnableWindow( GetDlgItem( GetHandle(), cm_LeftPositionReached ),
								  bGetLeftPeak );
        }
        //! Winkel je Kanal-Wert in Dialogbox
       //! FIX Fehler 48
        sprintf( buf, "%.3f", dStepWidth );
        SetDlgItemText( GetHandle(), id_StepWidth, buf );
		  Device->SetAddedChannels( 2 );
        Device->MeasureStart();
        break;

		  //! rechte Position erreicht-Button gedrueckt
    case cm_RightPositionReached:
        //! wenn Motor in bewegung abbrechen
        if ( bMoveActive )
				break;
		  Device->MeasureStop();
        bGetRightPeak = TRUE;
        bGetLeftPeak = FALSE;
		  //! 2Theta winkel speichern
        RightPeak.Pt[ 1 ] = mGetValue( Distance );
		  Device->SetAddedChannels( 1 );
		  Device->MeasureStart();
        SetFocus( hBar );
        break;

        //! linke Position erreicht-Button gedrueckt
    case cm_LeftPositionReached:
        //! wenn Motor in bewegung abbrechen
		  if ( bMoveActive )
            break;
		  Device->MeasureStop();
        bGetRightPeak = FALSE;
        bGetLeftPeak = TRUE;
        //! 2Theta winkel speichern
		  LeftPeak.Pt[ 1 ] = mGetValue( Distance );
        Device->SetAddedChannels( 1 );
        Device->MeasureStart();
		  SetFocus( hBar );
		  break;

        //! eingabefeld fuer neuen Thetawinkel angewaehlt
        //! wird nachdem Beenden-Button gedrueckt noch 2-mal aufgerufen
	 case id_NewAngle:
		  hDlgItem = GetDlgItem( GetHandle(), id_NewAngle );
        MsgCnt--;
        if ( MsgCnt == 1 )
		  {
            //! sorgt dafuer dass beim anclicken des Beenden-Buttons die Box
            //! verlassen wird
				hDlgItem = NULL;
            MsgCnt = 0;
        }
        break;

        //! behandelt Beenden-Button und Enter
    case IDOK:
        if ( !hDlgItem )
        {
				//! Box verlassen
            TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
            break;
        }
		  // Der Nutzer hat mit Return eine neue Position eingegeben
        if ( hDlgItem == GetDlgItem( GetHandle(), id_NewAngle ) )
        {
				mStopDrive( TRUE );
				//! achtung sendet ein id_NewAngle
            GetDlgItemText( GetHandle(), id_NewAngle, buf, 10 );
            bLongMove = TRUE;
            mMoveToDistance( atof( buf ) );
				//! achtung sendet indirekt ein id_NewAngle
				FORWARD_WM_COMMAND( hwnd, cm_MoveButton, hwndCtl, 0, SendMessage );
				MsgCnt = 3;
        }
		  hDlgItem = NULL;
        SetFocus( hBar );
        break;

        //! wird aufgerufen wenn motor durch direkte eingabe oder durch anclicken
        //! des scrollbars bewegt wird
    case cm_MoveButton:
        if ( bMoveActive )
            break;
        bMoveActive = TRUE;
        SetTimer( GetHandle(), TimerIdInformation, nAskTime, NULL );
        break;

        //! behandelt Abbruch
    default:
        TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }
};

//#pragma argsused
//! behandelt alle Scrollbarereignisse
void TCalibratePsd::Dlg_OnHScrollBar( HWND hwnd, HWND hwndCtl, UINT code,
                                      int pos )
{
	 switch ( code )
	 {
        //! scrollbar um eine einheit nach links
    case SB_LINEUP:
		  if ( bMoveActive )
            break;
        mMoveToDistance( mGetValue( Distance ) - mGetValue( Width ) );
		  FORWARD_WM_COMMAND( hwnd, cm_MoveButton, hwndCtl, 0, SendMessage );
        break;

        //! scrollbar um eine einheit nach rechts
    case SB_LINEDOWN:
        if ( bMoveActive )
            break;
        mMoveToDistance( mGetValue( Distance ) + mGetValue( Width ) );
        FORWARD_WM_COMMAND( hwnd, cm_MoveButton, hwndCtl, 0, SendMessage );
		  break;

        //! scrollbarereignisse ohne Wirkung
    case SB_ENDSCROLL:
	 case SB_PAGEUP:
    case SB_PAGEDOWN:
        break;
	 }
};

//! ermittelt Anzahl der Scrollbarschritte links bzw. rechts von der abs. Null
//! 1.Parameter side==LEFT Anzahl der Scrollbarschritte links von der abs. Null
//! sonst Anzahl der Scrollbarschritte rechts von der abs. Null
//! Rueckkehrcode Anzahl der Scrollbarschr. links bzw. rechts von der abs. Null
//! Achtung diese Funktion muss mit LEFT zuerst aufgerufen werden
int TCalibratePsd::GetBarEgde( int side )
{
    int steps, ret;
    // Geht vom symmetrischen Fall aus
	 if ( side == LEFT )
    {
        steps = ( int ) ( mGetValue( MinDistance ) / mGetValue( Width ) );
        BarFactor = ( abs( steps ) < 20000 ) ? 1 : 2;
        ret = steps / BarFactor;
    }
    else
    {
        ret = ( mGetValue( MaxDistance ) / ( mGetValue( Width ) * BarFactor ) );
	 }
    return ret;
};

//! liefert die Position des Scrollbar anhand der akt. Motorposition im
//!Rueckkehrcode
int TCalibratePsd::GetBarPos()
{
	 int ret;

    ret = ( ( mGetValue( Distance ) ) / ( mGetValue( Width ) * BarFactor ) );
    return ret;
};

//! wird aufgerufen beim druecken des Beenden-Buttons
//! Rueckkehrcode False wenn der Winkel pro Kanal ==0
//! sonst true
BOOL TCalibratePsd::CanClose( void )
{
	 char buf[ MaxString ];
    char ident[ MaxString ];
    //! FIX Fehler 48
    Device->SetAngleStep( dStepWidth );
    if ( Device->GetAngleStep() == 0.0 )
    {
        MessageBeep( 0 );
        return FALSE;
    }
	 //! speichert Kanal pro Winkel im Ini-File des Psd
    sprintf( buf, "%.5f", Device->GetAngleStep() );
    sprintf( ident, "Device%d", Device->GetId() );
    WritePrivateProfileString( ident, "AngleStep", buf, GetHWFile() );
	 return TRUE;
};

//! wird bei verlassen der dialogbox aufgerufen Rueckkehrcode immer true
BOOL TCalibratePsd::LeaveDialog( void )
{
    //! loescht alle TimerIdInformation + stoppen der messung
    //! FIX Fehler 49
	 mSetValue( Width, dOldMotorWidth );
	 KillTimer( GetHandle(), TimerIdInformation );
    Device->MeasureStop();
    Device->SetHost( NULL );
	 return TRUE;
};

//*****************************************************************************
//******* Dialog zum Auswaehlen von Scan's ************************************
//*****************************************************************************
//! Konstruktor fuer nichtmodale Dialogbox ChooseScan
//! dabei wird zunaechst der Konstruktor fuer Dialogboxen mit dem String, der
//! die Ressource spezifiziert, aufgerufen
#ifdef GermanVersion
TChooseScan::TChooseScan( TAreaScan* ascan ) : TModelessDlg( "ChooseScan" )
#else
TChooseScan::TChooseScan( TAreaScan* ascan ) : TModelessDlg( "ChooseScanEng" )
#endif
{
    AScan = ascan;
	  Report = AScan->ScanReport;
    Report2 = AScan->ScanReport2;
};

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TChooseScan::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM )
{
	 char buf[ MaxString ];
	 int i=0;

   //! 1.zusatzinfo auf Detektortyp setzen
	 nInfoNumber = 0;
	 //! anzahl der Kurven eintragen + Scrollbar initialisieren
	 nMaxScan = lpDBase->GetCNumber() - 1;
	 sprintf( buf, "%d", nMaxScan );
	 SetDlgItemText( hwnd, id_Limit, buf );
	 BarHandle = GetDlgItem( hwnd, id_Bar );
	 SetScrollRange( BarHandle, SB_CTL, 0, nMaxScan, TRUE );

	 //! alle zur datenbasis verfuegbaren Infos in combobox eintragen
	 hInfoList = GetDlgItem( hwnd , id_ChooseInfo );
	  ComboBox_AddString( hInfoList , szInfoType0 );
	 InfoField[i++]=0;
	 if (AScan->ReportUse.bIntegral==TRUE)
	  {
		ComboBox_AddString( hInfoList , szInfoType1 );
		InfoField[i++]=1;
	  }
	 if (AScan->ReportUse.bAbsorber==TRUE)
	  {
		ComboBox_AddString( hInfoList , szInfoType2 );
		InfoField[i++]=2;
	  }
	 if (AScan->ReportUse.bMonitor==TRUE)
	  {
		ComboBox_AddString( hInfoList , szInfoType3);
		InfoField[i++]=3;
	  }
	 if (AScan->ReportUse.bTime==TRUE)
	  {
		ComboBox_AddString( hInfoList , szInfoType4 );
		InfoField[i++]=4;
	  }
	 ComboBox_SelectString( hInfoList, 0 , szInfoType0 );

	 FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
	 return ( TRUE );
};


//! behandelt Kommandos in der Dialogbox
void TChooseScan::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
											UINT codeNotify )
{
	 char buf[ MaxString ];
	 float x, y, fIntegral, fPeakPos, fMonitor, fAbsorber, fTime, fdummy;

	 switch ( id )
	 {
		  //! Update-Button gedrueckt
	 case id_CurveShow:
		  //! Scannummer aus Dialogbox holen + diese Darstellen
		  GetDlgItemText( hwnd, id_ScanNumber, buf, MaxString );
		  lpDBase->SetCIdx( atoi( buf ) );
		  FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
		  break;

		  //! aktualisieren
	 case cm_ParamSet:
		  //! aktuelle Kurve in Maincurve + Dialogboxeintraege eintragen +
		  //! Fenster neuzeichnen
		  AScan->nActiveScan = lpDBase->GetCIdx();
		  AScan->MainCurve = lpDBase->GetCurve( AScan->nActiveScan );
		  sprintf( buf, "%d", AScan->nActiveScan );
		  SetDlgItemText( hwnd, id_ScanNumber, buf );
		  SetScrollPos( BarHandle, SB_CTL, nMaxScan - AScan->nActiveScan, TRUE );
		  Report->SetPP( AScan->nActiveScan );
		  Report->PGet( x, y, fIntegral );
      Report2->SetPP( AScan->nActiveScan );
		  Report2->PGet( fTime, fMonitor, fAbsorber);
		  //! FIX Fehler 42
		  sprintf( buf, "%.3f", x );
		  SetDlgItemText( hwnd, id_Omega, buf );
		  Curve = AScan->MainCurve;
		  sprintf( buf, "%.1f", Curve->Max[ 1 ] );
		  SetDlgItemText( hwnd, id_PeakIntensity, buf );

		  //! je nach ausgewaehltem combobox-eintrag den zugehoerigen infowert
      //! eintragen
		  Curve->GetGravityCenter(fPeakPos,fdummy,fdummy,2);
		  if (AScan->VisualDB.bPsd)
			fPeakPos=y+ fPeakPos;
		  sprintf( buf, "%.3f", fPeakPos );
		  SetDlgItemText( hwnd, id_PeakPosition, buf );
		  switch(nInfoNumber){
		  case 0: if (AScan->VisualDB.bPsd)
						 sprintf( buf, "Psd");
					 else
						 sprintf( buf, "0-dim.");
					 break;
		  case 1: sprintf( buf, "%.1f",fIntegral);  //! integrale Intens.
					 break;
		  case 2: sprintf( buf, "%.3f",fAbsorber);  //! Absorber
					 break;
		  case 3: sprintf( buf, "%.1f",fMonitor);  //! Monitor
					 break;
		  case 4: sprintf( buf, "%.3f",fTime);  //! Zeit
					 break;
		  default: sprintf( buf, "????");
					 break;
			};
		  SetDlgItemText( hwnd, id_Info, buf );

      //! Kurve im Hintergrund neu zeichnen
		  AScan->UpdateWnd( 0 );
		  break;

	 //! auswaehlen einer anderen zusatzinfo
	 case id_ChooseInfo:
		  switch ( codeNotify )
		  {
			//! wenn neue info ausgewaehlt, dann diesen ins nachbarfeld(in cm_ParamSet
		  case CBN_SELCHANGE:{
                   int idx = ComboBox_GetCurSel( hInfoList );
									 nInfoNumber=InfoField[idx];
									 FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
									 }
			};
		  //! behandelt OK und Abbruch
	 default:
		  TModelessDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }
};

//#pragma argsused
//! wird aufgerufen, wenn in der Dialogbox die linke Maustaste nach Druecken
//! wieder losgelassen wird (sinnvoll wenn Dialogbox waehrend eines Areascans
//! aktiv ist)
void TChooseScan::Dlg_OnLButtonUp( HWND hwnd, int, int, UINT )
{
	 char buf[ MaxString ];

	 //! aktualisiert Anzahl der Scans der Datenbasis + anpassen des Scrollbar
	 nMaxScan = lpDBase->GetCNumber() - 1;
	 sprintf( buf, "%d", nMaxScan );
	 SetDlgItemText( hwnd, id_Limit, buf );
	 BarHandle = GetDlgItem( hwnd, id_Bar );
    SetScrollRange( BarHandle, SB_CTL, 0, nMaxScan, TRUE );
	 FORWARD_WM_COMMAND( hwnd, cm_ParamSet, 0, 0, SendMessage );
};

//#pragma argsused
//! wird aufgerufen, wenn Scrollbar angeclickt wurde
void TChooseScan::Dlg_OnVScrollBar( HWND hwnd, HWND hwndCtl, UINT code,
                                    int pos )
{
	 switch ( code )
	 {
        //! click auf oberen Pfeil
    case SB_LINEUP:
        lpDBase->SetCIdx( AScan->nActiveScan + 1 );
        break;

        //! click auf unteren Pfeil
    case SB_LINEDOWN:
		  lpDBase->SetCIdx( AScan->nActiveScan - 1 );
        break;

        //! anclicken + bewegen des Scrollschiebers
	 case SB_THUMBPOSITION:
        lpDBase->SetCIdx( nMaxScan - pos );
		  break;

		  //! anclicken, obwohl endposition bereits erreicht
    case SB_ENDSCROLL:
        FORWARD_WM_COMMAND( hwnd, cm_ParamSet, 0, 0, SendMessage );
        break;

		  //! anclicken oberhalb des schiebers
    case SB_PAGEUP:
        lpDBase->SetCIdx( AScan->nActiveScan + 10 );
		  break;

		  //! anclicken unterhalb des schiebers
	 case SB_PAGEDOWN:
        lpDBase->SetCIdx( AScan->nActiveScan - 10 );
        break;
    }
};

//! wird aufgerufen beim druecken des OK-Buttons
//! Rueckkehrcode immer true
BOOL TChooseScan::CanClose( void )
{
	 return TRUE;
};
//#############################################################################

//*****************************************************************************
//******* Dialog zum Setzen der AreaScan-Parameter ****************************
//*****************************************************************************

//! Konstruktor fuer Dialogeinstellungen AreaScan
//! dabei wird zunaechst der Konstruktor fuer Dialogboxen mit dem String, der
//! die Ressource spezifiziert, aufgerufen
#ifdef GermanVersion
TSetupAreaScan::TSetupAreaScan( TAreaScan* scan ) :
        TModalDlg( "AreaScanParameters" )
#else
TSetupAreaScan::TSetupAreaScan( TAreaScan* scan ) :
        TModalDlg( "AreaScanParametersEng" )
#endif
{
	 //! einige Parameter vom AreaScan-fenster uebernehmen
	 Scan = scan;
	 mlSetAxis( nOmega );
	 strcpy( szOWF, mGetSF() );
	 mlSetAxis( nTheta );
	 strcpy( szTWF, mGetSF() );
	 nOmega = Scan->nOmega;
	 nTheta = Scan->nTheta;
	 Device = Scan->Device;
	 nOldMotor = mlGetAxis();
	 //! wenn ein PSD-det. verfuegbar ist, dann Wert fuer zusammenzufassende
    //! Kanaele setzen
    if ( Scan->bPsdDevice )
		  Device->SetAddedChannels( Scan->nAddedChannels );

	 //! o-t-offset aus AreaScanfenster holen
	 dThetaOffset = Scan->dOffsetTheta;
   dOmegaOffset = Scan->dOffsetOmega;
};

//#pragma argsused
//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TSetupAreaScan::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
	 int i = 0 ;
	 char buf[ MaxString ];

   //! 2-thetastartposition in Dialog
	 d2ThetaStart = Scan->d2ThetaStart;
	 sprintf( buf, "%.4f", d2ThetaStart );
	 SetDlgItemText( GetHandle(), id_2Theta, buf );
	 //! FIX Fehler 74
	 if(!mlIsAxisValid(Theta))
	  {
    Scan->eScanType=StandardScan;
    EnableWindow( GetDlgItem( hwnd, id_2Theta ), FALSE );
    }
	 //! Werte fuer Checkboxen 'Save on Ready' und 'Using Absorber' setzen
	 CheckDlgButton( hwnd, id_SaveOnReady, Scan->bSaveOnReady );
   //! nur wenn absorber exist diesen ev. aktivieren
   if(mlIsAxisValid(Absorber))
	     CheckDlgButton( hwnd, id_AbsorberUsed, Scan->ReportUse.bAbsorber );
	 //! diverse Werte in Dialogbox setzen
	 sprintf( buf, "%.1f", Scan->fMaxTime );
	 SetDlgItemText( GetHandle(), id_MaxTime, buf );
	 //! Fehler id_ThetaUnit existiert nicht
	 mlSetAxis( nTheta );
	 SetDlgItemText( GetHandle(), id_ThetaUnit, mGetAxisUnit() );
	 mlSetAxis( nOmega );
	 SetDlgItemText( GetHandle(), id_Unit, mGetAxisUnit() );
	 sprintf( buf, mGetDF(), Scan->dOmegaMax );
	 SetDlgItemText( GetHandle(), id_AngleMax, buf );
	 sprintf( buf, mGetDF(), Scan->dOmegaMin );
	 SetDlgItemText( GetHandle(), id_AngleMin, buf );
	 sprintf( buf, "%lu", Scan->dwMaxCounts );
	 SetDlgItemText( GetHandle(), id_MaxCounts, buf );
	 CheckDlgButton( GetHandle(), id_Standard,
						  Scan->eSaveFormat == StandardFile );
//	 CheckDlgButton( GetHandle(), id_DIB_Format, Scan->eSaveFormat == Bitmap );
	 //! aufnehmen aller verfuegbaren Detektoren in Combobox und vorauswahl des
	 //! aktuell eingestellten Det.
	 hDeviceList = GetDlgItem( GetHandle(), id_ChooseDevice );
	 i = 0;
		while ( i <= lpDList->LastId() )
			ComboBox_AddString( hDeviceList, lpDList->DP( i++) ->Characteristic );
	 ComboBox_SelectString( hDeviceList, 0 , Device->Characteristic );
	 CheckDlgButton( hwnd, id_SaveContinuous, Scan->bSaveContinuous );
	 //! FIX Fehler 38
	 sprintf( buf, szOWF, Scan->dOmegaWidth );
	 SetDlgItemText( hwnd, id_AngleWidth, buf );
	 SetDlgItemText( hwnd, id_Catalog, Scan->szDataPath );
	 sprintf( buf, "%.2lf", Scan->dMoveRelation );
				SetDlgItemText( hwnd, id_Relation, buf );

	 //! neu akk
	 //! einstellen der Art der Darstellungsaktualisierung
	 CheckDlgButton( hwnd, id_Final, !Scan->bAccumulatedDisplay );
	 CheckDlgButton( hwnd, id_Akkumulation, Scan->bAccumulatedDisplay );

   //! Omega-,ThetaOffset nicht benutzen (immer als voreinstellung )
	 CheckDlgButton( hwnd, id_Offset, FALSE );
	 EnableWindow( GetDlgItem( hwnd, cm_SetOffset ), FALSE );

	 //! nur wenn Theta existiert einen Kanaloffset erlauben +
   //! defaultwert eintragen
   if (!mlIsAxisValid(Theta))
      {
	    EnableWindow( GetDlgItem( hwnd, id_MeasurementChannel ), FALSE );
      strcpy(buf,"0");
      }
   else
      sprintf(buf,"%d", Scan->nMeasurementChannel);
	 SetDlgItemText( GetHandle(), id_MeasurementChannel, buf );
   //! Monitordetektor voreinstellungen
	 CheckDlgButton( hwnd, id_MonitorUsed, Scan->ReportUse.bMonitor );
	 EnableWindow( GetDlgItem( hwnd, cm_RotateDevice ), Scan->ReportUse.bMonitor );
	 if (Scan->ReportUse.bMonitor)
		{
		Monitor = Scan->Monitor;
		SetDlgItemText( hwnd, cm_RotateDevice, Monitor->Characteristic );
		}
   else
	 Monitor = Scan->Device;


	 //! bewirkt aufruf von Dlg_OnCommand mit den Kommandos cm_ParamSet und
	 //! cm_SetupParameters
	 FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
	 FORWARD_WM_COMMAND( hwnd, cm_SetupParameters, hwndCtl, 0, SendMessage );
	 return TRUE;
};

//! behandelt Kommandos in der Dialogbox
void TSetupAreaScan::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
                                    UINT codeNotify )
{
	 char buf[ MaxString ];
	 int idx;
 	 //! Pointer fuer Offset-dialog
	 TModalDlg * dlg;

	 //! abhaengig von Dialogelement bzw. Kommando
	 switch ( id )
    {
        //! initialisierung
	 case cm_ParamSet:
         //! abhaengig vom Scantyp einige Dialogelemente sperren bzw. freigeben
        switch ( Scan->eScanType )
		  {
        case Omega2ThetaScan:
				    EnableWindow( GetDlgItem( hwnd, id_Relation ), TRUE );
				//! abhaengig ob PSD verfuegbar oder nicht Dialogelemente sperren
				//! bzw. freigeben
				//! FIX Fehler 53
				CheckDlgButton( GetHandle(), id_FixThetaAxis, FALSE );
				if ( Scan->bPsdDevice )
				{
					 //! FIX Fehler 59
					 EnableWindow( GetDlgItem( hwnd, id_MaxCounts ), FALSE);
					 //! FIX Fehler 55
					 EnableWindow( GetDlgItem( hwnd, id_AbsorberUsed ), TRUE );
					 EnableWindow( GetDlgItem( hwnd, id_FixThetaAxis ), TRUE );
					 EnableWindow( GetDlgItem( hwnd, id_ThetaWidth ), FALSE );
					 EnableWindow( GetDlgItem( hwnd, id_ThetaWindow ), FALSE );
					 Scan->nAddedChannels = Device->GetAddedChannels();
					 Device->SetAddedChannels( Scan->nAddedChannels );
					 sprintf( buf, "%.3f", Device->GetWidth() );
					 SetDlgItemText( hwnd, id_ThetaWidth, buf );
  				 //! neu akk
					 //! bei psd Darstellungsaktualisierungmodus erlaubt
					 EnableWindow( GetDlgItem( hwnd, id_Akkumulation ), TRUE );
					 EnableWindow( GetDlgItem( hwnd, id_Final ), TRUE );
					 EnableWindow( GetDlgItem( hwnd, id_MonitorUsed ), TRUE );

				}
				else
				{
					 //! FIX Fehler 59
					 EnableWindow( GetDlgItem( hwnd, id_MaxCounts ), TRUE);
					 //! FIX Fehler 55
					 EnableWindow(GetDlgItem(hwnd,id_AbsorberUsed),FALSE);
                CheckDlgButton(hwnd,id_AbsorberUsed,FALSE);
					 //! FIX Fehler 53
                EnableWindow( GetDlgItem( hwnd, id_FixThetaAxis ), FALSE );
                EnableWindow( GetDlgItem( hwnd, id_ThetaWindow ), TRUE );
                EnableWindow( GetDlgItem( hwnd, id_ThetaWidth ), TRUE );
					 sprintf( buf, szTWF, Scan->dThetaWindow );
                SetDlgItemText( hwnd, id_ThetaWindow, buf );
					 sprintf( buf, szTWF, Scan->dThetaWidth );
                SetDlgItemText( GetHandle(), id_ThetaWidth, buf );
						EnableWindow( GetDlgItem( hwnd, id_MeasurementChannel ), FALSE );
						//! neu akk
						//! bei 0-dim. detektor Darstellungsaktualisierungmodus nicht
						//! erlaubt
						EnableWindow( GetDlgItem( hwnd, id_Akkumulation ), FALSE );
						EnableWindow( GetDlgItem( hwnd, id_Final ), FALSE );
						CheckDlgButton( GetHandle(), id_Akkumulation , FALSE);
						CheckDlgButton( GetHandle(), id_Final , TRUE);

						EnableWindow( GetDlgItem( hwnd, id_MonitorUsed ), FALSE );
						CheckDlgButton( GetHandle(), id_MonitorUsed , FALSE);
						EnableWindow( GetDlgItem( hwnd, cm_RotateDevice ), FALSE );

            }
            break;

		  case StandardScan:

				//! FIX Fehler 59
				EnableWindow( GetDlgItem( hwnd, id_MaxCounts ), FALSE);
				//! FIX Fehler 55
            EnableWindow( GetDlgItem( hwnd, id_AbsorberUsed ), TRUE );
				CheckDlgButton( GetHandle(), id_FixThetaAxis, TRUE );
				EnableWindow( GetDlgItem( hwnd, id_FixThetaAxis ), TRUE );
				EnableWindow( GetDlgItem( hwnd, id_ThetaWindow ), FALSE );
				EnableWindow( GetDlgItem( hwnd, id_ThetaWidth ), FALSE );
				EnableWindow( GetDlgItem( hwnd, id_Relation ), FALSE );
            Scan->nAddedChannels = Device->GetAddedChannels();
				Device->SetAddedChannels( Scan->nAddedChannels );
				sprintf( buf, "%.3f", Device->GetWidth( mGetUnitType() ) );
				SetDlgItemText( hwnd, id_ThetaWidth, buf );
				sprintf( buf, szTWF, Scan->dThetaWindow );
            SetDlgItemText( hwnd, id_ThetaWindow, buf );
						//! neu akk
						//! bei psd Darstellungsaktualisierungmodus erlaubt
						EnableWindow( GetDlgItem( hwnd, id_Akkumulation ), TRUE );
						EnableWindow( GetDlgItem( hwnd, id_Final ), TRUE );
						EnableWindow( GetDlgItem( hwnd, id_MonitorUsed ), TRUE );

            break;

		  default:
				MessageBox( GetFocus(), szDlgMsgLine001, szDlgFailure, MBSTOP );
            break;
		  }
        //! Focus auf OK-Button der Box
        SetFocus( GetDlgItem( hwnd, IDOK ) );
        break;

        //! 'Update Parameters'-Button betaetigt
    case cm_SetupParameters:
		  FORWARD_WM_COMMAND( hwnd, cm_InquireRelevantData, hwndCtl, 0,
									 SendMessage );
		  FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
        break;

		  //! uebernehmen von einigen Dialogeintraegen ohne pruefung (fehler)
		  //! 'Data Catalog','Save each Scan',Omegaschrittweite,Thetarelation,
		  //! Speicherformat
	 case cm_InquireRelevantData:
		  GetDlgItemText( GetHandle(), id_Catalog, ( LPSTR ) Scan->szDataPath,
								MaxString );
		  Scan->bSaveContinuous = IsDlgButtonChecked( GetHandle(),
										  id_SaveContinuous );
		  // Bestimmen der Schrittweite und Schrittrelation
		  GetDlgItemText( GetHandle(), id_AngleWidth, buf, MaxString );
		  Scan->dOmegaWidth = atof( buf );
		  GetDlgItemText( GetHandle(), id_Relation, buf, MaxString );
		  Scan->dMoveRelation = atof( buf );
		  //! uebernahme von Scantyp und abhaengig davon weitere werte
		  switch ( Scan->eScanType )
		  {
		  case Omega2ThetaScan:
				if ( Scan->bPsdDevice )
				{
					 if ( IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ) )
					 {
						  Scan->eScanType = StandardScan;
						  break;
					 }
					 sprintf( buf, szTWF, Scan->dMoveRelation * Scan->dOmegaWidth );
					 SetDlgItemText( GetHandle(), id_ThetaWidth, buf );
				}
				else
				{
					 GetDlgItemText( GetHandle(), id_ThetaWindow, buf, MaxString );
					 Scan->dThetaWindow = atof( buf );
					 GetDlgItemText( GetHandle(), id_ThetaWidth, buf, MaxString );
					 Scan->dThetaWidth = atof( buf );
				}
				break;

		  case StandardScan:
				if ( !IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ) )
				{
					 Scan->eScanType = Omega2ThetaScan;
					 if ( Scan->bPsdDevice )
					 {
						  sprintf( buf, szTWF, Scan->dMoveRelation * Scan->dOmegaWidth );
						  SetDlgItemText( GetHandle(), id_ThetaWidth, buf );
					 }
				}
				break;

		  default:
				MessageBox( GetFocus(), szDlgMsgLine001, szDlgFailure, MBSTOP );
				break;
		  }
		  Scan->eSaveFormat = StandardFile;
//!		  if ( IsDlgButtonChecked( GetHandle(), id_DIB_Format ) )
//!				Scan->eSaveFormat = Bitmap;
//!		  if ( IsDlgButtonChecked( GetHandle(), id_Standard ) )
//!				Scan->eSaveFormat = StandardFile;
		  break;

		  //! Detektor-auswahlbox angewaehlt
	 case id_ChooseDevice:
		  switch ( codeNotify )
		  {
				//! wenn neuer det. ausgewaehlt, dann diesen als aktuellen Det.
				//! setzen und neuinitialisierung (cm_ParamSet)
		  case CBN_SELCHANGE:
				idx = ComboBox_GetCurSel( hDeviceList );
				if ( ( Device != lpDList->DP( idx ) ) && ( idx != CB_ERR ) )
				{
					 Device = lpDList->DP( idx );
					 Scan->SetDevice( Device->GetId() );
					//! FIX Fehler 74
                if(!mlIsAxisValid(Theta) && !Scan->bPsdDevice)
                 {
                 Scan->SetDevice( dlGetIdByName(PsdDevice));
                 Device= lpDList->DP(dlGetIdByName(PsdDevice));
					  ComboBox_SelectString( hDeviceList, 0, Device->Characteristic );
                 }
                else
					  if( Scan->bPsdDevice)
						{
                  Scan->eScanType = StandardScan;
                  //! kanaloffset nur bei eingest. Psd und exist. Theta zulassen
                  if (mlIsAxisValid(Theta))
                    EnableWindow( GetDlgItem( hwnd, id_MeasurementChannel ), TRUE );
                  EnableWindow( GetDlgItem( hwnd, id_MonitorUsed ), TRUE );
                  }
                 else
                  {
						      Scan->eScanType = Omega2ThetaScan;

						      EnableWindow( GetDlgItem( hwnd, id_MeasurementChannel ), FALSE );
                  EnableWindow( GetDlgItem( hwnd, id_MonitorUsed ), FALSE );
                  CheckDlgButton( GetHandle(), id_MonitorUsed , FALSE);
                  EnableWindow( GetDlgItem( hwnd, cm_RotateDevice ), FALSE );
                  }
					 FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, PostMessage );
				}
		  }
		  break;

		  //! 'Device Settings'-Button betaetigt
		  //! bewirkt Aufruf der zum eingestellten Detekt. gehoerigen Settingsbox
		  //! und uebernahme der akt. Einstellungen ohne pruefung
	 case cm_SpecificParameters:
		  // spezifische Parameter fuer einen Sensor setzen
		  if ( Scan->bPsdDevice )
		  {
				TheModeless = ( TPsdParameters * ) new TPsdParameters();
				if ( TheModeless )
					 TheModeless->Initialize();
		  }
		  else
				Device->SetSpezificParametersDlg();
		  FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, SendMessage );
		  break;
		 //! FIX Fehler 74
   case id_FixThetaAxis:
      if (!mlIsAxisValid(Theta))
       CheckDlgButton(GetHandle(),id_FixThetaAxis,TRUE);

      //! 2thetawert bei fixierter Thetaachse vorgeben wenn Theta exist.
      if(IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ))
        {
         if (mlIsAxisValid(Theta))
          {
           double dPos;
           mlGetDistance(mlGetIdByName( Theta ), dPos);
           sprintf(buf,"%f",dPos);
           }
         else
           strcpy(buf,"  ");
         SetDlgItemText( GetHandle(), id_2Theta, buf );
        }
  		  FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, PostMessage );
		    break;

		  //! anclicken der folgenden Dialogelemente bewirkt uebernahme der akt.
		  //! Einstellungen ohne pruefung

/*	 case id_DIB_Format:
	 case id_Standard:
		  FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, PostMessage );
		  break;*/

	 //! neu akk
	 //! exclusives oder bei aktualisierungsoptionen
	 case id_Akkumulation: CheckDlgButton(GetHandle(),id_Final,FALSE);
										break;
	 case id_Final:    CheckDlgButton(GetHandle(),id_Akkumulation,FALSE);
										break;

	 //! FIX Fehler 71
	 case id_SaveContinuous:
                    CheckDlgButton(GetHandle(),id_SaveOnReady,FALSE);
										break;
	 case id_SaveOnReady:
                    CheckDlgButton(GetHandle(),id_SaveContinuous,FALSE);
										break;

  //! bei monitorbenutzung den rotatebutton freigeben bzw. sperren
	case id_MonitorUsed:
						 if(!Monitor)
                       {
                        CheckDlgButton(GetHandle(),id_MonitorUsed,FALSE);
                        break;
                       }
						 if(IsDlgButtonChecked( GetHandle(), id_MonitorUsed ))
                     EnableWindow( GetDlgItem( hwnd, cm_RotateDevice ), TRUE );
                   else
                     EnableWindow( GetDlgItem( hwnd, cm_RotateDevice ), FALSE );
                   break;
  //! auswaehlen von absorberbenutz. nur eraubt wenn absorber exist.
	case id_AbsorberUsed:
						 if(!mlIsAxisValid(Absorber))
                    {
						  MessageBox(GetFocus(),szDlgMsgLine003,szDlgFailure,MBINFO);
                    CheckDlgButton(GetHandle(),id_AbsorberUsed,FALSE);
                    }
                   break;

   //! benutzen von Omega-,thetaoffset
   case id_Offset: if(IsDlgButtonChecked( GetHandle(), id_Offset ))
                     {
                     //! Einstellungsbutton (de)aktivieren
                     EnableWindow( GetDlgItem( hwnd, cm_SetOffset ), TRUE );
                     //! dialog automatisch aufrufen
                	   FORWARD_WM_COMMAND( GetHandle(), cm_SetOffset, 0, 0, SendMessage );
                     }
						 else
                     EnableWindow( GetDlgItem( hwnd, cm_SetOffset ), FALSE );
                   break;


	case cm_SetOffset:{
                      //! dialog aufrufen
			              	dlg = ( TSetOffset * ) new TSetOffset(IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ),this  );
              				dlg->ExecuteDialog( hwnd );
								delete dlg;
								break;
							  }

   //! naechsten detektor in detektorliste als monitordet. auswaehlen
   case cm_RotateDevice:
		  Monitor = lpDList->DP( Monitor->GetId() + 1 );
		  SetDlgItemText( GetHandle(), cm_RotateDevice,( LPSTR ) Monitor->Characteristic );
		  break;
		  //! hier werden IDOK und IDCANCEL ... behandelt
	 default:
		  TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }
};

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen der
//! Dialogbox (durch OK-Button)
//! Rueckkehrcode false wenn die Dialogbox nicht geschlossen werden kann (werte
//! inkonsistent) sonst true
BOOL TSetupAreaScan::CanClose( void )
{
	 char buf[ MaxString ], dir[ _MAX_DIR ], drv[ _MAX_DRIVE ], name[ _MAX_FNAME ],
	 ext[ _MAX_EXT ];
	 float valueF;
	 OFSTRUCT of;
	 long valueL;
	 int hFile;
	 BOOL bFailure = FALSE;
   //! lokaler wert fuer psd-offset
	 double dPsdOffset=0.0;
   //! lokaler wert fuer messkanalnr.
	 int nChannel=0;
   //! lokale Wert fuer o-t-offset
   double dTO = dThetaOffset,dOO = dOmegaOffset;

	 //! uebernehmen von einigen werten ohne pruefung
	 FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, SendMessage );
	 //! uebernahme der CheckButtons 'Save on Ready' und 'Using Absorber'
	 Scan->bSaveOnReady = IsDlgButtonChecked( GetHandle(), id_SaveOnReady );
	 Scan->ReportUse.bAbsorber=IsDlgButtonChecked( GetHandle(), id_AbsorberUsed );
	 //! o-t-offset verwenden bzw. nicht verwenden
	 switch(Scan->eScanType){
	 case StandardScan: dTO = 0.0;
	 case Omega2ThetaScan:if (!IsDlgButtonChecked( GetHandle(), id_Offset ))
											  dTO=dOO=0.0;
								 break;
	 }
   //! Psd-spezifische parameter
	 if (Scan->bPsdDevice)
	  {
		  //! neu akk
		  //! art der darstellungsaktualisierung an Scanfenster uebergeben
		  Scan->bAccumulatedDisplay = IsDlgButtonChecked( GetHandle(), id_Akkumulation );

      //! testen ob messkanalnr. eine gueltige kanalNr. ist
			GetDlgItemText( GetHandle(), id_MeasurementChannel, buf, MaxString );
			nChannel = atol( buf );
      TPsd* PsdDev = (TPsd*)lpDList->DP(lpDList->GetIdByName(PsdDevice));
			if ((nChannel<0)||(nChannel>PsdDev->GetChannelNumber()))
			{
			 sprintf(buf,szDlgMsgLine004,PsdDev->GetChannelNumber());
			 MessageBox(GetFocus(),buf,szDlgMessage,MBINFO);
		   SetDlgItemText( GetHandle(), id_MeasurementChannel, "0" );
       bFailure = TRUE;
			}
      else
      {
       //! psd-offset berechnen
       dPsdOffset = - (double)(nChannel*PsdDev->GetAngleStep());
      }
   }

	 //! uebernahme des Omega-Maximum mit Pruefung, ob der Wert kleiner als der
	 //! maximal erlaubte
	 //! wenn Wert nicht kleiner als der max. erlaubte dann auf
	 //! Max.Wert-Schrittweite setzen + Setzen des korrekten Wertes fuer
	 //! Theta-Window? (Fehler) + Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_AngleMax, buf, MaxString );
	 valueF = atof( buf );
	 //! FIX Fehler 50,52
	 if ( (valueF+dOO < mlGetValue( nOmega, MaxDistance ))&&
			(valueF+dOO > mlGetValue( nOmega, MinDistance )))
		  Scan->dOmegaMax = valueF;
	 else
	 {
		  Scan->dOmegaMax = ( mlGetValue( nOmega, MaxDistance ) -
									 mlGetValue( nOmega, MinWidth ) );
		  sprintf( buf, mGetDF(), Scan->dOmegaMax );
		  SetDlgItemText( GetHandle(), id_AngleMax, buf );
		MessageBox(GetFocus(),szDlgMsgLine005,szDlgMessage,MBINFO);
		  bFailure = TRUE;
	 }

	 //! uebernahme des Omega-Minimum mit Pruefung, ob der Wert groesser als der
	 //! maximal erlaubte
	 //! wenn Wert nicht groesser als der max. erlaubte dann auf
	 //! Min.Wert+Schrittweite setzen + Setzen des korrekten Wertes fuer
	 //! Minimum + Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_AngleMin, buf, MaxString );
	 valueF = atof( buf );
	 //! FIX Fehler 50
	 if ((valueF+dOO < mlGetValue( nOmega, MaxDistance ))&&
		 ( valueF+dOO > mlGetValue( nOmega, MinDistance ) ))
		  Scan->dOmegaMin = valueF;
	 else
	 {
		  Scan->dOmegaMin = ( mlGetValue( nOmega, MinDistance ) +
									 mlGetValue( nOmega, MinWidth ) );
		  sprintf( buf, mGetDF(), Scan->dOmegaMin );
		  SetDlgItemText( GetHandle(), id_AngleMin, buf );
      MessageBox(GetFocus(),szDlgMsgLine005,szDlgMessage,MBINFO);
		  bFailure = TRUE;
	 }
	//! FIX Fehler 50,52
	 if (Scan->dOmegaMin >= Scan->dOmegaMax)
	  {
		Scan->dOmegaMax = ( mlGetValue( nOmega, MaxDistance ) -
								  mlGetValue( nOmega, MinWidth ) );
		sprintf( buf, mGetDF(), Scan->dOmegaMax );
		SetDlgItemText( GetHandle(), id_AngleMax, buf );
		Scan->dOmegaMin = ( mlGetValue( nOmega, MinDistance ) +
								  mlGetValue( nOmega, MinWidth ) );
		sprintf( buf, mGetDF(), Scan->dOmegaMin );
		SetDlgItemText( GetHandle(), id_AngleMin, buf );
		bFailure = TRUE;
	  }

    //! 2theta aus Dialogbox wird fuer bereichsuebrschreitungstests gebraucht
  	GetDlgItemText( GetHandle(), id_2Theta, buf, MaxString );
		d2ThetaStart = atof( buf );

    //!FIX Fehler 60
	 switch (Scan->eScanType){
	 case Omega2ThetaScan:
                //! Relation ermitteln
                GetDlgItemText( GetHandle(), id_Relation, buf, MaxString );
					 if ((Scan->dMoveRelation = atof( buf ))<= 0)
			           {
							 Scan->dMoveRelation = 2;
							 bFailure = TRUE;
			           }
		            sprintf( buf, "%.2lf", Scan->dMoveRelation );
		            SetDlgItemText( GetHandle(), id_Relation, buf );

                if (!(Scan->bPsdDevice))
								 {
								  //! uebernahme des Theta-Window mit Pruefung, ob der
								  //! Wert groesser 0 wenn nicht, setzen auf
								  //! (OmegaMax-OmegaMin)*Relation + eintragen des
								  //! entsprechenden Wertes in Dlg.Box + Box wird nicht
								  //! verlassen
								  GetDlgItemText( GetHandle(), id_ThetaWindow, buf, MaxString );
								  valueF = atof( buf );
								 //! FIX Fehler 50
								 if ( valueF > 0 )
									  Scan->dThetaWindow = valueF;
								 else
								 {
								  Scan->dThetaWindow = ( Scan->dOmegaMax - Scan->dOmegaMin ) *
									  Scan->dMoveRelation;
								  sprintf( buf, szTWF, Scan->dThetaWindow );
								  SetDlgItemText( GetHandle(), id_ThetaWindow, buf );
								  bFailure = TRUE;
                 }

	 //! uebernahme der Theta-Schrittweite mit Pruefung, ob der Wert ungleich 0
	 //! (Fehler) wenn nicht, setzen auf OmegaSchrittweite*Relation + eintragen
	 //! des entsprechenden Wertes in Dlg.Box + Box wird nicht verlassen
									GetDlgItemText( GetHandle(), id_ThetaWidth, buf, MaxString );
									 valueF = atof( buf );
								 //! FIX Fehler 50
								 if ( valueF > 0 )
									  Scan->dThetaWidth = valueF;
								 else
								 {
								  Scan->dThetaWidth = Scan->dOmegaWidth * Scan->dMoveRelation;
								  sprintf( buf, mGetDF(), Scan->dThetaWidth );
								  SetDlgItemText( GetHandle(), id_ThetaWidth, buf );
								  bFailure = TRUE;
								 }
								 //! uebernahme der Messimpulse mit Pruefung, ob der Wert ungleich 0 (Fehler)
								 //! wenn nicht, wird Box wird nicht verlassen
								 GetDlgItemText( GetHandle(), id_MaxCounts, buf, MaxString );
								 valueL = atol( buf );
								 //! FIX Fehler 50
								 if ( 0 < valueL )
								 {
								  Scan->dwMaxCounts = valueL;
								 }
								 else
								  bFailure = TRUE;
                 Scan->ReportUse.bTime=FALSE;
                 Scan->ReportUse.bIntegral=FALSE;
                 //! test ob Thetabereichsueberschreitung bei sld
                 if (!bFailure)
                 {
                 if (((d2ThetaStart-0.5*Scan->dThetaWindow)+dTO <= mlGetValue( nTheta, MaxDistance ))&&
                    ((d2ThetaStart-0.5*Scan->dThetaWindow)+dTO >= mlGetValue( nTheta, MinDistance )))
                   {
                   Scan->dThetaMin = d2ThetaStart-0.5*Scan->dThetaWindow;
                   //! Thetawinkel fuer letzten punkt des letzten spektrums
                   //! ermitteln + test ob dieser wert gueltig
                   valueF = d2ThetaStart+(Scan->dOmegaMax-Scan->dOmegaMin)*
                            Scan->dMoveRelation+0.5*Scan->dThetaWindow;

						 if(valueF+dTO <=mlGetValue( nTheta, MaxDistance ))
                      Scan->d2ThetaStart = d2ThetaStart;
						 else
						  {
							 MessageBox(GetFocus(),szDlgMsgLine006,szDlgMessage,MBINFO);
							 bFailure = TRUE;
						  }
						 }
					  else
						 {
						  MessageBox(GetFocus(),szDlgMsgLine006,szDlgMessage,MBINFO);
                    bFailure = TRUE;
                   }

					  }
							 }
					else //! O2T-Scan mit Psd
               {
                 //! test Thetabereichsueberschreitung O2T mit Psd
                 if (!bFailure)
                 {
                  //! ermitteln des Thetawinkel fuer letztes Spektrum + test ob
                  //! Bereichsueberschreitung
                  valueF = d2ThetaStart+(Scan->dOmegaMax-Scan->dOmegaMin)*
                           Scan->dMoveRelation;
                  if(((valueF+dTO+dPsdOffset) >=mlGetValue( nTheta, MinDistance ))&&
                     ((valueF+dTO+dPsdOffset) <=mlGetValue( nTheta, MaxDistance )))
                    {
                     Scan->dThetaMax = valueF;
							if(((d2ThetaStart+dTO+dPsdOffset) >= mlGetValue( nTheta, MinDistance ))
							 && ((d2ThetaStart+dTO+dPsdOffset) <=mlGetValue( nTheta, MaxDistance )))
							  {
							  Scan->d2ThetaStart = d2ThetaStart;
							  Scan->dThetaMin = d2ThetaStart;
							  }
							else
							 {
                        MessageBox(GetFocus(),szDlgMsgLine006,szDlgMessage,MBINFO);
                        bFailure = TRUE;
                      }
							}
						else
                    {
                      MessageBox(GetFocus(),szDlgMsgLine006,szDlgMessage,MBINFO);
                      bFailure = TRUE;
                    }
					  }
                //! bei Psd diese infos immer anlegen
					      Scan->ReportUse.bTime=TRUE;
                Scan->ReportUse.bIntegral=TRUE;

               }break;

   case StandardScan://! bei Psd diese infos immer anlegen
                     Scan->ReportUse.bTime=TRUE;
                     Scan->ReportUse.bIntegral=TRUE;

                 //! test Thetabereichsueberschreitung StandardScan
               if (!bFailure)
                //! test ob Theta exist. wenn ja wert testen+ ev.uebernehmen
                //! sonst nicht
                if(mlIsAxisValid( Theta ))
                 if(((d2ThetaStart+dPsdOffset) >= mlGetValue( nTheta, MinDistance ))
							   && ((d2ThetaStart+dPsdOffset) <=mlGetValue( nTheta, MaxDistance )))
                 {
                  Scan->dThetaMin = d2ThetaStart;
                  Scan->dThetaMax = d2ThetaStart;
                  Scan->d2ThetaStart = d2ThetaStart;
                 }
                 else
                 {
                  MessageBox(GetFocus(),szDlgMsgLine006,szDlgMessage,MBINFO);
                  bFailure = TRUE;
                 }

							 break;

	 default:;
	 }

	 //! uebernahme der Messzeit mit Pruefung, ob der Wert ungleich 0
	 //! wenn nicht, wird Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_MaxTime, buf, MaxString );
	 valueF = atof( buf );
	 //! FIX Fehler 50
	 if ( 0.0 < valueF )
	 {
		  Scan->fMaxTime = valueF;
	 }
	 else
		  bFailure = TRUE;

	 //! uebernahme des Datenpfades, wenn er sich beschreiben laesst
	 //! ansonsten auf "C:\\" setzen + Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_Catalog, ( LPSTR ) Scan->szDataPath,
						  MaxString );
	 // Testen, ob sich der Pfad auch beschreiben laesst
	 if ( Scan->szDataPath[ strlen( Scan->szDataPath ) - 1 ] != '\\' )
		  strcat( Scan->szDataPath, "\\" );
	 _splitpath( Scan->szDataPath, drv, dir, name, ext );
	 _makepath( Scan->szDataPath, drv, dir, "check", "tmp" );
	 hFile = OpenFile( Scan->szDataPath, &of, OF_CREATE );
	 if ( -1 != hFile )
	 {
		  _lclose( hFile );
		  remove( Scan->szDataPath );
		  _makepath( Scan->szDataPath, drv, dir, "", "" );
	 }
	 else
	 {
		  bFailure = TRUE;
		  strcpy( Scan->szDataPath, "c:\\" );
		  //! FIX Fehler 38
		  SetDlgItemText( GetHandle(), id_Catalog, Scan->szDataPath );
	 }
	  //! FIX Fehler 38,51
		  GetDlgItemText( GetHandle(), id_AngleWidth, buf, MaxString );
		  if ( atof( buf ) >= mGetValue( MinWidth ) )
			 Scan->dOmegaWidth = atof( buf );
		  else
			 {
			 Scan->dOmegaWidth = mGetValue( MinWidth );
			  bFailure = TRUE;
			 }
		  sprintf( buf, szOWF, Scan->dOmegaWidth );
		  SetDlgItemText( GetHandle(), id_AngleWidth, buf );

	//! wenn bisher keine fehler auftraten diverse werte an Areasanfenster
  //! uebergeben
	if( !bFailure)
   {
     //! Offsetwerte uebernehmen
   	 Scan->dOffsetOmega=dOO;
  	 Scan->dOffsetTheta=dTO;
     Scan->dPsdOffset = dPsdOffset;
     Scan->nMeasurementChannel = nChannel;
     //! gewollte zusatzinfos
     Scan->ReportUse.bMonitor=IsDlgButtonChecked( GetHandle(), id_MonitorUsed );
	   Scan->ReportUse.bAbsorber=IsDlgButtonChecked( GetHandle(), id_AbsorberUsed );
   }

	 //! bei aufgetretenen Fehlern cm_ParamSet senden und Dialogbox nicht
	 //! schliessen
	 if ( bFailure )
	 {
		  PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0l );
		  return FALSE;
	 }

	 return TRUE;
};

//! wird bei verlassen der Dlg.box aufgerufen (in dieser Dlg.box keine
//! Bedeutung) da auch geerbt
BOOL TSetupAreaScan::LeaveDialog( void )
{
	 return TRUE;
}

//! dialog zum einstellen des Omega- und Thetaoffset
#ifdef GermanVersion
TSetOffset::TSetOffset( BOOL bValue, TSetupAreaScan *dlg) : TModalDlg( "SetOffset" )
#else
TSetOffset::TSetOffset( BOOL bValue, TSetupAreaScan *dlg ) : TModalDlg( "SetOffsetEng" )
#endif
{
 //! Pointer auf Areascandialog setzen
 dialog = dlg;

 bOnlyOmega=bValue;
};

//#pragma argsused
BOOL TSetOffset::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
  char buf[MaxString];
  double dRealAngle=15.0;

  //! werte initialisieren + in Dialog schreiben
  bOmegaDirect = bThetaDirect = TRUE;
  dThetaOffset = dialog->dThetaOffset;
  dOmegaOffset = dialog->dOmegaOffset;
  mlGetDistance( mlGetIdByName( Omega ), dRealAngle);
  dIdealOmega = dRealAngle-dOmegaOffset;
  sprintf(buf," %f",/*dIdealTheta +   dOmegaOffset*/ dRealAngle);
  SetDlgItemText( GetHandle(), id_RealOmega, buf );

  sprintf(buf," %f",dIdealOmega);
  SetDlgItemText( GetHandle(), id_IdealOmega, buf );

  sprintf(buf," %f",dThetaOffset);
  SetDlgItemText( GetHandle(), id_ThetaOffset, buf );
  sprintf(buf," %f",dOmegaOffset);
  SetDlgItemText( GetHandle(), id_OmegaOffset, buf );

  //! wenn Thetaachse fixiert dann keinen Thetaoffset
  if(bOnlyOmega)
	{
	 EnableWindow( GetDlgItem( hwnd, cm_SetThetaOffset ), FALSE );
	 EnableWindow( GetDlgItem( hwnd, id_RealTheta ), FALSE );
	 EnableWindow( GetDlgItem( hwnd, id_IdealTheta ), FALSE );
	 EnableWindow( GetDlgItem( hwnd, id_ThetaOffset ), FALSE );
	}
  else
   {
   mlGetDistance( mlGetIdByName( Theta ), dRealAngle);
   dIdealTheta = dRealAngle-dThetaOffset;
   sprintf(buf," %f",/*dIdealOmega +   dThetaOffset*/dRealAngle);
   SetDlgItemText( GetHandle(), id_RealTheta, buf );
   sprintf(buf," %f",dIdealTheta);
   SetDlgItemText( GetHandle(), id_IdealTheta, buf );
   }
  return TRUE;
};


void TSetOffset::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
											UINT codeNotify )
{
	char buf[MaxString];
	float ValueF;

  //! Button bezeichnungen
#ifdef GermanVersion
	char szButtonText1[]= "Winkel berechnen";
	char szButtonText2[]= "Offset berechnen";
#else
	char szButtonText1[]= "calculate angle";
	char szButtonText2[]= "calculate offset";
#endif

	switch ( id ){

  //! eingabe in Omegaoffset-feld
	case id_OmegaOffset:
                //! neue Buttonbezeichnung + berechnungsmodus setzen
							  SetDlgItemText( GetHandle(), cm_SetOmegaOffset,szButtonText1 );
							  bOmegaDirect = TRUE;
							  break;
  //! eingabe in Winkel-feld (omega)
	case id_RealOmega:
  //! eingabe in entspricht_Winkel-feld (omega)
	case id_IdealOmega:
               //! neue Buttonbezeichnung + berechnungsmodus setzen
							 SetDlgItemText( GetHandle(), cm_SetOmegaOffset,szButtonText2 );
							 bOmegaDirect = FALSE;
							 break;
	case cm_SetOmegaOffset:
								  GetDlgItemText( GetHandle(), id_RealOmega, buf, MaxString );
								  ValueF = atof( buf );
                  //! je nach modus fehlenden Wert berechnen
								  if (bOmegaDirect)
								  {
									 GetDlgItemText( GetHandle(), id_OmegaOffset, buf, MaxString );
									 dOmegaOffset = atof( buf );
									 dIdealOmega = ValueF + dOmegaOffset;
								  sprintf(buf,"%f",dIdealOmega);
								  SetDlgItemText(GetHandle(),id_IdealOmega,buf);
									 FORWARD_WM_COMMAND( GetHandle(), id_OmegaOffset, 0, 0, SendMessage );
								  }
								  else
								  {
									 GetDlgItemText( GetHandle(), id_IdealOmega, buf, MaxString );
									 dIdealOmega = atof( buf );
									 dOmegaOffset = dIdealOmega - ValueF;
								  sprintf(buf,"%f",dOmegaOffset);
								  SetDlgItemText(GetHandle(),id_OmegaOffset,buf);
									 FORWARD_WM_COMMAND( GetHandle(), id_RealOmega, 0, 0, SendMessage );
								  }
								  break;
  //! eingabe in Thetaoffset-feld
	case id_ThetaOffset:
                //! neue Buttonbezeichnung + berechnungsmodus setzen
							  SetDlgItemText( GetHandle(), cm_SetThetaOffset,szButtonText1 );
							  bThetaDirect = TRUE;
							 break;
  //! eingabe in Winkel-feld (theta)
	case id_RealTheta:
  //! eingabe in entspricht_Winkel-feld (theta)
	case id_IdealTheta:
                //! neue Buttonbezeichnung + berechnungsmodus setzen
							  SetDlgItemText( GetHandle(), cm_SetThetaOffset,szButtonText2 );
							  bThetaDirect = FALSE;
							 break;
	case cm_SetThetaOffset:
								  GetDlgItemText( GetHandle(), id_RealTheta, buf, MaxString );
								  ValueF = atof( buf );
                  //! je nach modus fehlenden Wert berechnen
								  if (bThetaDirect)
								  {
									 GetDlgItemText( GetHandle(), id_ThetaOffset, buf, MaxString );
									 dThetaOffset = atof( buf );
									 dIdealTheta = ValueF + dThetaOffset;
								  sprintf(buf,"%f",dIdealTheta);
								  SetDlgItemText(GetHandle(),id_IdealTheta,buf);
									 FORWARD_WM_COMMAND( GetHandle(), id_ThetaOffset, 0, 0, SendMessage );
								  }
								  else
								  {
									 GetDlgItemText( GetHandle(), id_IdealTheta, buf, MaxString );
									 dIdealTheta = atof( buf );
									 dThetaOffset = dIdealTheta - ValueF;
								  sprintf(buf,"%f",dThetaOffset);
								  SetDlgItemText(GetHandle(),id_ThetaOffset,buf);
									 FORWARD_WM_COMMAND( GetHandle(), id_RealTheta, 0, 0, SendMessage );
								  }
								  break;
	default:TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	}
};

BOOL TSetOffset::CanClose( void )
{
 //! vor verlassen des dialoges die Werte nochmal berechnen + Offsetwerte
 //! an AreaScandialog uebergeben 
 FORWARD_WM_COMMAND( GetHandle(), cm_SetOmegaOffset, 0, 0, SendMessage );
 if(!bOnlyOmega)
	{
	 FORWARD_WM_COMMAND( GetHandle(), cm_SetThetaOffset, 0, 0, SendMessage );
	 dialog->dThetaOffset = dThetaOffset;
	}
 dialog->dOmegaOffset = dOmegaOffset;
 return TRUE;
};

//! Dialogbox Datenbasis zusammensetzen
#ifdef GermanVersion
TComposeDB::TComposeDB( TAreaScan* scan ) : TModalDlg( "ComposeDatabase" )
#else
TComposeDB::TComposeDB( TAreaScan* scan ) : TModalDlg( "ComposeDatabaseEng" )
#endif
{
  //! sichern aktueller Werte fuer Dateinamen und Dateianzahl
	Areascan = scan;
	strcpy( oldFirstFile, Areascan->FirstFile );
	strcpy( oldLastFile, Areascan->LastFile );
	oldMaxFiles = Areascan->MaxFiles;
};

//#pragma argsused
//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TComposeDB::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
  char buf[ MaxString ];

  //! Eintraege in Dialogbox setzen fuer Dateinamen und Dateizahl
  SetDlgItemText( GetHandle(), cm_StartFile, oldFirstFile );
  SetDlgItemText( GetHandle(), id_LastFile, oldLastFile );
  sprintf( buf, "%d", oldMaxFiles );
  SetDlgItemText( GetHandle(), id_NumberSpectrum, buf );
  //! wenn Dateizahl 0 deaktivieren des Eingabefeldes
  if( oldMaxFiles==0 )
  EnableWindow( GetDlgItem( hwnd, id_NumberSpectrum ), FALSE );
  return TRUE;
};

//#pragma argsused
//! behandelt alle kommandos der Dialogbox
void TComposeDB::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	 HFILE hFile;
	 OFSTRUCT of;
	 char buf[ MaxString ], FileName[ MaxString ];
	 int counter = 0, oldcounter=0;
	 char drive[ _MAX_DRIVE ], path[ _MAX_DIR ], name[ _MAX_FNAME ], ext[ _MAX_EXT ];

	 switch( id )
	 {
	  //! Kommando cm_ParamSet
	  case cm_ParamSet:
	  //! Eintragen der Dialogbox-Elemente
	  break;

    //! Start-Datei-Button gedrueckt
	  case cm_StartFile:
	  strcpy( DismantleFile, "*.crv" );
#ifdef GermanVersion
	  FileOpen( "Datenbasis-File whlen", "", DismantleFile,
			Areascan->szDataPath );
#else
	  FileOpen( "Choose database-file", "", DismantleFile,
			Areascan->szDataPath );
#endif
    //! nach Auswahl des Dateinamen bestimmen der maximalen Anzahl
    //! zusammenfassbarer Spektren abhaengig von fortlaufendem Vorhandensein
    //! der entsprechenden Dateien
    //! zunaechst: Bestimmung des Dateinamens(ohne Numerierung)
	  _splitpath( DismantleFile, drive, path, name, ext );
	  counter=oldcounter=atoi( &name[ strlen( name ) - 4 ] );
	  strcpy( buf, name );
	  buf[ strlen( name )-4 ]='\0';
	  strcpy( DismantleFile, buf );
	  strcpy( oldFirstFile, name );
	  strcat( oldFirstFile, ext );
	  SetWindowText( GetDlgItem( GetHandle(), cm_StartFile ), oldFirstFile );
	  hFile = OpenFile( oldFirstFile, &of, OF_READ );
    //! fortlaufender Test auf vorhandene Dateien
	  do
	  {
		_lclose( hFile );
		strcpy( oldLastFile, name );
		strcpy(buf,"");
		sprintf( buf, "%.4d", counter++ );
		strcpy( name, DismantleFile );
		strcat( name, buf );
		_makepath( FileName, drive, path, name, ext );
		hFile = OpenFile( FileName, &of, OF_READ );
	  }
	  while( -1!=hFile );
    //! Eintragen von Dateizahl, Start- , End-Datei in Dialogbox
	  sprintf( buf, "%d", counter-oldcounter-1 );
	  strcat( oldLastFile, ext );
	  SetDlgItemText( GetHandle(), id_NumberSpectrum, buf );
	  SetDlgItemText( GetHandle(), id_LastFile, oldLastFile );
	  oldMaxFiles=counter-oldcounter-1;
	  EnableWindow( GetDlgItem( hwnd, id_NumberSpectrum ), TRUE );
	  break;

	  //! behandelt IDOK, IDCANCEL
	  default:
	  TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }
};

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
//! der Dialogbox (durch OK-Button)
//! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
//! (Werte inkonsistent) sonst true
BOOL TComposeDB::CanClose()
{
  BOOL retval=TRUE;
  char buf[ MaxString ];
  int counter;

  //! auslesen der Spektrenzahl, event. Korrektur, wenn Wert zu gross bzw. klein
  GetDlgItemText( GetHandle(), id_NumberSpectrum, buf, MaxString );
  if( atoi( buf ) != oldMaxFiles )
  {
	 if( ( atoi( buf ) > oldMaxFiles ) || ( atoi( buf ) < 1 ) )
		 sprintf( buf, "%d", oldMaxFiles );
	 else
	 {
		 oldMaxFiles = atoi( buf );
		 strcpy( buf, oldLastFile );
		 buf[ strlen( buf )-8 ]='\0';
		 strcpy( oldLastFile, buf );
		 counter=atoi( &oldFirstFile[ strlen( oldFirstFile ) - 8 ] );
		 sprintf( buf, "%.4d", counter+oldMaxFiles-1 );
		 strcat( oldLastFile, buf );
		 strcat( oldLastFile, ".crv" );
	 }
   //! setzen der neuen Eintraege
	 SetDlgItemText( GetHandle(), id_LastFile, oldLastFile );
	 sprintf( buf, "%d", oldMaxFiles );
	 SetDlgItemText( GetHandle(), id_NumberSpectrum, buf );
	 retval=FALSE;
  }
  else
  {
  //! uebergeben der neuen Werte an das AreaScan-Fenster
	Areascan->MaxFiles = oldMaxFiles;
	GetDlgItemText( GetHandle(), cm_StartFile, buf, MaxString );
	strcpy( Areascan->FirstFile, buf );
	GetDlgItemText( GetHandle(), id_LastFile, buf, MaxString );
	strcpy( Areascan->LastFile, buf );
  }
  return retval;
};


#ifdef GermanVersion
TDismantleDB::TDismantleDB( TAreaScan* scan ) : TModalDlg( "DismantleDatabase" )
#else
TDismantleDB::TDismantleDB( TAreaScan* scan ) : TModalDlg( "DismantleDatabaseEng" )
#endif
{
	//! Einlesen der Id's in Feld-Variablen zur komfortableren Nutzung
	Areascan = scan;
};

//#pragma argsused
//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TDismantleDB::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
  //! setzen des Datenpfades
  SetDlgItemText( hwnd, id_Catalog, Areascan->szDataPath );
  strcpy(DismantleFile,"");
  return TRUE;
};

//#pragma argsused
//! behandelt alle kommandos der Dialogbox
void TDismantleDB::Dlg_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
  TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
};

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
//! der Dialogbox (durch OK-Button)
//! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
//! (Werte inkonsistent) sonst true
BOOL TDismantleDB::CanClose()
{
	 char dir[ _MAX_DIR ], drv[ _MAX_DRIVE ], name[ _MAX_FNAME ], ext[ _MAX_EXT ];
	 OFSTRUCT of;
	 int hFile;
	 BOOL retval=TRUE;

	 GetDlgItemText( GetHandle(), id_Catalog, ( LPSTR ) Areascan->szDataPath,
						  MaxString );
	 //! Testen, ob sich der Pfad auch beschreiben laesst
	 if ( Areascan->szDataPath[ strlen( Areascan->szDataPath ) - 1 ] != '\\' )
		  strcat( Areascan->szDataPath, "\\" );
	 _splitpath( Areascan->szDataPath, drv, dir, name, ext );
	 _makepath( Areascan->szDataPath, drv, dir, "check", "tmp" );
	 hFile = OpenFile( Areascan->szDataPath, &of, OF_CREATE );
	 if ( -1 != hFile )
	 {
		  _lclose( hFile );
		  remove( Areascan->szDataPath );
		  _makepath( Areascan->szDataPath, drv, dir, "", "" );
	 }
	 else
	 {
		retval = FALSE;
		strcpy( Areascan->szDataPath, "c:\\" );
		SetDlgItemText( GetHandle(), id_Catalog, Areascan->szDataPath );
	 }
   //! Dateinamen auslesen und auf Laenge <5 testen
   //! sonst nur erste 4 Zeichen nehmen und Dialogbox bleibt geoeffnet
   if(retval)
   {
	  GetDlgItemText( GetHandle(), id_FileName, DismantleFile, MaxString );
	  if( strlen( DismantleFile )>4 )
	  {
	  	char buf[ MaxString ];
	  	strcpy( buf, DismantleFile );
	  	buf[4]='\0';
	  	strcpy( DismantleFile, buf );
	  	SetDlgItemText( GetHandle(), id_FileName, buf );
	  	retval =FALSE;
	  }
   }
	 return retval;
};

// LastLine
