// File m_psd.h
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung an Schichtstrukturen"
#ifndef __M_PSD_H
#define __M_PSD_H

//JP  *******************************************************************	
//JP  Dieser Abschnitt wird in einer spaeteren Version entfernt.
//JP  IO_Wait_Psd wird im gesamten Projekt nicht verwendet.
//JP  #define IO_Wait_Psd 27
//JP
//JP  Die Funktionalitaet von stoe_psd.inc wird von inem enum 
//JP  von TStoe_Psd uebernommen
//JP  #include "stoe_psd.inc"
//JP  *******************************************************************	

#if defined ( Build_Counters ) 
#define _COUNTERCLASS __declspec(dllexport)
#elif defined( Use_Counters ) 
#define _COUNTERCLASS __declspec(dllimport)
#else
#define _COUNTERCLASS
#endif


class TStoe_Psd : public TPsd
{
  public:
    TStoe_Psd(  void );
    ~TStoe_Psd(  void );
    int PollDevice(  void );
    int GetBufferSize(  void )
    { return nMaxChannel-nMinChannel+1; };
  private:
//JP  *******************************************************************	
//JP  Diese Kommentare werden in einer spaeteren Version entfernt.
//JP  IoWaitStoe war vorher ein #define in counters.cpp
//JP  Jetzt it es C++-gemaess eine Klassenkonstante
	  enum { IoWaitStoe=42 };
//JP  *******************************************************************

//JP  *******************************************************************	
//JP  Diese Kommentare werden in einer spaeteren Version entfernt.
//JP  Das folgende entspricht dem Inhalt der Datei stoe_psd.inc,
//JP  einer Datei des Herstellers, die eine Reihe von #define's enthielt
	  
	  // Der Stoe_PSD wird ueber eine 16Bit PIO kontrolliert.
	  // Zwei 8255 Chips werden parallel eingesetzt, um eine
	  // 16bit Ausgabe ueber PORTA und Eingae ueber PORTB zu realisieren.
	  // Dabei verarbeitet Chip 1 das low-byte und Chip 2 das high-byte.
	  enum {	
				PIO_BASEADR	= 0x300,
				PIO_PORTA	= 0x300,	// = PIO_BASEADR
				PIO_PORTB	= 0x302,	// = PIO_BASEADR+2
				PIO_PORTC	= 0x304,	// = PIO_BASEADR+4
				PIO_CTRL	= 0x306,	// = PIO_BASEADR+6
		
				// PORTC Bit-Definitionen zum Steuern des PSD
				PSD_STOP	= 0x000,	// CSR0 & CSR1 =0 : stop PSD
				PSD_CSR0	= 0x002,
				PSD_CSR1	= 0x004,
				PSD_NDRDY	= 0x008,	// New data ready
				PSD_DTRNS	= 0x010,	// Data transition
				PSD_INIT	= 0x020,	// Init PSD
				PSD_DVAL	= 0x100,	// Data valid
				PSD_OVF		= 0x200		// Overflow
	  };
//JP  *******************************************************************	

	BOOL bLong;
    int Initialize(  void );
    int SetParameters(  void )
    { return R_OK; };
    int PsdReadOut(  THowReadOutPsd );
    int PsdRead(  int, int, int, LPWORD );
    int PsdInit(  void );
    int PsdStart(  void );
    int PsdStop(  void );
    HGLOBAL hReadBuf;
    int nReadBufItems;
};

#endif
// __M_PSD_H
// __LastLine__
