#ifndef _SWINTRAC_H
#define _SWINTRAC_H

class  TModalDlg
{
    friend BOOL __declspec(dllexport) CALLBACK DialogProc(  HWND, UINT, WPARAM, LPARAM );
  public:
    TModalDlg(  char* DlgName );
    HWND GetHandle(  void )
    { return hWindow; };
    virtual ~TModalDlg(  void );
    virtual int ExecuteDialog(  HWND );
  protected:
    virtual BOOL Dlg_OnInit(  HWND, HWND, LPARAM );
    virtual void Dlg_OnCommand(  HWND, int, HWND, UINT );
    virtual void Dlg_OnHScrollBar(  HWND, HWND, UINT, int )
    {};
    virtual void Dlg_OnVScrollBar(  HWND, HWND, UINT, int )
    {};
    virtual void Dlg_OnTimer(  HWND, UINT )
    {};
  private:
    virtual BOOL CanClose(  void );
    virtual void Interrupt(  void )
    {};
    virtual BOOL LeaveDialog(  void )
    { return TRUE; };
    HWND hWindow;
    HINSTANCE hInstance;
    FARPROC dialogFunc;
    char RC_Name[ MaxString ];
    TModalDlg* dlgInstance;
    BOOL bCallUp;
    BOOL bCanOpen;
};

class  TModelessDlg
{
    friend BOOL __declspec(dllexport) CALLBACK ModelessProc(  HWND, UINT, WPARAM, LPARAM );
  public:
    TModelessDlg(  char* DlgName );
    virtual ~TModelessDlg(  void );
    HWND GetHandle(  void )
    { return hWindow; };
    BOOL Initialize(  void );
  protected:
    virtual BOOL Dlg_OnInit(  HWND, HWND, LPARAM );
    virtual void Dlg_OnCommand(  HWND, int, HWND, UINT );
    virtual void Dlg_OnSetFocus(  HWND, HWND )
    {};
    virtual void Dlg_OnKillFocus(  HWND, HWND )
    {};
    virtual void Dlg_OnMouseActivate(  HWND, int, HWND, UINT )
    {};
    virtual void Dlg_OnMouseMove(  HWND, int, HWND, UINT )
    {};
    virtual void Dlg_OnHScrollBar(  HWND, HWND, UINT, int )
    {};
    virtual void Dlg_OnVScrollBar(  HWND, HWND, UINT, int )
    {};
    virtual void Dlg_OnTimer(  HWND, UINT )
    {};
    virtual void Dlg_OnLButtonUp(  HWND, int, int, UINT )
    {};
    virtual int Dlg_OnMouseActivate(  HWND, HWND, UINT, UINT )
    { return 1; }
    virtual BOOL CanClose(  void );
    BOOL bCanOpen;
  private:
    virtual void Interrupt(  void )
    {};
    virtual BOOL LeaveDialog(  void )
    { return TRUE; };
    HWND hWindow;
    DLGPROC dialogFunc;
    char RC_Name[ MaxString ];
    TModelessDlg* dlgInstance;
    BOOL bCallUp;
};

class TMeasurementParam : public TModalDlg
{
 public:
       TMeasurementParam();
  BOOL CanClose( void );
  BOOL Dlg_OnInit( HWND, HWND, LPARAM );
  BOOL LeaveDialog( void ) 
      { return TRUE; };
};

class TExecuteCmd : public TModalDlg
{
 public:
       TExecuteCmd();
  BOOL Dlg_OnInit( HWND, HWND, LPARAM );
  void Dlg_OnCommand( HWND, int, HWND, UINT );
  BOOL LeaveDialog( void );
  int  ExecutionId;
  int  nMotor;
};

class TDevice;

class TAngleControl : public TModalDlg
{
 public:             
           TAngleControl();
  int      GetBarEgde( int );
  int      GetBarPos( void );
  void     Dlg_OnHScrollBar( HWND, HWND, UINT, int );
  void     Dlg_OnTimer( HWND, UINT );
  void     Dlg_OnCommand( HWND, int, HWND, UINT );
  BOOL     Dlg_OnInit( HWND, HWND, LPARAM );
  void     Interrupt( void );
  BOOL     LeaveDialog( void );
 private:
  int      AskTime;
  BOOL     bStepMode;
  BOOL     bMoveActive;
  BOOL     bLongMove;
  BOOL     bMeasureHwb;
  HWND     BarHandle;
  HWND     hMotorList;
  int      BarFactor;
  int      nMotor;
  TDevice* Sensor;
  float*   MoveSpeed;
};

class TGetData : public TModalDlg
{
 public:
       TGetData( LPSTR, int* );
 private:
  BOOL Dlg_OnInit( HWND, HWND, LPARAM );
  BOOL CanClose( void );
  int* dataref;
  char datatext[40];
};


class TPsd;

class TPsdParameters : public TModelessDlg
{
  public:
    TPsdParameters(  void );
  private:
    TPsd* Device;
    int OldId;
    BOOL Dlg_OnInit(  HWND, HWND, LPARAM );
    void Dlg_OnCommand(  HWND, int, HWND, UINT );
    BOOL CanClose(  void );
    BOOL LeaveDialog(  void );
};


class TCounterWindow : public TMDIWindow
{
//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  Ich habe bei allen Funktionen, die im Klassendefinitionskoerper
//JP  vollstaendig definiert werden, das Schluesselwort inline
//JP  entfernt, da diese Funktionen ohnehin implizit inline sind.
//JP  *****************************************************************
	
	friend class TCounterShowParam;
  public:
    TCounterWindow( int DeviceId );
    ~TCounterWindow( );
    void Create( HWND hwnd );
    HCURSOR GetCursor( void ) { return LoadCursor( NULL, IDC_ARROW ); };
    BOOL bShowAsDigital;
    void SetupLogging( void );
  protected:
    BOOL bWriteLogFile;
    TScaleType eScaleType;
    float fMaxIntensity;
    TDevice* Sensor;
    void CounterSetRequest( LPARAM );
    void Size( HWND, WPARAM, LPARAM );
    void rButtonDown( LPARAM );
    void SetFocus( void );
    BOOL CanOpen( void );
    void lButtonDown( WPARAM, LPARAM );
    void Paint( HDC, PAINTSTRUCT * );
  private:
    BOOL bQuiteOpen;
    HGLOBAL hMemG;
#if defined( __FLAT__ ) 
    float *IField;
#else
    float _huge *IField;
#endif
    float fData;
    int nIdx;
    int nMaxBarIdx;
    HPEN hPen;
    HBRUSH hBrushWhite, hBrushBlack, hBrushRed, hBrushOC;
    float fThickness, fHight;
    BOOL SetTitle( void );
    BOOL bAnalogSwitchOn;
    BOOL bWindowWillBeOpen;
    LPCSTR ClassName() { return "MDevice"; };
    LPCSTR GetCharacteristic( void ) { return "Device"; };
};

class TCounterShowParam : public TModalDlg
{
//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  Ich habe bei allen Funktionen, die im Klassendefinitionskoerper
//JP  vollstaendig definiert werden, das Schluesselwort inline
//JP  entfernt, da diese Funktionen ohnehin implizit inline sind.
//JP  *****************************************************************

  public:
    TCounterShowParam( TCounterWindow* );
  private:
    TCounterWindow* CounterWnd;
    BOOL CanClose( void );
    BOOL Dlg_OnInit( HWND, HWND, LPARAM );
    BOOL LeaveDialog( void ) { return TRUE; };
};




#endif
// __LastLine__
