
%{
#include <limits.h>
#include <malloc.h> // alloca
#include <string.h>
#include "cmd.h"
#include "mc_812.h"

#define YYPARSE_PARAM yyparam1, yyparam2, yyparam3, yyparam4
#define YYPARSE_PARAM_DECL char* yyparam1, int yyparam2, int* yyparam3, int yyparam4
#define YYLEX_PARAM yyparam1, yyparam2, yyparam3, yyparam4

extern yylex(YYPARSE_PARAM_DECL);

static MC_812* theMC;
static int cmd_count;

static void yyerror (char*)
{
  theMC -> Error(0, 0, LONG_MAX);
}

%}

//%pure_parser

%union {
	long long_val;
	int  int_val;
}

%token <int_val>  AXIS
%token <long_val> PARAM
%token <int_val>  CMD
%token <int_val>  CMDEND
%token <int_val>  SEQEND
%token <int_val>  PERROR

%type  <int_val>  END;



%%


cmds : cmd | cmd cmds ;

cmd  : cmd_1 | cmd_2 | cmd_3 | cmd_4 | error END;

END : CMDEND | SEQEND ;

cmd_1 :  AXIS CMD PARAM END {

	switch ($2) {
		case CMD_FE: case CMD_MA: case CMD_MR:
		case CMD_DB: case CMD_LS:
		case CMD_SA: case CMD_SD: case CMD_SN:
		case CMD_SG: case CMD_SE:
		case CMD_SO:
		case CMD_SP: case CMD_SQ: case CMD_SV:
			theMC -> Execute($2, $1, $3);
			break;
		default:
			theMC -> Error($2, $1, $3);
			//return -1;
	}

	cmd_count++;

	if ($4 == SEQEND) {
		theMC -> EndCmdSeq(cmd_count);
	}
}

cmd_2 :  CMD PARAM END {

	switch ($1) {
		case CMD_FE: case CMD_MI: case CMD_MP:
		case CMD_BR: case CMD_CF: case CMD_CI:
		case CMD_CN: case CMD_CT: case CMD_IA:
		case CMD_LS: case CMD_SA: case CMD_SD:
		case CMD_SN: case CMD_SG: case CMD_SE:
		case CMD_SO: case CMD_SP: case CMD_SQ:
		case CMD_SV:
		case CMD_HE:
		case CMD_TA: case CMD_TC: case CMD_TM:
			theMC -> Execute($1, 0, $2);
			break;
		default:
			theMC -> Error($1, 0, $2);
			//return -1;
	}

	cmd_count++;

	if ($3 == SEQEND) {
		theMC -> EndCmdSeq(cmd_count);
	}
}

cmd_3 :  AXIS CMD END {

	switch ($2) {
		case CMD_AB: case CMD_CP: case CMD_GH:
		case CMD_GO: case CMD_MF: case CMD_MN:
		case CMD_ST:
		case CMD_DH: case CMD_SF:
		case CMD_TE: case CMD_TF: case CMD_TG:
		case CMD_TO: case CMD_TP: case CMD_TQ:
		case CMD_TS: case CMD_TT: case CMD_TV:
		case CMD_TY:
			theMC -> Execute($2, $1, LONG_MAX);
			break;
		default:
			theMC -> Error($2, $1, LONG_MAX);
			//return -1;
	}

	cmd_count++;

	if ($3 == SEQEND) {
		theMC -> EndCmdSeq(cmd_count);
	}
}

cmd_4 :  CMD END {

	switch ($1) {
		case CMD_AB: case CMD_CP: case CMD_GH:
		case CMD_GO: case CMD_MF: case CMD_MN:
		case CMD_ST:
		case CMD_DH: case CMD_EN: case CMD_EF:
		case CMD_RT: case CMD_SF:
		case CMD_DM: case CMD_HM:
		case CMD_CS:
		case CMD_TA: case CMD_TC:
		case CMD_TE: case CMD_TF: case CMD_TG:
		case CMD_TM: case CMD_TO: case CMD_TI:
		case CMD_TP: case CMD_TQ: case CMD_TS:
		case CMD_TT: case CMD_TV: case CMD_TY:
		case CMD_VE:
			theMC -> Execute($1, 0, LONG_MAX);
			break;
		default:
			theMC -> Error($1, 0, LONG_MAX);
			//return -1;
	}

	cmd_count++;

	if ($2 == SEQEND) {
		theMC -> EndCmdSeq(cmd_count);
	}
}



%%

void parse_command_string(char* buffer, MC_812* mc, int mode)
{
	cmd_count = 0;

	theMC = mc;
	int x = 0;
	yyparse(buffer, strlen(buffer), &x, mode);
	theMC = 0;
}
